# ConfigureProgram -*- TCL -*-
#----------------------Configuration section-----------------------------

#::GidPriv(Configuration) must be release or debug
#set ::GidPriv(Configuration) debug
set ::GidPriv(Configuration) release


# to create a splash window
set ::GidPriv(SplashWindow) [file join $GIDDEFAULT bitmaps GiDsplash.gif]

# Image that appears in the about window
set ::GidPriv(AboutWindow) [file join $GIDDEFAULT bitmaps about.gif]

# use of mouse button changes
# 0 old_bindings , 1 new_bindings
set ::GidPriv(ChangeButtonMeaning) 1


# A contextual button is added to GiD
#set ::GidPriv(havecontextualbutton) 1

# name of the game
set ::GidPriv(ProgName,Default) GiD
set ::GidPriv(Organization,Default) "CIMNE - International Center for Numerical Methods in Engineering"

# web page of the program
set ::GidPriv(ProgWeb,Default) "http://www.gidhome.com"
# web page to obtain a password to register the program
set ::GidPriv(PassWeb,Default) "http://www.gidhome.com/password"


# check proc 'CreateWelcomeWin' in file tclfileP.tcl

# Icons to check (in directory bitmaps):
#                    GiDlogo.ppm    (the one that appears in the printed copies)
#                    GiDicono64.xbm (only for UNIX. The image of GiD iconified)
#                    GiDicono.xbm   (the one seen in the GiD page setup)
#                    GiDdirectory.gif (the one in the project file browser and register Problem type window)
#                    GiDdirectory_h.gif (the one in the project file browser for hidden directories)
#                    gid.ico        (for Windows it is the icon application)
#                                   (The Windows installer uses this icon to
#                                    put it in the desktop)
#                    info_gid_a.gif  (seen in the toolbar to show evaluation version)
#                    info_gid_p.gif                               professional
#                    info_gid_t.gif                               temporal
#                    GiDsplash.gif  (initial splash window)
#                    about.gif      (image that appears in the about window)

set ::GidPriv(BitmapsWidth)    24
set ::GidPriv(BitmapsHeight)   24
set ::GidPriv(BitmapsSepHWidth)  24
set ::GidPriv(BitmapsSepHHeight)  8
set ::GidPriv(BitmapsSepVWidth)   8
set ::GidPriv(BitmapsSepVHeight) 24

set ::GidPriv(GiDRuedas)       1
set ::GidPriv(Texturas)        1

#to change in the help->About, the showed internal GiD version number
#for another alternative text version of a particular developer
#(e.g set ::GidPriv(TextOfVersion) "MyProgram 4.0" )
set ::GidPriv(TextOfVersion,Default) ""

#To customize the info icon of right of the standard bar and the procedure to invoke
set ::GidPriv(InfoGiDBitmapName) "info_gid.gif"
# info_gid.gif - default info icon
# info_gid_a.gif - info icon for the evaluation version (GiD will add the '_a' suffix)
# info_gid_p.gif - info icon for the professional version (GiD will add the '_p' suffix)
set ::GidPriv(InfoGiDProc) "CreateGiDInfo_win"

#To customize some widget colors
set ::GidPriv(Color,BackgroundListbox) {white smoke}
set ::GidPriv(Color,DisabledBackgroundEntry) {white smoke}
set ::GidPriv(Color,DisabledForegroundEntry) {black}
set ::GidPriv(Color,DisabledForegroundMenu) {grey60}
set ::GidPriv(Color,BackgroundFileDialog) {white}

#can be: none, brown
set ::GidPriv(Color,Linux) none

#to customize the default extension of the calculation file, for example ".nas" for Nastran
set ::GidPriv(CalculationFileExtension,Default) ".dat"

if { ( $tcl_platform(platform) == "windows") || ( $tcl_platform(os) == "Darwin") } {
    set ::GidPriv(MenuType) "native"
    #set ::GidPriv(MenuType) "generic"
} else {
    set ::GidPriv(MenuType) "generic"
}

#variable to hide volume level menus, tools
set ::GidPriv(HideVolumeLevel) 0
 

#if a procedure 'configure_program_proc' exists, it will be executed as the last step
#can be implemented to do some special initialization. Its prototype is:
#proc configure_program_proc { } { ...body... }


#----------------------End configuration section-------------------------


#---------------------- Info section -------------------------
# tcl functions related to internal GiD version number
# format: n1.n2[.n3][char] (e.g: 9.1.2d or 9.2 are valid)
# This version number is used to compare is a version is more recent to another

# proc GiDVersionCmp { Version }
# return -1 if Internal GiD Version < Version
# return  0 if Internal GiD Version == Version
# return  1 if Internal GiD Version > Version
# Internal GiD Version must be asked with [GiD_Info GiDVersion]

# proc GiDVersionNumber { VersionString } convert the string to an integer
# (e.g. "9.1.2d" return 901020)

# proc GiDVersionSubchar { VersionString } return the char if exist
# (e.g. "9.1.2d" return d)

#----------------------End Info section -------------------------

#to debug whitout open a window
if { $::GidPriv(Configuration) == "debug" } {
    if {$tcl_platform(platform) == "unix"} {
	set tmpdir /tmp
    } else {
	set tmpdir $env(tmp)
    }
    set ::GidPriv(SetDebugFileName) [file join $tmpdir DebugGiDTcl.log]
}
set ::GidPriv(DebugInitialized) 0

proc ConfigureProgramSetVariablesDefault { } {
    foreach item {ProgName Organization ProgWeb PassWeb TextOfVersion CalculationFileExtension} {
	set ::GidPriv($item) $::GidPriv($item,Default)
    }
}

ConfigureProgramSetVariablesDefault
