proc EditNURBS { LineOrSurface } {
    # tk_messageBox -message "vaL=$LineOrSurface " -type ok
    global GidPriv
    set w .gid.nurbsurfmove
    set GidPriv(FixBoundary) 1
    set GidPriv(Decrement) 0.4
    set GidPriv(LastDecrement) 0.4
    set GidPriv(FixBoundary) 1
    if { ![info exists GidPriv(EdNURBStolerance)] } {
	set GidPriv(EdNURBStolerance) [_ "Automatic"]
    } elseif {$GidPriv(EdNURBStolerance)==-1.0} {
	set GidPriv(EdNURBStolerance) [_ "Automatic"]
    }

    set entitytypename [_ $LineOrSurface]
    InitWindow $w [_ "Edit NURBS %s" $entitytypename] EditNURBSWindowGeom
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
    ttk::frame $w.frmMovement -padding 5
    ttk::label $w.lblNumEntity -text [_ "unselected"]
    ttk::label $w.frmMovement.lblMoveType -text [_ "Movement type"] -padding 5
    
    if { ![info exists GidPriv(Movement)] } {
	set GidPriv(Movement) MoveScreen
    }

    #tile combobox to substitude ComboBoxRAM

    #if { $LineOrSurface == "surface" } {
    #	set labels [list [_ "Screen"] [_ "Normal"] [_ "Point"] [_ "X-Axis"] [_ "Y-Axis"] [_ "Z-Axis"]]
    #	set commands { MoveScreen MoveNormal MoveToPoint MoveXAxis MoveYAxis MoveZAxis }
    #} else {
    #	set labels [list [_ "Screen"] [_ "Point"] [_ "X-Axis"] [_ "Y-Axis"] [_ "Z-Axis"]]
    #	set commands { MoveScreen MoveToPoint MoveXAxis MoveYAxis MoveZAxis }
    #}
    #ComboBoxRAM $w.frmMovement.mnuMovement GidPriv(Movement) $labels $commands


    if { [string equal -nocase "$LineOrSurface" "surface"] } {
	set labels [list [_ "Screen"] [_ "Normal"] [_ "Point"] [_ "X-Axis"] [_ "Y-Axis"] [_ "Z-Axis"]]

        ttk::combobox $w.frmMovement.mnuMovement -values $labels -state readonly

        bind .gid.nurbsurfmove.frmMovement.mnuMovement <<ComboboxSelected>> {
          global GidPriv
 	  set commands { MoveScreen MoveNormal MoveToPoint MoveXAxis MoveYAxis MoveZAxis }
       	  set GidPriv(Movement) [lindex $commands [.gid.nurbsurfmove.frmMovement.mnuMovement current]]
    	}

	#Default value blank without any option selected
    	#To select an option can be use:
    	set indexcombobox 0

    	$w.frmMovement.mnuMovement current $indexcombobox

    	#Be careful, the binding hasn't been executed so:

    	set commands { MoveScreen MoveNormal MoveToPoint MoveXAxis MoveYAxis MoveZAxis }
       	set GidPriv(Movement) [lindex $commands $indexcombobox]   
    
       	# #To write something in combobox use
    	# 
    	# $w.frmMovement.mnuMovement set "Select a Value"

    } else {
	set labels [list [_ "Screen"] [_ "Point"] [_ "X-Axis"] [_ "Y-Axis"] [_ "Z-Axis"]]

        ttk::combobox $w.frmMovement.mnuMovement -values $labels -state readonly

        bind .gid.nurbsurfmove.frmMovement.mnuMovement <<ComboboxSelected>> {
          global GidPriv
	  set commands { MoveScreen MoveToPoint MoveXAxis MoveYAxis MoveZAxis }
          set GidPriv(Movement) [lindex $commands [.gid.nurbsurfmove.frmMovement.mnuMovement current]]
	}

	set indexcombobox 0

    	$w.frmMovement.mnuMovement current $indexcombobox

  	set commands { MoveScreen MoveToPoint MoveXAxis MoveYAxis MoveZAxis }
        set GidPriv(Movement) [lindex $commands $indexcombobox]
    
    }    
    
    
    

    #end ComboBoxRAM


    GidHelp "$w.frmMovement.mnuMovement" \
	[_ "User can choose the mode of select points dinamically."]
    

    ##################scale tile

    ttk::frame $w.frmDecrement -borderwidth 2 -relief ridge
    
    ttk::button $w.buttonMinus -text - -width 3
    
    set scl [ttk::frame $w.sclDecrement -relief solid -borderwidth 2 -padding 2]
    
    ttk::label $scl.label -text [_ "Influence factor"]
    ttk::scale $scl.bar -from 0 -to 1 -orient horizontal -variable GidPriv(Decrement) -command DecrementMoving
    ttk::label $scl.text -textvariable GidPriv(Decrement)
    grid $scl -row 2 -column 0 -padx 1 -pady 1 -sticky ew
    grid $scl.label -in $scl -row 1 -column 1 -sticky ew
    grid $scl.bar -in $scl -row 2 -column 1 -sticky ew
    grid $scl.text -in $scl -row 3 -column 1 -sticky ew
    grid columnconfigure $scl 1 -weight 1
    grid rowconfigure $scl 1 -weight 1   

    ttk::button $w.buttonPlus -text + -width 3
	    
    proc DecrementMoving { val } {
	global GidPriv
	set GidPriv(Decrement) [format "%.2f" $val]
	if { $GidPriv(Decrement) != $GidPriv(LastDecrement) } {
	    set GidPriv(LastDecrement) $GidPriv(Decrement)
	    GiD_Process Decrement=$GidPriv(Decrement)
	}
    }
    set GidPriv(auxvar) $w.sclDecrement.bar

    $w.buttonMinus conf -command { $GidPriv(auxvar) set \
	    [expr $GidPriv(Decrement)-0.05] }

    $w.buttonPlus conf -command { $GidPriv(auxvar) set \
	    [expr $GidPriv(Decrement)+0.05] }

    #after idle [$w.sclDecrement.bar conf  -command DecrementMoving]


    #coments scale:
    #for disable use: $w.sclDecrement.bar state disabled
    #for enable use:  $w.sclDecrement.bar state !disabled
    ##################end scale tile   
    
    GidHelp "$w.sclDecrement" \
	[_ "Value 0 only move the control point\n value 1 move all control points."]

    

    ttk::frame $w.frmFixBoundary 
    ttk::checkbutton $w.chkFixBoundary -text [_ "Fix boundary"] \
	    -variable GidPriv(FixBoundary) \
	    -command SetBoundary
    
    proc SetBoundary { } {
	global GidPriv
	if { $GidPriv(FixBoundary) } {
	    GiD_Process FixBoundary
	} else {
	    GiD_Process FreeBoundary
	}
    }
    
    GidHelp "$w.chkFixBoundary" \
	[_ "Fix or free the boundary control points."]
    
    
    ttk::frame $w.frmLineSpecific -padding 5
    ttk::frame $w.frmSurfaceSpecific -padding 5
    ttk::button $w.btnInsertKnot -text [_ "Insert knot"] -command "GiD_Process InsertKnot" \
	     -width 16
    ttk::button $w.btnDegreeElevate -text [_ "Elevate degree"] -command "GiD_Process DegreeElevate" \
	     -width 16
    ttk::button $w.btnDegreeReduce -text [_ "Reduce degree"] -command "SendTolAnd DegreeReduce" \
	     -width 16
    
    ttk::button $w.btnWeightChange -text [_ "Change weight"] -command "GiD_Process WeightChange" \
	     -width 16
    ttk::button $w.btnCancelWeights -text [_ "Cancel weights"] -command "GiD_Process CancelWeights" \
	     -width 16

    ttk::button $w.btnReparametrize -text [_ "Reparametrize"] -command "GiD_Process Reparametrize" \
	     -width 16
    ttk::button $w.btnSimilarCubic -text [_ "Similar Cubic"] -command "SendTolAnd SimilarCubic" \
	     -width 16

    ttk::button $w.btnInsertUKnot -text [_ "Insert U knot"] -command "GiD_Process InsertUKnot" \
	     -width 16
    ttk::button $w.btnInsertVKnot -text [_ "Insert V knot"] -command "GiD_Process InsertVKnot" \
	     -width 16
    ttk::button $w.btnDegreeUElevate -text [_ "Elevate U degree"] -command "GiD_Process DegreeUElevate" \
	     -width 16
    ttk::button $w.btnDegreeVElevate -text [_ "Elevate V degree"] -command "GiD_Process DegreeVElevate" \
	     -width 16
    ttk::button $w.btnDegreeUReduce -text [_ "Reduce U degree"] -command "SendTolAnd DegreeUReduce " \
	     -width 16
    ttk::button $w.btnDegreeVReduce -text [_ "Reduce V degree"] -command "SendTolAnd DegreeVReduce" \
	     -width 16

    ttk::button $w.btnKnotRemoval -text [_ "Knot Removal"] -command "SendTolAnd KnotRemoval" \
	     -width 16
    ttk::button $w.btnUKnotRemoval -text [_ "Knot Removal in U"] -command "SendTolAnd UKnotRemoval" \
	     -width 16
    ttk::button $w.btnVKnotRemoval -text [_ "Knot Removal in V"] -command "SendTolAnd VKnotRemoval" \
	     -width 16

    ttk::label $w.labeltol -text [_ "Tolerance"]: -width 16
    ttk::entry $w.entrytol -textvariable GidPriv(EdNURBStolerance) -width 16

    ttk::frame $w.blankframe
    ttk::frame $w.frmButtons -style LightBackground.TFrame -padding 5

    ttk::button $w.frmButtons.btnApply -text [_ "Apply"] \
	-command "GiD_Process escape" -underline 0

    ttk::button $w.frmButtons.btnSelect -text [_ "Pick"] \
	-command [list EditNURBSSelEntity $w $LineOrSurface] -underline 0
   
    ttk::button $w.frmButtons.btnclose -text [_ "Close"] \
	-command [list EditNURBSClose $w $LineOrSurface] -underline 0

   # SetWidgetsWidthFromText $w.frmButtons.btnApply $w.frmButtons.btnSelect $w.frmButtons.btnclose

    grid $w.frmMovement -row 1 -column 1 -sticky ewns
    grid $w.frmMovement.lblMoveType -row 1 -column 1 -sticky ewns
    grid $w.frmMovement.mnuMovement -row 1 -column 2 -sticky ewns

    grid $w.frmDecrement -row 2 -column 1 -sticky ewns
    grid $w.buttonMinus -in $w.frmDecrement -row 1 -column 1
    grid $w.sclDecrement -in $w.frmDecrement -row 1 -column 2 -sticky ew
    grid $w.buttonPlus -in $w.frmDecrement -row 1 -column 3
    grid columnconfigure $w.frmDecrement 1 -weight 0
    grid columnconfigure $w.frmDecrement 2 -weight 1
    grid columnconfigure $w.frmDecrement 3 -weight 0

    grid $w.frmFixBoundary -row 3 -column 1 -sticky news
    grid $w.chkFixBoundary -in $w.frmFixBoundary -row 1 -column 1 -sticky news
    grid $w.sclDecrement.bar -in $w.sclDecrement -row 2 -column 1 -sticky ew

    if { [string equal -nocase "$LineOrSurface" "surface"] } {
	grid $w.frmSurfaceSpecific -row 4 -column 1  -sticky news
	grid $w.btnInsertUKnot -in $w.frmSurfaceSpecific -row 1 -column 1 -sticky new -padx 1 -pady 1
	grid $w.btnUKnotRemoval -in $w.frmSurfaceSpecific -row 1 -column 2 -sticky new -padx 1 -pady 1
	grid $w.btnInsertVKnot -in $w.frmSurfaceSpecific -row 2 -column 1 -sticky new -padx 1 -pady 1
	grid $w.btnVKnotRemoval -in $w.frmSurfaceSpecific -row 2 -column 2 -sticky new -padx 1 -pady 1
	grid $w.btnDegreeUElevate -in $w.frmSurfaceSpecific -row 3 -column 1 -sticky new -padx 1 -pady 1
	grid $w.btnDegreeUReduce -in $w.frmSurfaceSpecific -row 3 -column 2 -sticky new -padx 1 -pady 1
	grid $w.btnDegreeVElevate -in $w.frmSurfaceSpecific -row 4 -column 1 -sticky new -padx 1 -pady 1
	grid $w.btnDegreeVReduce -in $w.frmSurfaceSpecific -row 4 -column 2 -sticky new -padx 1 -pady 1
	grid $w.btnWeightChange -in $w.frmSurfaceSpecific -row 5 -column 1 -sticky new -padx 1 -pady 1
	grid $w.btnCancelWeights -in $w.frmSurfaceSpecific -row 5 -column 2 -sticky new -padx 1 -pady 1
	grid $w.btnReparametrize -in $w.frmSurfaceSpecific -row 6 -column 1 -sticky new -padx 1 -pady 1
	grid $w.btnSimilarCubic -in $w.frmSurfaceSpecific -row 6 -column 2 -sticky new -padx 1 -pady 1
	grid $w.labeltol -in $w.frmSurfaceSpecific -row 7 -column 1 -sticky new -padx 1 -pady 1
	grid $w.entrytol -in $w.frmSurfaceSpecific -row 7 -column 2 -sticky new -padx 1 -pady 1
    } else {
	grid $w.frmLineSpecific -row 4 -column 1  -sticky ewns
	grid $w.btnInsertKnot -in $w.frmLineSpecific -row 1 -column 1 -sticky new -padx 1 -pady 1
	grid $w.btnKnotRemoval -in $w.frmLineSpecific -row 1 -column 2 -sticky new -padx 1 -pady 1
	grid $w.btnDegreeElevate -in $w.frmLineSpecific -row 2 -column 1 -sticky new -padx 1 -pady 1
	grid $w.btnDegreeReduce -in $w.frmLineSpecific -row 2 -column 2 -sticky new -padx 1 -pady 1
	grid $w.btnWeightChange -in $w.frmLineSpecific -row 3 -column 1 -sticky new -padx 1 -pady 1
	grid $w.btnCancelWeights -in $w.frmLineSpecific -row 3 -column 2 -sticky new -padx 1 -pady 1
	grid $w.btnReparametrize -in $w.frmLineSpecific -row 4 -column 1 -sticky new -padx 1 -pady 1
	grid $w.btnSimilarCubic -in $w.frmLineSpecific -row 4 -column 2 -sticky new -padx 1 -pady 1
	grid $w.labeltol -in $w.frmLineSpecific -row 5 -column 1 -sticky new -padx 1 -pady 1
	grid $w.entrytol -in $w.frmLineSpecific -row 5 -column 2 -sticky new -padx 1 -pady 1
    }

    grid $w.blankframe -row 5 -column 1 -sticky news

    grid $w.frmButtons.btnApply -row 1 -column 1 \
 -padx 5 -pady 6
    grid $w.frmButtons.btnSelect -row 1 -column 2 \
-padx 5 -pady 6
    grid $w.frmButtons.btnclose -row 1 -column 3 \
 -padx 5 -pady 6
    grid $w.frmButtons -row 6 -column 1  -columnspan 7 -sticky ews


   
    grid $w.frmButtons.btnApply -row 1 -column 1 -padx 5 -pady 6
    grid $w.frmButtons.btnSelect -row 1 -column 2 -padx 5 -pady 6
    grid $w.frmButtons.btnclose -row 1 -column 3 -padx 5 -pady 6
    grid $w.frmButtons -row 5 -column 1  -sticky ews -columnspan 7
    if { $::tcl_version >= 8.5 } { grid anchor $w.frmButtons center }


    # Resize behavior management
    grid columnconf $w 1 -minsize 80 -weight 1

    grid rowconfigure $w 1 -weight 0
    grid rowconfigure $w 2 -weight 0
    grid rowconfigure $w 3 -weight 0
    grid rowconfigure $w 4 -weight 0
    grid rowconfigure $w 5 -weight 1
    grid rowconfigure $w 6 -weight 0


    # grid $w.lblNumEntity -row 5 -column 1
    
    #set GidPriv(auxvar) $w.sclDecrement.bar
    #$w.buttonMinus conf -command { $GidPriv(auxvar) set \
#	    [expr $GidPriv(Decrement)-0.05] }

    #$w.buttonPlus conf -command { $GidPriv(auxvar) set \
#	    [expr $GidPriv(Decrement)+0.05] }

    #after idle [$w.sclDecrement.bar conf -command DecrementMoving]

    EnabledDisabled $w $LineOrSurface disabled

    focus $w.frmButtons.btnSelect

    bind $w <Alt-s> "tkButtonInvoke $w.frmButtons.btnSelect"
    bind $w <Alt-c> "tkButtonInvoke $w.frmButtons.btnclose"
    bind $w <Escape> "tkButtonInvoke $w.frmButtons.btnclose"
    bind $w <Return> "tkButtonInvoke $w.frmButtons.btnApply"

    bind $w <Destroy> [list +DestroyEditNURBS %W $w]
    trace add variable GidPriv(Movement) write "EditNurbsChangeMovement ;#"
}

proc EditNURBSCancelPick { w LineOrSurface } {
    GiD_Process escape escape escape escape
    $w.frmButtons.btnSelect conf -command [list EditNURBSSelEntity $w $LineOrSurface] -text [_ "Pick"]
    # SetWidgetsWidthFromText $w.frmButtons.btnSelect
}

proc EditNURBSClose { w LineOrSurface } {
  if { [string equal -nocase "$LineOrSurface" "surface"] } {
    GiD_Process escape escape escape escape Geometry Edit EdNurbsSurf Close
  } else { 
    GiD_Process escape escape escape escape Geometry Edit EdNurbsLine Close
  }
  destroy $w
}

proc EditNURBSSelEntity { w LineOrSurface } {
    global GidPriv

    if { [trace vinfo GidPriv(selection)] != "" } { return }
    $w.lblNumEntity conf -text [_ "unselected"]
    
    
    if { [string equal -nocase "$LineOrSurface" "surface"] } {
	GiD_Process escape escape escape escape SelectEntities JustOne Surfaces
    } else { 
	GiD_Process escape escape escape escape SelectEntities JustOne Lines
    }
    $w.frmButtons.btnSelect conf -command [list EditNURBSCancelPick $w $LineOrSurface] \
	-text [_ "Cancel"] 
    trace var GidPriv(selection) w "EditNURBSEndSelEntity $w $LineOrSurface ;#"
}

proc EditNURBSEndSelEntity { w LineOrSurface } {
    global GidPriv

    $w.frmButtons.btnSelect conf -command "cmdbreak $w $LineOrSurface" -text [_ "Cancel"]

    proc cmdbreak { w LineOrSurface } {
	GiD_Process Break
	$w.frmButtons.btnSelect conf -command [list EditNURBSSelEntity $w $LineOrSurface] -text [_ "Pick"]
    } 


    foreach i [trace vinfo GidPriv(selection)] {
	trace vdelete GidPriv(selection) [lindex $i 0] [lindex $i 1]
    }

    set num [lindex [lindex $GidPriv(selection) 0] 1]
    set nnum ""
    regexp {[0-9]*} $num nnum
    if { $nnum == "" } { return }
    # if { $nnum != "" } {
    #        $w.lblNumEntity conf -text $nnum
    #        raise $w
    # }
    set entitytypename [_ $LineOrSurface]
    wm title $w [_ "Edit NURBS %s %d" $entitytypename $nnum]

    set GidPriv(selection) ""

    EnabledDisabled $w $LineOrSurface normal
    if { [string equal -nocase "$LineOrSurface" "surface"] } {
	GiD_Process escape escape escape escape geometry edit EdNurbsSurf $nnum
    } else {
	GiD_Process escape escape escape escape geometry edit EdNurbsLine $nnum
    }
    after idle [list delayedop changefunc "EnabledDisabled $w $LineOrSurface disabled"]
}

proc EnabledDisabled { w LineOrSurface stat } {
    $w.frmMovement.mnuMovement conf -state $stat
    #$w.sclDecrement conf -state $stat
    if { $stat == "disabled" } {	
	set entitytypename [_ "%s" $LineOrSurface]
	wm title $w [_ "Edit NURBS %s" $entitytypename]
	$w.frmButtons.btnSelect conf -command [list EditNURBSSelEntity $w $LineOrSurface] -text [_ "Pick"]
	#$w.sclDecrement conf -fg grey60
	$w.sclDecrement.bar state disabled       
    } else {
	$w.sclDecrement.bar state !disabled
    }
    $w.sclDecrement.text conf -state $stat
    $w.buttonMinus conf -state $stat
    $w.buttonPlus conf -state $stat
    $w.chkFixBoundary conf -state $stat
    
    if { [string equal -nocase "$LineOrSurface" "surface"] } {
	#RecursiveChangeState $w.frmSurfaceSpecific $stat
	$w.btnInsertUKnot conf -state $stat
	$w.btnInsertVKnot conf -state $stat
	$w.btnUKnotRemoval conf -state $stat
	$w.btnVKnotRemoval conf -state $stat
	$w.btnDegreeUElevate conf -state $stat
	$w.btnDegreeVElevate conf -state $stat
	$w.btnDegreeUReduce conf -state $stat
	$w.btnDegreeVReduce conf -state $stat
	$w.btnWeightChange conf -state $stat
	$w.btnCancelWeights conf -state $stat
	$w.btnReparametrize conf -state $stat
	$w.btnSimilarCubic conf -state $stat
	$w.labeltol conf -state $stat
    } else {
	#RecursiveChangeState $w.frmLineSpecific $stat
	$w.btnInsertKnot conf -state $stat
	$w.btnKnotRemoval conf -state $stat
	$w.btnDegreeElevate conf -state $stat
	$w.btnDegreeReduce conf -state $stat
	$w.btnWeightChange conf -state $stat
	$w.btnCancelWeights conf -state $stat
	$w.btnReparametrize conf -state $stat
	$w.btnSimilarCubic conf -state $stat
	$w.labeltol conf -state $stat
    }    
    $w.frmButtons.btnApply conf -state $stat
}

proc DestroyEditNURBS { W w } {
    if { $W != $w } return
    global GidPriv
    trace remove variable GidPriv(Movement) write "EditNurbsChangeMovement ;#"
}

proc EditNurbsChangeMovement { } {
    global GidPriv
    if { ![info exists GidPriv(Movement)] } {
	set GidPriv(Movement) MoveScreen
    }
    GiD_Process $GidPriv(Movement)
}
proc SendTolAnd { value } {
    global GidPriv
    if { $GidPriv(EdNURBStolerance)==[_ "Automatic"] } {
	GiD_Process Tolerance 0.0 $value
    } else {
	GiD_Process Tolerance $GidPriv(EdNURBStolerance) $value
    }
}