#!/bin/sh
#PostDisplay -*- TCL -*- Created: miguel Jan-1997

set ::_Debug_PostAnim 0

proc DebugPostAnim { txt} {
    if { $::_Debug_PostAnim} {
	#WarnWinText "$txt"
	set fo [ open "/temp/bb.bb" a+]
	puts $fo $txt\n
	close $fo
    }
}

namespace eval AnimacionEstatica {
    variable _wid
    variable _tipo
    variable _pasos
    variable _imagenes
}

proc AnimacionEstatica::Cerrar { } {
    variable _wid

    if { ![info exists _wid] || ![ winfo exists $_wid] } { return}
    destroy $_wid
}

proc AnimacionEstatica::CambiaTipo { que} {
    variable _tipo

    set _tipo $que
}

proc AnimacionEstatica::Aceptar { } {
    variable _wid
    variable _tipo
    variable _pasos
    global AnimacionEstatica

    set res [ scan $_pasos %d pp]
    if { ( $res != 1) || ( $_pasos <= 1)} {
	WarnWin [_ "Number of steps for the animation should be > 1, and not '%s'" $_pasos] $_wid
    } else {
	set AnimacionEstatica(tipo) $_tipo
	set AnimacionEstatica(pasos) $_pasos
	AnimacionEstatica::Cerrar
    }
}

proc AnimacionEstatica::Crear { parent_w} {
    variable _wid
    variable _tipo
    variable _pasos
    variable _imagenes
    global AnimacionEstatica GIDDEFAULT
    set _tipo $AnimacionEstatica(tipo)
    set _pasos $AnimacionEstatica(pasos)

    if { "$parent_w" == "."} {
	set _wid .__w_Animacion_estatica
    } else {
	set _wid $parent_w.__w_Animacion_estatica
    }

    toplevel $_wid

    wm title $_wid [_ "Creating animation of static analysis"]

    set def_back [ $parent_w cget -background]
    set realzado [ CCColorActivo $def_back]

    frame $_wid.f -bd 0

    foreach ti "Lineal Cosine Triangular Sinusoidal" {
	if { ![ info exists _imagenes($ti)]} {
	    set _imagenes($ti) [image create bitmap -file [ file join $GIDDEFAULT bitmaps StaticAnim$ti.xbm] \
		 -foreground black]
	}
    }
    radiobutton $_wid.f.rd1 -image $_imagenes(Lineal) -value Lineal -variable AnimacionEstatica::_tipo
    radiobutton $_wid.f.rd2 -image $_imagenes(Cosine) -value Cosine -variable AnimacionEstatica::_tipo
    radiobutton $_wid.f.rd3 -image $_imagenes(Triangular) -value Triangular -variable AnimacionEstatica::_tipo
    radiobutton $_wid.f.rd4 -image $_imagenes(Sinusoidal) -value Sinusoidal -variable AnimacionEstatica::_tipo
    label $_wid.f.l -text [_ "Steps"]:
    entry $_wid.f.e -width 5 -textvariable AnimacionEstatica::_pasos -bd 1 -relief sunken


    grid $_wid.f.rd1 $_wid.f.rd2 -sticky w -pady 3 -padx 4
    grid $_wid.f.rd3 $_wid.f.rd4 -sticky w -pady 3 -padx 4
    grid $_wid.f.l $_wid.f.e -sticky e -pady 3 -padx 4
    grid configure $_wid.f.e -sticky w

    # marco de los botones
    frame $_wid.but -bd 0 -background $realzado

    button $_wid.but.apply -text [_ "Apply"] -command "AnimacionEstatica::Aceptar" -takefocus 0 -bd 1 -padx 8 -pady 3
    button $_wid.but.close -text [_ "Close"] -command AnimacionEstatica::Cerrar -takefocus 0 -bd 1 -padx 8 -pady 3
    SetWidgetsWidthFromText $_wid.but.apply $_wid.but.close

    grid $_wid.but.apply -sticky ews -padx 4 -pady 10
    grid $_wid.but.close -sticky ews -padx 4 -pady 10 -row 0 -column 1

    #enpaquetamos marcos
    grid $_wid.f -sticky news -padx 0 -pady 0
    grid $_wid.but -sticky wes
    if { $::tcl_version >= 8.5 } { grid anchor $_wid.but center }

    grid columnconfigure $_wid 0 -weight 1
    grid rowconfigure $_wid 0 -weight 1

    AjustaPosicion $_wid $parent_w

    focus $_wid.but.apply
    bind $_wid <Escape> "tkButtonInvoke $_wid.but.close"
    return $_wid
}


proc PostAnimateDisableGUIUpdates { } {
    # GiD_Set PostUpdateWindows no
    GiD_Process escape escape escape escape utilities variables PostUpdateWindows no escape escape escape escape
    # GidUtils::Disable windows
    #GidUtils::Disable graphinput
    #GidUtils::Disable graphics
    # GidUtils::Disable  warnline
    .central.s disable windows 1
    .central.s disable warnline 1
}

proc PostAnimateEnableGUIUpdates { } {
    # GidUtils::Enable windows
    #GidUtils::Enable graphinput
    #GidUtils::Enable graphics
    #GidUtils::Enable warnline
    .central.s disable windows 0
    .central.s disable warnline 0
    # GiD_Set PostUpdateWindows yes
    GiD_Process escape escape escape escape utilities variables PostUpdateWindows yes escape escape escape escape
}

proc PostAnimateVerificaPermisos { w archivo} {
    # verificamos que el archivo se pueda escribir
    if { [ catch {
	set fo [ open $archivo w]
	puts $fo "hola"
	close $fo
    } err_msg ]} {
	WarnWin "$err_msg\nPlease check permisions, quotas and \nthat no application is using the file." $w
	return 0
    }
    return 1
}


proc PostAnimateInitValues {} {
    global GidPriv AnimacionEstatica

    set GidPriv(PostAnimateControlsDelay) 0

    set GidPriv(PostAnimateDoing) Nothing
    set GidPriv(PostAnimateDeform) 0
    set GidPriv(PostAnimateIsoSurfaces) ""
    set GidPriv(PostAnimateRsultView) ""
    set GidPriv(PostAnimateCurrentButton) ""
    set GidPriv(PostAnimateDurationType) TotalTime
    set GidPriv(PostAnimateDefaultDelayTime) 200
    set GidPriv(PostAnimateDefaultDurationTime) 5
    set GidPriv(PostAnimateDelayTime) $GidPriv(PostAnimateDefaultDelayTime)
    set GidPriv(PostAnimateDelay) 0
    set GidPriv(PostAnimateDurationTime) $GidPriv(PostAnimateDefaultDurationTime)
    set GidPriv(PostAnimateDuration) 1
    set GidPriv(PostAnimateDurationWStep) 0
    set GidPriv(PostAnimateDurationOld) 0
    set GidPriv(PostAnimateStepvalues) 0
    set GidPriv(PostAnimateIstepold) 0
    set GidPriv(PostAnimateDefaultRangeFrameFrom) 1
    set GidPriv(PostAnimateDefaultRangeFrameTo) 1
    set GidPriv(PostAnimateRangeFrameFrom) $GidPriv(PostAnimateDefaultRangeFrameFrom)
    set GidPriv(PostAnimateRangeFrameTo) $GidPriv(PostAnimateDefaultRangeFrameTo)
    set GidPriv(PostAnimateRangeFrames) 0
    set GidPriv(PostAnimateOldAutoRedraw) 1
    set GidPriv(PostAnimateSaveFrame) 0
    set GidPriv(PostAnimateSaveAnimation) 0
    set GidPriv(PostAnimateSavingAnimation) 0
    set GidPriv(PostAnimateSavingRepes) 1
    set GidPriv(PostAnimateSlideDelay) 10
    set GidPriv(PostAnimateSliding) 0
    set GidPriv(PostAnimateAnalysisLimitsCb) 0
    set GidPriv(PostAnimateSaveAnimationFormat) [GiD_Info postprocess get animationformat]
    set GidPriv(PostAnimateSaveFrameFormat) "TIFF"
    set GidPriv(PostAnimateSaveAnimationFormat) "MPEG"
    set info2 [.central.s configure]
    set height_list [ lindex $info2 0]
    set width_list [ lindex $info2 1]
    set current [format "%dx%d" [ lindex $width_list 4] [ lindex $height_list 4]]
    set GidPriv(PostAnimateResizeDefault) "$current"
    set GidPriv(PostAnimateResize) Default
    set GidPriv(PostAnimateTime) 0

    # para animaciones de un solo paso de analisis
    set AnimacionEstatica(tipo) Lineal
    set AnimacionEstatica(pasos) 10
    set AnimacionEstatica(hay) 0
}

proc AnimacionEstaticaCreaFactores { factor_base} {
    global AnimacionEstatica

    switch "$AnimacionEstatica(tipo)" {
	"Lineal" {
	    set f [ expr 1.0 / double( $AnimacionEstatica(pasos))]
	    set AnimacionEstatica(factores) ""
	    for { set i 1} { $i < $AnimacionEstatica(pasos)} { incr i} {
		lappend AnimacionEstatica(factores) [ expr $factor_base * $i * $f]
	    }
	    # para asegurarnos que este
	    lappend AnimacionEstatica(factores) $factor_base
	}
	"Cosine" {
	    set f [ expr 2.0 * acos( 0.0) / double( $AnimacionEstatica(pasos))]
	    set AnimacionEstatica(factores) ""
	    for { set i 1} { $i < $AnimacionEstatica(pasos)} { incr i} {
		lappend AnimacionEstatica(factores) [ expr $factor_base * 0.5 * ( 1.0 - cos( $f * $i))]
	    }
	    # para asegurarnos que este
	    lappend AnimacionEstatica(factores) $factor_base
	}
	"Triangular" {
	    if { $AnimacionEstatica(pasos) == 2} {
		set AnimacionEstatica(factores) ""
		lappend AnimacionEstatica(factores) $factor_base
		lappend AnimacionEstatica(factores) $factor_base
	    } else {
		set p2 [ expr ( $AnimacionEstatica(pasos)) / 2]
		set f [ expr 1.0 / double( $p2)]
		set AnimacionEstatica(factores) ""
		for { set i 1} { $i < $p2} { incr i} {
		    lappend AnimacionEstatica(factores) [ expr $factor_base * $i * $f]
		}
		# para asegurarnos que este
		lappend AnimacionEstatica(factores) $factor_base
		# si es impar repetimos $factor_base, p.ej.
		# 3 pasos -> 1.0 1.0 0.0
		# 4 pasos -> 0.5 1.0 0.5 0.0
		# 5 pasos -> 0.5 1.0 1.0 0.5 0.0
		if { [ expr $AnimacionEstatica(pasos) % 2]} {
		    lappend AnimacionEstatica(factores) $factor_base
		}
		for { set i 1} { $i <= $p2} { incr i} {
		    lappend AnimacionEstatica(factores) [ expr $factor_base * ( $p2 - $i) * $f]
		}
	    }
	}
	"Sinusoidal" {
	    if { $AnimacionEstatica(pasos) == 2} {
		set AnimacionEstatica(factores) ""
		lappend AnimacionEstatica(factores) $factor_base
		lappend AnimacionEstatica(factores) $factor_base
	    } else {
		set p2 [ expr ( $AnimacionEstatica(pasos)) / 2]
		set f [ expr 2.0 * acos( 0.0) / double( $p2)]
		set AnimacionEstatica(factores) ""
		for { set i 1} { $i < $p2} { incr i} {
		    lappend AnimacionEstatica(factores) [ expr $factor_base * 0.5 * ( 1.0 - cos( $f * $i))]
		}
		# para asegurarnos que este
		lappend AnimacionEstatica(factores) $factor_base
		# si es impar repetimos $factor_base, p.ej.
		# 3 pasos -> 1.0 1.0 0.0
		# 4 pasos -> 0.5 1.0 0.5 0.0
		# 5 pasos -> 0.5 1.0 1.0 0.5 0.0
		if { [ expr $AnimacionEstatica(pasos) % 2]} {
		    lappend AnimacionEstatica(factores) $factor_base
		}
		for { set i 1} { $i <= $p2} { incr i} {
		    lappend AnimacionEstatica(factores) [ expr $factor_base * 0.5 * ( 1.0 - cos( $f * ( $p2 - $i)))]
		}
	    }
	}
    }
}

proc CambioPostAnimateDeform { name1 name2 op} {
    global GidPriv AnimacionEstatica

    if { ![ info exists GidPriv(PostAnimateWindow)] || ![ winfo exists $GidPriv(PostAnimateWindow)] } {
	return
    }

    # if { $GidPriv(PostAnimateDeform)}
    set mainst [GiD_Info postprocess get main_geom_state]
    if { $mainst == "Deformed" } {
	if { [ llength $GidPriv(PostAnimate_all_step)] != 1} {
	    $AnimacionEstatica(boton) configure -state disable -foreground grey60
	    set AnimacionEstatica(hay) 0
	} else {
	    $AnimacionEstatica(boton) configure -state normal -foreground black
	    set AnimacionEstatica(hay) 1
	}
	AnimacionEstaticaCreaFactores $GidPriv(PostAnimate_cur_d_factor)
    } else {
	$AnimacionEstatica(boton) configure -state disable -foreground grey60
	set AnimacionEstatica(hay) 0
    }
}

proc UpdateStepValEntry { val} {
    $::GidPriv(PostAnimateStepValueEntry) configure -state normal
    $::GidPriv(PostAnimateStepValueEntry) del 0 end
    if { $val != ""} {
	$::GidPriv(PostAnimateStepValueEntry) ins 0 $val
    }
    $::GidPriv(PostAnimateStepValueEntry) configure -state readonly
}

proc UpdateStepNumEntry { val} {
    $::GidPriv(PostAnimateStepNumberEntry) configure -state normal
    $::GidPriv(PostAnimateStepNumberEntry) del 0 end
    if { $val != ""} {
	$::GidPriv(PostAnimateStepNumberEntry) ins 0 $val
    }
    $::GidPriv(PostAnimateStepNumberEntry) configure -state readonly
}

proc PostAnimateConfigureSlide {} {
    global GidPriv AnimacionEstatica

    if { ![ winfo exists $GidPriv(PostAnimateSlide)] } { return}

    if { $GidPriv(PostAnimateDeform) } {
	if { $AnimacionEstatica(hay)} {
	    $GidPriv(PostAnimateSlide) configure -from 0 -to [ expr [ llength $AnimacionEstatica(factores)]]
	    # -resolution 1
	} else {
	    $GidPriv(PostAnimateSlide) configure -from 0 -to [ expr [ llength $GidPriv(PostAnimate_all_step)]]
	    # -resolution 1
	}

	#set GidPriv(PostAnimateCurrentFrame) -1
	#$GidPriv(PostAnimateSlide) set [ expr $GidPriv(PostAnimateCurrentFrame)+1]
	#$GidPriv(PostAnimateStepValueEntry) configure -state normal
	#$GidPriv(PostAnimateStepValueEntry) del 0 end
	#$GidPriv(PostAnimateStepValueEntry) ins 0 "Orig"
	#$GidPriv(PostAnimateStepValueEntry) configure -state disabled
	#$GidPriv(PostAnimateStepNumberEntry) configure -state normal
	#$GidPriv(PostAnimateStepNumberEntry) del 0 end
	#$GidPriv(PostAnimateStepNumberEntry) ins 0 "Orig"
	#$GidPriv(PostAnimateStepNumberEntry) configure -state disabled

	if { $AnimacionEstatica(hay)} {
	    set res [ lsearch $AnimacionEstatica(factores) $GidPriv(PostAnimate_cur_d_factor)]
	} else {
	    set res [ lsearch $GidPriv(PostAnimate_all_step) $GidPriv(PostAnimate_cur_d_step)]
	}
	set frame $res

	if { $AnimacionEstatica(hay)} {
	    set istep [ lindex $AnimacionEstatica(factores) $frame]
	} else {
	    set istep [ lindex $GidPriv(PostAnimate_all_step) $frame]
	}
	if { $istep == ""} {
	    set frame -1
	    UpdateStepValEntry "Orig"
	} else {
	    UpdateStepValEntry $istep
	}
	$GidPriv(PostAnimateSlide) set [ expr $frame+1]
	UpdateStepNumEntry [ expr $frame+1]

	set frame [ expr $res+1]
	if { $AnimacionEstatica(hay)} {
	    set istep [ lindex $AnimacionEstatica(factores) $frame]
	} else {
	    set istep [ lindex $GidPriv(PostAnimate_all_step) $frame]
	}
	if { $istep == ""} {
	    set frame -1
	} else {
	    set frame $res
	}

	set GidPriv(PostAnimateCurrentFrame) $frame

    } else {
	set nsteps [ llength $GidPriv(PostAnimate_all_step)]
	if { $nsteps != 0} {
	    $GidPriv(PostAnimateSlide) configure -from 1 -to $nsteps
	    # -resolution 1

	    #set GidPriv(PostAnimateCurrentFrame) 0
	    #$GidPriv(PostAnimateSlide) set [ expr $GidPriv(PostAnimateCurrentFrame)+1]

	    set res [ lsearch $GidPriv(PostAnimate_all_step) $GidPriv(PostAnimate_cur_step)]
	    set frame $res
	
	    set istep [ lindex $GidPriv(PostAnimate_all_step) $frame]
	    # $GidPriv(PostAnimateStepValueEntry) configure -state normal
	    # $GidPriv(PostAnimateStepValueEntry) del 0 end
	    # $GidPriv(PostAnimateStepValueEntry) ins 0 $istep
	    # $GidPriv(PostAnimateStepValueEntry) configure -state disabled
	    UpdateStepValEntry $istep
	    $GidPriv(PostAnimateSlide) set [ expr $frame+1]
	    UpdateStepNumEntry [ expr $frame+1]
	
	    set frame [ expr $res+1]
	    set istep [ lindex $GidPriv(PostAnimate_all_step) $frame]
	    if { $istep == ""} {
		set frame 0
	    } else {
		set frame $res
	    }
	
	    set GidPriv(PostAnimateCurrentFrame) $frame
	
	    #$GidPriv(PostAnimateSlide) set [ expr $GidPriv(PostAnimateCurrentFrame)+1]
	    #
	    #set istep [ lindex $GidPriv(PostAnimate_all_step) $GidPriv(PostAnimateCurrentFrame)]
	    #$GidPriv(PostAnimateStepValueEntry) configure -state normal
	    #$GidPriv(PostAnimateStepValueEntry) del 0 end
	    #$GidPriv(PostAnimateStepValueEntry) ins 0 $istep
	    #$GidPriv(PostAnimateStepValueEntry) configure -state disabled
	} else {
	    $GidPriv(PostAnimateSlide) configure -from 0 -to 0
	    # -resolution 1
	    # $GidPriv(PostAnimateStepValueEntry) configure -state normal
	    # $GidPriv(PostAnimateStepValueEntry) del 0 end
	    # $GidPriv(PostAnimateStepValueEntry) configure -state disabled

	    UpdateStepValEntry ""
	    UpdateStepNumEntry ""
	
	    set GidPriv(PostAnimateCurrentFrame) 0
	}
    }
    set GidPriv(PostAnimateSlideDelay) 10
    set GidPriv(PostAnimateSliding) 0
    update
}

#checkea si el analysis y el paso de la deformada y C.fill son los mismos
proc PostAnimateCheckVisualizationCoherency { } {
    global GidPriv AnimacionEstatica

    if { [ info exists GidPriv(PostAnimateWindow)] && [ winfo exists $GidPriv(PostAnimateWindow)] } {
	if { ( $GidPriv(PostAnimateResultView) != "") && $GidPriv(PostAnimateDeform) } {
	    if { $GidPriv(PostAnimate_cur_d_anal) != $GidPriv(PostAnimate_cur_anal) } {

		# verificamos que en ambos analisis hay igual numero de pasos y con igual valor
		set GidPriv(PostAnimate_all_d_step) [GiD_Info postprocess get all_steps $GidPriv(PostAnimate_cur_d_anal)]
		set iguales 1
		if { [ llength $GidPriv(PostAnimate_all_step)] != [ llength $GidPriv(PostAnimate_all_d_step)] } {
		    set iguales 0
		} else {
		    set l [ llength $GidPriv(PostAnimate_all_step)]
		    for { set idx 0} { $idx < $l} { incr idx} {
		        if { "[ lindex $GidPriv(PostAnimate_all_step) $idx]" != "[ lindex $GidPriv(PostAnimate_all_d_step) $idx]"} {
		            set iguales 0
		            break
		        }
		    }
		}

		if { $iguales} {
		    # verificamos que el paso es el mismo para el resultado como para la deformada
		    if { $GidPriv(PostAnimate_cur_step) != $GidPriv(PostAnimate_cur_d_step)} {
		        WarnWin "Current Deformation step differs from the current Result View's step. The animation will display the view and deformation on of the same step." $GidPriv(PostAnimateWindow)
		    }
		} else {
		    set resp [ tk_dialog  $GidPriv(PostAnimateWindow).___pa_ww [_ "Warning"] \
		            [_ "Current Deformation analysis differs from current Result View's analysis. \
		            Choose which one should be valid for the animation"] \
		            info 2 [_ "ResultView"] [_ "Deformation"] [_ "Cancel"]]
		    switch $resp {
		        0 {
		            set GidPriv(PostAnimateDeform) 0
		        }
		        1 {
		            set GidPriv(PostAnimateResultView) ""
		        }
		        2 {
		            set GidPriv(PostAnimateResultView) ""
		            set GidPriv(PostAnimateDeform) 0
		        }
		    }
		}
	    }
	}
    }
}

proc PostAnimateInitVariables { } {
    global GidPriv AnimacionEstatica

    if { [ info exists GidPriv(PostAnimateInitializing)] && $GidPriv(PostAnimateInitializing)} { return}

    if { ![ info exists GidPriv(PostAnimateDoing)] } { set GidPriv(PostAnimateDoing) "Nothing"}

    if { $GidPriv(PostAnimateDoing) != "Nothing"} { return}

    set GidPriv(PostAnimateInitializing) 1

    set GidPriv(PostAnimate_cur_anal) [GiD_Info postprocess get cur_analisis]
    set cur_anal $GidPriv(PostAnimate_cur_anal)
    set GidPriv(PostAnimate_cur_step) [GiD_Info postprocess get cur_step $cur_anal]
    set GidPriv(PostAnimate_all_step) [GiD_Info postprocess get all_steps $cur_anal]
    #set GidPriv(PostAnimate_all_step,anal) [GiD_Info postprocess get all_steps $cur_anal]
    set GidPriv(PostAnimate_cur_resv) [GiD_Info postprocess get cur_results_view]
    set GidPriv(PostAnimate_cur_res)  [ join [GiD_Info postprocess get cur_result]]
    set GidPriv(PostAnimate_cur_comp) [ join [GiD_Info postprocess get cur_component]]

    set GidPriv(PostAnimateVariosResultados) [ string tolower [ GiD_Set postresoverres]]
    set GidPriv(PostAnimateListaResultados) [ GiD_Info postprocess get results_view_list]

    set GidPriv(PostAnimate_cur_d_defor) [ GiD_Info postprocess get main_geom_cur_deform]

    set GidPriv(PostAnimate_cur_d_anal) [ GiD_Info postprocess get main_geom_cur_anal]
    set GidPriv(PostAnimate_cur_d_step) [ GiD_Info postprocess get main_geom_cur_step]
    set GidPriv(PostAnimate_cur_d_factor) [GiD_Info postprocess get main_geom_cur_factor]

    set GidPriv(PostAnimate_cur_defor_type) [ GiD_Info postprocess get main_geom_deformation_type]

#    set GidPriv(PostAnimate_cur_d_factor) [GiD_Info postprocess get main_geom_factor $GidPriv(PostAnimate_cur_d_defor) $GidPriv(PostAnimate_cur_d_anal) $GidPriv(PostAnimate_cur_d_step)]

#     set GidPriv(PostAnimateDoing) Nothing
#     set GidPriv(PostAnimateCurrentButton) ""
#     set GidPriv(PostAnimateDefaultDelayTime) 200
#     set GidPriv(PostAnimateDelayTime) $GidPriv(PostAnimateDefaultDelayTime)
#     set GidPriv(PostAnimateDelay) 0
#     set GidPriv(PostAnimateOldAutoRedraw) 1

    set GidPriv(PostAnimateDefaultRangeFrameFrom) 1
    set GidPriv(PostAnimateDefaultRangeFrameTo) [ llength $GidPriv(PostAnimate_all_step)]
    set GidPriv(PostAnimateRangeFrameFrom) $GidPriv(PostAnimateDefaultRangeFrameFrom)
    set GidPriv(PostAnimateRangeFrameTo) $GidPriv(PostAnimateDefaultRangeFrameTo)

    regsub -all {_} $GidPriv(PostAnimate_cur_resv) {} pepe

    set GidPriv(PostAnimate_cur_resv) $pepe

    set GidPriv(PostAnimateResultViewCb) 1
    switch $GidPriv(PostAnimate_cur_resv) {
	"ShMinMax" { set GidPriv(PostAnimateResultView) $GidPriv(PostAnimate_cur_resv)}
	"ContourFill" { set GidPriv(PostAnimateResultView) $GidPriv(PostAnimate_cur_resv)}
	"SmoothContourFill" { set GidPriv(PostAnimateResultView) $GidPriv(PostAnimate_cur_resv)}
	"ContourLines" { set GidPriv(PostAnimateResultView) $GidPriv(PostAnimate_cur_resv)}
	"IsoSurfaces" {
	    set GidPriv(PostAnimateResultView) $GidPriv(PostAnimate_cur_resv)
	    # esto de abajo lo hacemos siempre, pues puede ser que hagan
	    # isosuperficies con color del contour fill y hagan despues el contour fill
	    #set GidPriv(PostAnimateIsoSurfaces) [ lindex [GiD_Info postprocess get iso_cur_result_values] 0]
	}
	"DisplayVectors" {
	    set GidPriv(PostAnimateResultView) $GidPriv(PostAnimate_cur_resv)
	    set GidPriv(PostAnimateDisplayVectors) [GiD_Info postprocess get cur_vector_factor \
		    Display_Vectors $GidPriv(PostAnimate_cur_res) $GidPriv(PostAnimate_cur_anal) \
		    $GidPriv(PostAnimate_cur_step)]
	}
	"ContourRanges" { set GidPriv(PostAnimateResultView) $GidPriv(PostAnimate_cur_resv)}
	"ScalarLineDiagram" {
	    set GidPriv(PostAnimateResultView) $GidPriv(PostAnimate_cur_resv)
	    set GidPriv(PostAnimateScalarDiagram) [GiD_Info postprocess get cur_diagram_factor\
		    $GidPriv(PostAnimate_cur_res) $GidPriv(PostAnimate_cur_comp) $GidPriv(PostAnimate_cur_anal) \
		    $GidPriv(PostAnimate_cur_step)]
	}
	"VectorLineDiagram" {
	    set GidPriv(PostAnimateResultView) $GidPriv(PostAnimate_cur_resv)
	    set GidPriv(PostAnimateVectorDiagram) [GiD_Info postprocess get cur_diagram_factor\
		    $GidPriv(PostAnimate_cur_res) $GidPriv(PostAnimate_cur_anal) \
		    $GidPriv(PostAnimate_cur_step)]
	}
	"ResultSurface" {
	    set GidPriv(PostAnimateResultView) $GidPriv(PostAnimate_cur_resv)
	    set GidPriv(PostAnimateResultSurface) [GiD_Info postprocess get cur_result_surface_factor \
		    Result_Surface $GidPriv(PostAnimate_cur_res) $GidPriv(PostAnimate_cur_comp) $GidPriv(PostAnimate_cur_anal) \
		    $GidPriv(PostAnimate_cur_step)]
	}
	default {
	    set GidPriv(PostAnimateResultView) ""
	    set GidPriv(PostAnimateResultViewCb) 0
	}
    }
    set GidPriv(PostAnimateIsoSurfaces) [ lindex [GiD_Info postprocess get iso_cur_result_values] 0]
    # WarnWinText "linex iso_cur_result_values] 0] -$GidPriv(PostAnimateIsoSurfaces)-"

    if { [ info exists GidPriv(PostAnimateResButtons)] && [ winfo exists $GidPriv(PostAnimateResButtons).b1] } {
	if { $GidPriv(PostAnimateResultViewCb) } {
	    #$GidPriv(PostAnimateResButtons).l configure -foreground black
	    $GidPriv(PostAnimateResButtons).b1 configure -state normal
	    #$GidPriv(PostAnimateResButtons).b2 configure -state normal
	} else {
	    #$GidPriv(PostAnimateResButtons).l configure -foreground grey60
	    $GidPriv(PostAnimateResButtons).b1 configure -state disabled
	    #$GidPriv(PostAnimateResButtons).b2 configure -state disabled
	}
    }

    #if { [ info exists GidPriv(PostAnimateAnalysisLimitsCb)] && \
    #             $GidPriv(PostAnimateAnalysisLimitsCb) } {
    #         PostAnimateGetAnalysisLimits "" "" ""
    #}


    set mainst [GiD_Info postprocess get main_geom_state]
    if { $mainst == "Deformed" } {
	set GidPriv(PostAnimateDeform) 1
    } else {
	set GidPriv(PostAnimateDeform) 0
    }

    if { [ info exists GidPriv(PostAnimateSlide)] } {
	PostAnimateConfigureSlide
    }

    set GidPriv(PostAnimateInitializing) 0

    if { [ info exists GidPriv(PostAnimateAnalysisLimitsCb)] && \
	    $GidPriv(PostAnimateAnalysisLimitsCb) } {
	PostAnimateGetAnalysisLimits "" "" ""
    }
}

proc PostAnimateGetValidFrame { frame} {
    global GidPriv AnimacionEstatica

    # no hace falta: if { !$GidPriv(PostAnimateRangeFrames)} { return $frame}
    # corrige el maximo por si acaso
    PostAnimateCheckRangeFrame 0
    set from_f [ expr $GidPriv(PostAnimateRangeFrameFrom) - 1]
    if { $frame < $from_f} {
	set frame $from_f
    } else {
	# set to_f [ expr $GidPriv(PostAnimateRangeFrameTo) - 1]
	# if { ( $frame > $to_f) && $GidPriv(PostAnimateEndless)} {
	#     set frame $from_f
	# }
    }
    return $frame
}

proc PostAnimateFrame { frame} {
    global GidPriv AnimacionEstatica

    #WarnWinText "PostAnimateFrame: GidPriv(PostAnimateDoing) = $GidPriv(PostAnimateDoing)   frame = $frame"
    if { $GidPriv(PostAnimateRangeFrames) && $GidPriv(PostAnimateDoing) == "Animate"} {
	#WarnWinText "Skipping first frames doing $GidPriv(PostAnimateDoing)"
	set frame [ PostAnimateGetValidFrame $frame]
    }
    switch $GidPriv(PostAnimateDoing) {
	"Nothing" { return}
	"Stop" {
	    PostAnimateEnableGUIUpdates
	    if { $GidPriv(PostAnimateSavingAnimation) } {
		GiD_Process animationfile end
		set GidPriv(PostAnimateSavingAnimation) 0
	    }

	    if { $GidPriv(PostAnimateDeform)} {
		# reactivate redraw
		#DebugPostAnim "SET_stop AutomaticRedraw $GidPriv(PostAnimateOldAutoRedraw)"
		GiD_Set AutomaticRedraw $GidPriv(PostAnimateOldAutoRedraw)
		# .central.s render
		GiDActualizaVentanasTogl
	    }
	    #set GidPriv(PostAnimateCurrentFrame) [ expr $frame-1]
	    set GidPriv(PostAnimateCurrentFrame) $frame
	    #WarnWin "Frame:Stop: $GidPriv(PostAnimateCurrentFrame)"
	
	    catch {
		if { $GidPriv(PostAnimateCurrentButton) != ""} {
		    TryRoundRelief $GidPriv(PostAnimateCurrentButton) raised
		    # $GidPriv(PostAnimateCurrentButton) configure -relief raise
		}
	    }
	    update
	    set GidPriv(PostAnimateDoing) Nothing

	    return
	}
	"Rewind" {
	    if { $GidPriv(PostAnimateDeform)} {
		set GidPriv(PostAnimateCurrentFrame) -1
	    } else {
		set GidPriv(PostAnimateCurrentFrame) 0
	    }
	
	    set frame $GidPriv(PostAnimateCurrentFrame)
	    #WarnWin "Frame:Rewind: $GidPriv(PostAnimateCurrentFrame)"
	
	    if { $frame == -1} {
		UpdateStepValEntry "Orig"
	    } else {
		set all_step $GidPriv(PostAnimate_all_step)
		set istep [ lindex $all_step $frame]
		UpdateStepValEntry $istep
	    }
	    $GidPriv(PostAnimateSlide) set [ expr $frame+1]
	    UpdateStepNumEntry [ expr $frame+1]
	}
    }

	#actualizamos la slide
#         set frame $GidPriv(PostAnimateCurrentFrame)
#         $GidPriv(PostAnimateStepValueEntry) configure -state normal
#         $GidPriv(PostAnimateStepValueEntry) del 0 end
#         if { $frame == -1} {
#             $GidPriv(PostAnimateStepValueEntry) ins 0 "Orig"
#         } else {
#             set all_step   $GidPriv(PostAnimate_all_step)
#             set istep [ lindex $all_step $frame]
#             $GidPriv(PostAnimateStepValueEntry) ins 0 $istep
#         }
#         $GidPriv(PostAnimateStepValueEntry) configure -state disabled
#         $GidPriv(PostAnimateSlide) set [ expr $frame+1]

    set cur_anal   $GidPriv(PostAnimate_cur_anal)
    #set cur_step   $GidPriv(PostAnimate_cur_step)
    set cur_d_anal   $GidPriv(PostAnimate_cur_d_anal)
    #set cur_d_step   $GidPriv(PostAnimate_cur_d_step)
    set all_step   $GidPriv(PostAnimate_all_step)
    set cur_resv   $GidPriv(PostAnimate_cur_resv)
    set cur_res    $GidPriv(PostAnimate_cur_res)
    set cur_comp   $GidPriv(PostAnimate_cur_comp)
    set cur_defor  $GidPriv(PostAnimate_cur_d_defor)
    set cur_factor $GidPriv(PostAnimate_cur_d_factor)
    set cur_defor_type $GidPriv(PostAnimate_cur_defor_type)


    if { $GidPriv(PostAnimateSaveFrame)} {
	if { "$GidPriv(PostAnimateSaveFrameFormat)" == "TIFF"} {
	    set GidPriv(PostAnimateSaveFilename) [ format %s-%02d.tif \
		    $GidPriv(PostAnimateSavePrefix) [ expr $frame+1]]
	} elseif { "$GidPriv(PostAnimateSaveFrameFormat)" == "JPEG"} {
	    set GidPriv(PostAnimateSaveFilename) [ format %s-%02d.jpg \
		    $GidPriv(PostAnimateSavePrefix) [ expr $frame+1]]
	} else {
	    set GidPriv(PostAnimateSaveFilename) [ format %s-%02d.gif \
		    $GidPriv(PostAnimateSavePrefix) [ expr $frame+1]]
	}
    } else {
	set GidPriv(PostAnimateSaveFilename) ""
    }

    if { $GidPriv(PostAnimateDeform) && $frame == -1} {

	# deactivate redraw
	set GidPriv(PostAnimateOldAutoRedraw) [GiD_Set AutomaticRedraw]
	#DebugPostAnim "GET-1 AutomaticRedraw $GidPriv(PostAnimateOldAutoRedraw)"
	#DebugPostAnim "SET-1 AutomaticRedraw -1"
	GiD_Set AutomaticRedraw -1

	# la original
	GiD_Process Mescape results geometry Original
	#DebugPostAnim "SET-1 AutomaticRedraw $GidPriv(PostAnimateOldAutoRedraw)"
	GiD_Set AutomaticRedraw $GidPriv(PostAnimateOldAutoRedraw)
	#.central.s render
	GiDActualizaVentanasTogl
	if { $GidPriv(PostAnimateSavingAnimation) } {
	    # for { set irepe 0} { $irepe < $GidPriv(PostAnimateSavingRepes)} { incr irepe} {
	    #           GiD_Process Mescape utilities animationfile addframe
	    # }
	    GiD_Process animationfile addstep
	}
	if { $GidPriv(PostAnimateSaveFrame)} {
	    #WarnWin "$GidPriv(PostAnimateSaveFilename)"
	    GiD_Process Mescape utilities hardcopy \
		    $GidPriv(PostAnimateSaveFrameFormat) $GidPriv(PostAnimateSaveFilename)
	}
	#update
	#update idletasks
	
	#DebugPostAnim "SET-1 AutomaticRedraw -1"
	GiD_Set AutomaticRedraw -1

	#actualizamos la slide
	$GidPriv(PostAnimateSlide) set [ expr $frame+1]
	UpdateStepNumEntry [ expr $frame+1]
	# $GidPriv(PostAnimateStepValueEntry) configure -state normal
	# $GidPriv(PostAnimateStepValueEntry) del 0 end
	# $GidPriv(PostAnimateStepValueEntry) ins 0 "Orig"
	# $GidPriv(PostAnimateStepValueEntry) configure -state disabled
	UpdateStepValEntry "Orig"

	if { $GidPriv(PostAnimateDoing) == "Rewind"} {
	    set GidPriv(PostAnimateDoing) Stop
	    PostAnimateFrame $frame
	    return
	}

	update idletasks
	if { $GidPriv(PostAnimateDelay) } {
	    #WarnWin "1 after $GidPriv(PostAnimateDelayTime) PostAnimateFrame 0 - $GidPriv(PostAnimateDoing)"
	    if { ![ catch { set pp [ expr $GidPriv(PostAnimateDelayTime)]}] } {
		after $GidPriv(PostAnimateDelayTime) "PostAnimateFrame 0"
	    } else {
		PostAnimateFrame 0
	    }
	} else {
	    #WarnWin "1b after $GidPriv(PostAnimateDefaultDelayTime) PostAnimateFrame 0 - $GidPriv(PostAnimateDoing)"
	    after $GidPriv(PostAnimateDelayTime) "PostAnimateFrame 0"
	}
	return
	
    }

    if { !$GidPriv(PostAnimateDeform) || !$AnimacionEstatica(hay)} {
	set istep [ lindex $all_step $frame]
    } else {
	set istep [ lindex $AnimacionEstatica(factores) $frame]
    }

    if { $GidPriv(PostAnimateRangeFrames)} {
	set to_f $GidPriv(PostAnimateRangeFrameTo)
	if { ( $frame >= $to_f)} {
	    set istep ""
	}
    }

    if { $istep == ""} {
	if { $GidPriv(PostAnimateDeform)} {
	    set frame -1
	} else {
	    set frame 0
	}
	if { $GidPriv(PostAnimateEndless)} {
	    #set istep [ lindex $all_step 0]
	    PostAnimateFrame $frame
	    return
	} else {
	    set GidPriv(PostAnimateDoing) Stop
	    PostAnimateFrame $frame
	    return
	}
    }

	
    #actualizamos la slide
    $GidPriv(PostAnimateSlide) set [ expr $frame+1]
    UpdateStepNumEntry [ expr $frame+1]
    # $GidPriv(PostAnimateStepValueEntry) configure -state normal
    # $GidPriv(PostAnimateStepValueEntry) del 0 end
    # $GidPriv(PostAnimateStepValueEntry) ins 0 $istep
    # $GidPriv(PostAnimateStepValueEntry) configure -state disabled
    UpdateStepValEntry $istep

    #actualizamos la representacion del resultado
    #DebugPostAnim "SET AutomaticRedraw -1"
    GiD_Set AutomaticRedraw -1

    GiD_Process Mescape results geometry noresults escape escape escape escape

    if { $GidPriv(PostAnimateDeform)} {
	# puede que cur_anal != cur_d_anal
	GiD_Process Mescape results analysissel $cur_d_anal $istep
	GiD_Process Mescape results options deformationtype $cur_defor_type
	if { $AnimacionEstatica(hay)} {
	    GiD_Process Mescape results geometry Original geometry deformation $cur_defor $istep escape
	} else {
	    GiD_Process Mescape results geometry Original geometry deformation $cur_defor $cur_factor escape
	}
	GiD_Process Mescape results options deformationtype relative
    }
    GiD_Process Mescape results analysissel $cur_anal $istep Mescape
	
    # si hay isosuperficie, la actualizamos
    if { ( $GidPriv(PostAnimate_cur_resv) == "IsoSurfaces") && ( [ llength $GidPriv(PostAnimateIsoSurfaces)] != 0)} {
	set iso_res [ lindex $GidPriv(PostAnimateIsoSurfaces) 2]
	set iso_anal [ lindex $iso_res 2]
	set iso_paso [ lindex $iso_res 3]
	if { "$cur_anal" != "$iso_paso"} {
	    GiD_Process Mescape results analysissel $iso_anal $istep Mescape
	}
	set lst_valores [ lindex $GidPriv(PostAnimateIsoSurfaces) 1]
	GiD_Process Mescape results IsoSurfaces Exact [ lindex $iso_res 0] [ lindex $iso_res 1] \
	    [ lindex $GidPriv(PostAnimateIsoSurfaces) 0] {*}$lst_valores
	# WarnWinText "1- $GidPriv(PostAnimateIsoSurfaces)"
	# WarnWinText "1- GiD_Process Mescape results IsoSurfaces Exact [ lindex $iso_res 0] [ lindex $iso_res 1] \
	#     [ lindex $GidPriv(PostAnimateIsoSurfaces) 0] {*}$lst_valores"
	# foreach val $lst_valores {
	#     GiD_Process $val
	# }
	if { "$cur_anal" != "$iso_paso"} {
	    GiD_Process Mescape results analysissel $cur_anal $istep Mescape
	}
    }

    if { $GidPriv(PostAnimateResultViewCb) && $GidPriv(PostAnimateAnalysisLimitsCb)} {
	PostAnimatePushLimits
	PostAnimateSetAnalysisLimits
    }

    if { $GidPriv(PostAnimateResultViewCb) && $GidPriv(PostAnimateResultView) != ""} {
	if { "$GidPriv(PostAnimateVariosResultados)" == "no"} {
	    switch $GidPriv(PostAnimate_cur_resv) {
		"ShMinMax" {
		    GiD_Process Mescape results $cur_resv $cur_res $cur_comp
		}
		"ContourFill" {
		    GiD_Process Mescape results $cur_resv $cur_res $cur_comp
		}
		"SmoothContourFill" {
		    GiD_Process Mescape results $cur_resv $cur_res $cur_comp
		}
		"ContourLines" {
		    GiD_Process Mescape results $cur_resv $cur_res $cur_comp
		}
		"IsoSurfaces" {
		    set lst_valores [ lindex $GidPriv(PostAnimateIsoSurfaces) 1]
		    GiD_Process Mescape results $cur_resv Exact $cur_res $cur_comp \
		        [ lindex $GidPriv(PostAnimateIsoSurfaces) 0] {*}$lst_valores
		    # WarnWinText "2- $GidPriv(PostAnimateIsoSurfaces)"
		    # WarnWinText "2 - GiD_Process Mescape results $cur_resv Exact $cur_res $cur_comp \
		    #     [ lindex $GidPriv(PostAnimateIsoSurfaces) 0] {*}$lst_valores"
		    # foreach val $lst_valores {
		    # 	GiD_Process $val
		    # }
		}
		"DisplayVectors" {
		    GiD_Process Mescape results $cur_resv $cur_res $cur_comp \
		        $GidPriv(PostAnimateDisplayVectors)
		}
		"ContourRanges" {
		    GiD_Process Mescape results $cur_resv $cur_res $cur_comp
		}
		"ScalarLineDiagram" {
		    GiD_Process Mescape results LineDiagram ScalarDiagram $cur_res $cur_comp \
		        $GidPriv(PostAnimateScalarDiagram)
		}
		"VectorLineDiagram" {
		    GiD_Process Mescape results LineDiagram VectorDiagram $cur_res \
		        $GidPriv(PostAnimateVectorDiagram)
		}
		"ResultSurface" {
		    GiD_Process Mescape results $cur_resv $cur_res $cur_comp \
		        $GidPriv(PostAnimateResultSurface)
		}
		default {
		    #nothing
		}
	    }
		
	} else {
	    # varios resultados
	
	    # GiD_Process Mescape results geometry noresults Mescape
	    foreach estado_res $GidPriv(PostAnimateListaResultados) {
		set resv [ string tolower [ lindex $estado_res 1]]
		set res_name [ lindex $estado_res 4]
		set res_comp [ lindex $estado_res 5]
		set res_factor [ lindex $estado_res 6]
		regsub -all { } $resv {} resv
		if { $resv == "displayvectors"} {
		    GiD_Process Mescape results $resv $res_name $res_comp $res_factor
		} elseif { $resv == "scalarlinediagram"} {
		    GiD_Process Mescape results LineDiagram ScalarDiagram $res_name $res_comp $res_factor
		} elseif { $resv == "vectorlinediagram"} {
		    GiD_Process Mescape results LineDiagram VectorDiagram $res_name $res_factor
		} elseif { $resv == "isosurfaces"} {
		    set lst_valores [ lindex $res_factor 1]
		    GiD_Process Mescape results $resv Exact $res_name $res_comp \
		        [ lindex $res_factor 0] {*}$lst_valores
		    # WarnWinText "3- $res_factor ( $GidPriv(PostAnimateIsoSurfaces))"
		    # WarnWinText "3- GiD_Process Mescape results $resv Exact $res_name $res_comp \
		    #     [ lindex $res_factor 0] {*}$lst_valores"
		    # foreach val $lst_valores {
		    # 	GiD_Process $val
		    # }
		} else {
		    GiD_Process Mescape results $resv $res_name $res_comp
		}
	    }
	}
    }

    #WarnWin "istep = $istep - frame = $frame"

    #if { $GidPriv(PostAnimateDeform)} {
    #DebugPostAnim "GET AutomaticRedraw $GidPriv(PostAnimateOldAutoRedraw)"
    GiD_Set AutomaticRedraw $GidPriv(PostAnimateOldAutoRedraw)
    #.central.s render
    GiDActualizaVentanasTogl
    #}

    if { $GidPriv(PostAnimateSavingAnimation) } {
	# for { set irepe 0} { $irepe < $GidPriv(PostAnimateSavingRepes)} { incr irepe} {
	#     GiD_Process Mescape utilities animationfile addframe
	# }
	GiD_Process animationfile addstep
	#PostAnimateShowFileSize
    } else {
	PostAnimateShowTime
    }
    if { $GidPriv(PostAnimateSaveFrame)} {
	#WarnWin $GidPriv(PostAnimateSaveFilename)
	GiD_Process Mescape hardcopy $GidPriv(PostAnimateSaveFrameFormat) $GidPriv(PostAnimateSaveFilename)
    }

    if { $GidPriv(PostAnimateResultViewCb) && $GidPriv(PostAnimateAnalysisLimitsCb)} {
	PostAnimatePopLimits
    }

    if { $GidPriv(PostAnimateDoing) == "Rewind"} {
	set GidPriv(PostAnimateDoing) Stop
	PostAnimateFrame $frame
	#WarnWin "holahola"
	return
    }

    update idletasks
   if { $GidPriv(PostAnimateDelay) } {
	#WarnWin "2 after $GidPriv(PostAnimateDelayTime) PostAnimateFrame [expr $frame + 1] - $GidPriv(PostAnimateDoing)"
	if { ![ catch { set pp [ expr $GidPriv(PostAnimateDelayTime)]}] } {
		after $GidPriv(PostAnimateDelayTime) "PostAnimateFrame [expr $frame + 1]"
	} else {
	    PostAnimateFrame [expr $frame + 1]
	}
    } else {
	#WarnWin "2b after $GidPriv(PostAnimateDefaultDelayTime) PostAnimateFrame [expr $frame + 1] - $GidPriv(PostAnimateDoing)"
	#Tcl_GetInt(interp,$frame,a)
	
	if { $GidPriv(PostAnimateDuration)} {
	    if { $GidPriv(PostAnimateDurationWStep)} {
		set GidPriv(PostAnimateStepvalues) 1
	    } else {
		set GidPriv(PostAnimateStepvalues) 0
	    set GidPriv(PostAnimateDelayTime) [expr {$GidPriv(PostAnimateDurationTime)*1000/$GidPriv(PostAnimateRangeFrameTo)}]
	    }
	}
	if {$GidPriv(PostAnimateStepvalues)} {
		if {$GidPriv(PostAnimateDuration)} {
		    #set dur  [expr $GidPriv(PostAnimateDurationTime)/$)]
		set npas [ expr $GidPriv(PostAnimateRangeFrameTo)  - 1]
		    set pas_final [lindex $GidPriv(PostAnimate_all_step) $npas]
		    set dur [ expr double($GidPriv(PostAnimateDurationTime))/$pas_final]
		} else {set dur 1}
		set frame1 [expr $istep-$GidPriv(PostAnimateIstepold)]
		set GidPriv(PostAnimateIstepold) $istep
		if { $frame1 < 0 } {
		    set GidPriv(PostAnimateDelayTime) 0
		} else {
		    set GidPriv(PostAnimateDelayTime) [expr int([expr $frame1*1000*$dur])]
		}
		after [expr $GidPriv(PostAnimateDelayTime)] "PostAnimateFrame [expr $frame + 1]"
	    } else {
	    after $GidPriv(PostAnimateDelayTime) "PostAnimateFrame [expr $frame + 1]"
	}
    }
    return

}

proc PostAnimatePlay { w { un_paso 0}} {
    global GidPriv

    if { $GidPriv(PostAnimateDoing) != "Nothing"} { return}

    # if { ( $GidPriv(PostAnimateResultView) == "" ) && !$GidPriv(PostAnimateDeform)} {
    #           WarnWin [_ "Please check ResultView or Deformation"] $GidPriv(PostAnimateWindow)
    #           return
    # }
    #WarnWinText "PostAnimatePlay: rangeframes = $GidPriv(PostAnimateRangeFrames) from $GidPriv(PostAnimateRangeFrameFrom) to $GidPriv(PostAnimateRangeFrameTo). Check = [ PostAnimateCheckRangeFrame]"
    if { $GidPriv(PostAnimateRangeFrames) && ![ PostAnimateCheckRangeFrame]} { return}

    if { ![ PostAnimateCheckWhichAnimation]} { return}

    PostAnimateCheckVisualizationCoherency

    if { $GidPriv(PostAnimateDelay)} {
	if { [ catch { set pp [ expr $GidPriv(PostAnimateDelayTime)]}] } {
	    WarnWin [_ "Delay '%s' not correct." $GidPriv(PostAnimateDelayTime)] $GidPriv(PostAnimateWindow)
	    return
	}
	if { $GidPriv(PostAnimateDelayTime) < 0} {
	    WarnWin [_ "Delay '%s' not correct." $GidPriv(PostAnimateDelayTime)] $GidPriv(PostAnimateWindow)
	    return
	}
	if { $GidPriv(PostAnimateDelayTime) > 15000} {
	    set resp [ tk_messageBox -parent $GidPriv(PostAnimateWindow) -default no -title [_ "Confirm"] -type yesno \
		-message [_ "Are you sure you want to use %s ms as delay?" $GidPriv(PostAnimateDelayTime)]]
	    if { $resp == "no"} {
		return
	    }
	}
    }

    if { $GidPriv(PostAnimateDuration)} {
	if { [ catch { set pp [ expr $GidPriv(PostAnimateDurationTime)]}] } {
	    WarnWin [_ "Duration '%s' not correct." $GidPriv(PostAnimateDurationTime)] $GidPriv(PostAnimateWindow)
	    return
	}
	if { $GidPriv(PostAnimateDurationTime) < 0} {
	    WarnWin [_ "Duration '%s' not correct." $GidPriv(PostAnimateDurationTime)] $GidPriv(PostAnimateWindow)
	    return
	}
	if { $GidPriv(PostAnimateDurationTime) > 200} {
	    set resp [ tk_messageBox -parent $GidPriv(PostAnimateWindow) -default no -title [_ "Confirm"] -type yesno \
		    -message [_ "Are you sure you want to use %s s as duration?" $GidPriv(PostAnimateDurationTime)]]
	    if { $resp == "no"} {
		return
	    }
	}
    }

    if { $GidPriv(PostAnimateEndless) && ( $GidPriv(PostAnimateSaveAnimation) || $GidPriv(PostAnimateSaveFrame))} {
	set what ""
	if { $GidPriv(PostAnimateSaveFrame)} {
	    set what "save $GidPriv(PostAnimateSaveFrameFormat)'s"
	}
	if { $GidPriv(PostAnimateSaveAnimation)} {
	    if { $what == ""} {
		set what "save the $GidPriv(PostAnimateSaveAnimationFormat)"
	    } else {
		set what "$what & save the $GidPriv(PostAnimateSaveAnimationFormat)"
	    }
	}
	set resp [ tk_dialog $GidPriv(PostAnimateWindow).___pa_ww2 [_ "Warning"] \
		       [_ "Are you sure to do an ENDLESS animation AND %s, so that the disk will be filled?" $what]\
		       error 1 [_ "Yes, I know"] [_ "No, I wouldn't"]]
	switch $resp {
	    0 {
		WarnWin [_ "Remember to push the STOP button to STOP the animation and so, not to fill the disk !!!"] $GidPriv(PostAnimateWindow)
	    }
	    1 {
		return
	    }
	}
    }

    #if { $GidPriv(PostAnimateSaveAnimation) && !$GidPriv(PostAnimateDelay) } {
	 # set resp [ tk_messageBox -parent $GidPriv(PostAnimateWindow) -icon warning -type yesno \
	#           -default no -message \
	#           "Saving a MPEG animation file without delay between Steps can cause some strange efects in Microsoft Windows 95/98/NT.\n Are you sure you want continue?" ]
	# if { $resp == "no"} {
	#     return
	# }
     #   WarnWin [_ "There is no delay selected, using default of 200 ms. \n If you want no delay, please check the delay time entry."] $GidPriv(PostAnimateWindow)
    #}
#     set cur_anal   $GidPriv(PostAnimate_cur_anal)
#     set cur_step   $GidPriv(PostAnimate_cur_step)
#     set all_step   $GidPriv(PostAnimate_all_step)
#     set cur_resv   $GidPriv(PostAnimate_cur_resv)
#     set cur_res    $GidPriv(PostAnimate_cur_res)
#     set cur_comp   $GidPriv(PostAnimate_cur_comp)
#     set cur_defor  $GidPriv(PostAnimate_cur_defor)
#     set cur_factor $GidPriv(PostAnimate_cur_factor)

#     if { $GidPriv(PostAnimateCurrentFrame) == ""} {
#         if { $GidPriv(PostAnimateDeform)} {
#             set GidPriv(PostAnimateCurrentFrame) -1
#         } else {
#             set GidPriv(PostAnimateCurrentFrame) 0
#         }
#     }

    # configuramos la slide
#     if { $GidPriv(PostAnimateDeform)} {
#         $GidPriv(PostAnimateSlide) configure -from 0 -to [ expr [ llength $all_step]] -resolution 1
#     } else {
#         $GidPriv(PostAnimateSlide) configure -from 1 -to [ expr [ llength $all_step]] -resolution 1
#     }
#WarnWin $GidPriv(PostAnimateCurrentFrame)

    if { $GidPriv(PostAnimateSaveAnimation) } {
	if { ![ PostAnimateVerificaPermisos $w $GidPriv(PostAnimateSaveAnimationFile)]} {
	    return
	}
	# para que no nos actualize el estado de resultados:
	#puede que estemos haciendo una animacion de deformada y estemos en el estado original
	set GidPriv(PostAnimateInitializing) 1
	GiD_Process animationfile format $GidPriv(PostAnimateSaveAnimationFormat)
	set GidPriv(PostAnimateInitializing) 0

	if { ( "$GidPriv(PostAnimateSaveAnimationFormat)" == "AVIMJPG") || \
		 ( "$GidPriv(PostAnimateSaveAnimationFormat)" == "AVIMSVC") || \
		( "$GidPriv(PostAnimateSaveAnimationFormat)" == "AVI") || \
		( "$GidPriv(PostAnimateSaveAnimationFormat)" == "AVI15") || \
		( "$GidPriv(PostAnimateSaveAnimationFormat)" == "AVI16")} {
	    set info2 [.central.s configure]
	    set height_list [ lindex $info2 0]
	    set width_list [ lindex $info2 1]
	    set width [ lindex $width_list 4]
	    set height [ lindex $height_list 4]

	    set avisize [ expr $width * $height * ( [ llength $GidPriv(PostAnimate_all_step)] + $GidPriv(PostAnimateDeform))]
	    if { "$GidPriv(PostAnimateSaveAnimationFormat)" == "AVIMJPG" } {
		# estimacion aproximada
		set avisize [ expr $avisize * 3 * 0.1]
	    } elseif { "$GidPriv(PostAnimateSaveAnimationFormat)" == "AVIMSVC" } {
		# estimacion aproximada
		set avisize [ expr $avisize * 3 * 0.15]
	    } elseif { "$GidPriv(PostAnimateSaveAnimationFormat)" == "AVI" } {
		set avisize [ expr $avisize * 3]
	    } else {
		set avisize [ expr $avisize * 2]
	    }
	    set avisize [ expr ( $avisize / 1024.0) / 1024.0]

	    if { $avisize > 95.00 } {
		set resp [ tk_messageBox -parent $GidPriv(PostAnimateWindow) -icon warning -type yesno \
		        -default no -message \
		        "Warning: the AVI file will be [ format %.3g $avisize] MB big !!!\n Are you sure you want continue?" ]
		if { $resp == "no"} {
		    return
		}
	    }
	    #WarnWin "The AVI file will be [ format %.3g $avisize] MB big !!!"
	}

	# Frame rate = 25 FPS == 40 ms.
	set repe 1
	if { $GidPriv(PostAnimateDelay) } {
	    if { ( $GidPriv(PostAnimateDelayTime) == 0) && \
		    ( "$GidPriv(PostAnimateSaveAnimationFormat)" == "MPEG") } {
		set resp [ tk_messageBox -parent $GidPriv(PostAnimateWindow) -icon warning -type yesno \
		        -default no -message \
		        "Saving a MPEG animation file without delay between Steps can cause some strange efects in Microsoft Windows 95/98/NT.\n Are you sure you want continue?" ]
		if { $resp == "no"} {
		    return
		}
	    }
#            set repe [ expr int(0.5 + $GidPriv(PostAnimateDefaultDelayTime)/40.0)]
	    set repe [ expr int(0.5 + $GidPriv(PostAnimateDelayTime)/40.0)]
	    if { $repe == 0} { set repe 1}
	} else {
	    # por defecto 200 ms. # medio segundo
	    set repe [ expr int(0.5 + 200.0/40.0)]
	    if { $repe == 0} { set repe 1}
	}

	set GidPriv(PostAnimateSavingRepes) $repe
	GiD_Process animationfile framesperstep $GidPriv(PostAnimateSavingRepes) escape escape escape escape
	GiD_Process animationfile start $GidPriv(PostAnimateSaveAnimationFile) yes escape escape escape escape

	set GidPriv(PostAnimateSavingAnimation) 1

	update
    }

    # para mostrar al usuario el tamanyo del archivo
    if { $GidPriv(PostAnimateStepvalues) } {
	set temps [lindex $GidPriv(PostAnimate_all_step) 0]
	set GidPriv(PostAnimateTime) [expr int([expr $temps*1000])]
    } else {
	set GidPriv(PostAnimateTime) 0
    }

    set GidPriv(PostAnimateDoing) Animate
    if { !$un_paso} {
	PostAnimateDisableGUIUpdates
    }

    if { $w != ""} {
	TryRoundRelief $w sunken
	#$w configure -relief sunken
    }
    set GidPriv(PostAnimateCurrentButton) $w

    #WarnWinText "PostAnimatePlay: 5 $GidPriv(PostAnimateCurrentFrame)"
    #WarnWinText "PostAnimatePlay: un_paso = $un_paso   CurrentFrame = $GidPriv(PostAnimateCurrentFrame)"
    PostAnimateFrame $GidPriv(PostAnimateCurrentFrame)
}

proc PostAnimateStop { w} {
    global GidPriv
    #WarnWinText "PostAnimateStop"
    if { $GidPriv(PostAnimateDoing) == "Nothing"} { return}
    if { $GidPriv(PostAnimateCurrentButton) != ""} {
	TryRoundRelief $GidPriv(PostAnimateCurrentButton) raised
	#$GidPriv(PostAnimateCurrentButton) configure -relief raised
    }
    set GidPriv(PostAnimateDoing) Stop
    if { $w != ""} {
	TryRoundRelief $w sunken
	#$w configure -relief sunken
    }
    set GidPriv(PostAnimateCurrentButton) $w
}

proc PostAnimateRewind { w} {
    global GidPriv

    if { $GidPriv(PostAnimateCurrentButton) != ""} {
	TryRoundRelief $GidPriv(PostAnimateCurrentButton) raised
	#$GidPriv(PostAnimateCurrentButton) configure -relief raised
    }
    if { $w != ""} {
	TryRoundRelief $w sunken
	#$w configure -relief sunken
    }
    if { $GidPriv(PostAnimateStepvalues) } { set GidPriv(PostAnimateTime) 0}
    set GidPriv(PostAnimateCurrentButton) $w
    #WarnWin "Rewind: $GidPriv(PostAnimateDoing)"
    if { $GidPriv(PostAnimateDoing) != "Animate"} {
	set GidPriv(PostAnimateDoing) Rewind
	set oldstepvalues $GidPriv(PostAnimateStepvalues)
	set oldskipframes $GidPriv(PostAnimateRangeFrames)
	set oldsave $GidPriv(PostAnimateSaveFrame)
	set oldsaveanim $GidPriv(PostAnimateSaveAnimation)
	set GidPriv(PostAnimateStepvalues) 0
	set GidPriv(PostAnimateRangeFrames) 0
	set GidPriv(PostAnimateSaveFrame) 0
	set GidPriv(PostAnimateSaveAnimation) 0
	PostAnimateFrame $GidPriv(PostAnimateCurrentFrame)
	set GidPriv(PostAnimateSaveFrame) $oldsave
	set GidPriv(PostAnimateSaveAnimation) $oldsaveanim
	set GidPriv(PostAnimateRangeFrames) $oldskipframes
	set GidPriv(PostAnimateStepvalues) $oldstepvalues
    } else {
	set GidPriv(PostAnimateDoing) Rewind
    }
}

proc PostAnimateStep { w} {
    global GidPriv

    #WarnWinText "PostAnimateStep"
    set oldskipframes $GidPriv(PostAnimateRangeFrames)
    set old $GidPriv(PostAnimateDefaultDelayTime)
    set oldduration $GidPriv(PostAnimateDuration)
    set olddurationtime $GidPriv(PostAnimateDefaultDurationTime)
    set oldstepvalues $GidPriv(PostAnimateStepvalues)
    set oldsave $GidPriv(PostAnimateSaveFrame)
    set oldsaveanim $GidPriv(PostAnimateSaveAnimation)
    set GidPriv(PostAnimateRangeFrames) 0
    set GidPriv(PostAnimateDefaultDelayTime) 0
    set GidPriv(PostAnimateDuration) 0
    set GidPriv(PostAnimateDefaultDurationTime) 0
    set GidPriv(PostAnimateStepvalues) 0
    set GidPriv(PostAnimateSaveFrame) 0
    set GidPriv(PostAnimateSaveAnimation) 0
    # para que tambien actualize las ventanas
    PostAnimatePlay $w 1
    PostAnimateStop $w
    set GidPriv(PostAnimateSaveAnimation) $oldsaveanim
    set GidPriv(PostAnimateSaveFrame) $oldsave
    set GidPriv(PostAnimateDefaultDelayTime) $old
    set GidPriv(PostAnimateDuration) $oldduration
    set GidPriv(PostAnimateDefaultDurationTime) $olddurationtime
    set GidPriv(PostAnimateStepvalues) $oldstepvalues
    set GidPriv(PostAnimateRangeFrames) $oldskipframes
}

proc PostAnimateMPEGLeds { estado} {
    global GidPriv

    set w $GidPriv(PostAnimateWindow)
    set led_libre $GidPriv(PostAnimateMPEG_led_libre)
    #set led_ocupado $GidPriv(PostAnimateMPEG_led_ocupado)

    switch $estado {
	DISABLED {
	    $w.f_anim.f.cv itemconfigure $led_libre -fill grey60
	    #$w.f_anim.f.cv itemconfigure $led_ocupado -fill grey60
	}
	FREE {
	    $w.f_anim.f.cv itemconfigure $led_libre -fill green
	    #$w.f_anim.f.cv itemconfigure $led_ocupado -fill grey60
	}
	BUSY {
	    $w.f_anim.f.cv itemconfigure $led_libre -fill red
	    #$w.f_anim.f.cv itemconfigure $led_ocupado -fill red
	}
	default {
	    WarnWin [_ "Unknown led state: %s" $estado] $GidPriv(PostAnimateWindow)
	    $w.f_anim.f.cv itemconfigure $led_libre -fill grey60
	    #$w.f_anim.f.cv itemconfigure $led_ocupado -fill grey60
	}
    }

}

proc PostAnimateTogleDelayEntry { name1 name2 op} {
    global GidPriv

    set w $GidPriv(PostAnimateWindow)
    if { $GidPriv(PostAnimateDelay) } {
	$w.f_dur.f_del.e configure -state normal -foreground black
	focus $w.f_dur.f_del.e
    } else {
	$w.f_dur.f_del.e configure -state disabled -foreground grey60
    }
}

proc PostAnimateTogleDurationEntry { name1 name2 op} {
    global GidPriv

    set w $GidPriv(PostAnimateWindow)
    if { $GidPriv(PostAnimateDuration) } {
	$w.f_dur.dur.e configure -state normal -foreground black
	focus $w.f_dur.dur.e
	#$w.f_dur.f_del.cb configure -state disabled -foreground grey60
	#$w.f_dur.f_del.e configure -state disabled -foreground grey60
	$w.f_dur.f_sca.cb configure -state normal -foreground black
	#set GidPriv(PostAnimateDelayTime) [expr {$GidPriv(PostAnimateDurationTime)*1000/$GidPriv(PostAnimateRangeFrameTo)}]
	
    } else {
	$w.f_dur.dur.e configure -state disabled -foreground grey60
	$w.f_dur.f_sca.cb configure -state disabled -foreground grey60
	#$w.f_dur.f_del.cb configure -state normal -foreground black
	#$w.f_dur.f_del.e configure -state normal -foreground black
    }
}

proc PostAnimateGetDurationType { name1 name2 op} {

    global GidPriv

    if { $GidPriv(PostAnimateDurationType) == "TotalTime" } {
	set GidPriv(PostAnimateDuration) 1
	set GidPriv(PostAnimateDelay) 0
	if { $GidPriv(PostAnimateDurationWStep) } {
	    set GidPriv(PostAnimateStepvalues) 1
	} else {
	    set GidPriv(PostAnimateStepvalues) 0
	}
    }

    if { $GidPriv(PostAnimateDurationType) == "Delay" } {
	set GidPriv(PostAnimateDuration) 0
	set GidPriv(PostAnimateDelay) 1
	set GidPriv(PostAnimateStepvalues) 0
    }

    if { $GidPriv(PostAnimateDurationType) == "StepValue" } {
	set GidPriv(PostAnimateDuration) 0
	set GidPriv(PostAnimateDelay) 0
	set GidPriv(PostAnimateStepvalues) 1
    }


}

proc PostAnimateTogleStepvaluesEntry { name1 name2 op} {
    global GidPriv

    set w $GidPriv(PostAnimateWindow)
    if { $GidPriv(PostAnimateStepvalues) } {
	#if { $GidPriv(PostAnimateDuration) } {
	#    set GidPriv(PostAnimateDurationOld) 1
	#    set GidPriv(PostAnimateDuration) 0
	#} else {
	#    set GidPriv(PostAnimateDurationOld) 0
	#}
	#$w.f_opt.f_dur.cb configure -state disabled -foreground grey60
	#$w.f_opt.f_dur.e configure -state disabled -foreground grey60
	#$w.f_opt.f_del.cb configure -state disabled -foreground grey60
	#$w.f_dur.f_del.e configure -state disabled -foreground grey60
	set GidPriv(PostAnimateDelayTime) 0
    } else {
	#$w.f_opt.f_dur.cb configure -state normal -foreground black
	#$w.f_opt.f_dur.e configure -state normal -foreground black
	#$w.f_opt.f_del.cb configure -state normal -foreground black
	#$w.f_dur.f_del.e configure -state normal -foreground black
	
	#set GidPriv(PostAnimateDuration) $GidPriv(PostAnimateDurationOld)
    }
}

proc PostAnimateTogleRangeFramesEntry { name1 name2 op} {
    global GidPriv

    set w $GidPriv(PostAnimateWindow)
    if { $GidPriv(PostAnimateRangeFrames) } {
       # if { $GidPriv(PostAnimateDuration) } {
	#    set GidPriv(PostAnimateDurationOld) 1
	    #set GidPriv(PostAnimateDuration) 0
	    #$w.f_opt.f_dur.e configure -state disabled -foreground grey60
	#} else {
	 #   set GidPriv(PostAnimateDurationOld) 0
	#}
	$w.f_opt.f_rangefr.ef configure -state normal -foreground black
	focus $w.f_opt.f_rangefr.ef
	$w.f_opt.f_rangefr.et configure -state normal -foreground black
	if { $GidPriv(PostAnimateRangeFrameFrom) == $GidPriv(PostAnimateRangeFrameTo)} {

	    set GidPriv(PostAnimateRangeFrameTo) [ llength $GidPriv(PostAnimate_all_step)]
	}
    } else {
	# set GidPriv(PostAnimateRangeFrameTo) [ llength $GidPriv(PostAnimate_all_step)]
	$w.f_opt.f_rangefr.ef configure -state disabled -foreground grey60
	$w.f_opt.f_rangefr.et configure -state disabled -foreground grey60
       # $w.f_opt.f_dur.cb configure -state normal -foreground black
	#$w.f_opt.f_dur.e configure -state normal -foreground black
	#set GidPriv(PostAnimateDuration) $GidPriv(PostAnimateDurationOld)
       # if { $GidPriv(PostAnimateStepvalues) } {
	#    set GidPriv(PostAnimateStepvalues) 0
	 #   set GidPriv(PostAnimateStepvalues) 1
	#}
    }
}

proc PostAnimateTogleSaveEntry { name1 name2 op} {
    global GidPriv

    set w $GidPriv(PostAnimateWindow)
    if { $GidPriv(PostAnimateSaveFrame) } {
	$w.f_save.f.f.cb configure -foreground black
	$w.f_save.f.f.mb configure -state normal
	$w.f_save.f.f.l configure -foreground black
	$w.f_save.f.b configure -state normal
	$w.f_save.e configure -state normal -foreground black
	focus $w.f_save.e
    } else {
	$w.f_save.f.f.cb configure -foreground grey60
	$w.f_save.f.f.mb configure -state disabled
	$w.f_save.f.f.l configure -foreground grey60
	$w.f_save.f.b configure -state disabled
	$w.f_save.e configure -state disabled -foreground grey60
    }
}

proc PostAnimateTogleMPEGLeds { name1 name2 op} {
    global GidPriv

    if { $GidPriv(PostAnimateSavingAnimation) == 0} {
	PostAnimateMPEGLeds FREE
    }

    if { $GidPriv(PostAnimateSavingAnimation) == 1} {
	PostAnimateMPEGLeds BUSY
    }
}

proc PostAnimateChangeExtension { new_format} {
    global GidPriv

    if { "$GidPriv(PostAnimateSaveAnimationFile)" == "" } { return}
    set w $GidPriv(PostAnimateWindow)

    set raiz [ file root "$GidPriv(PostAnimateSaveAnimationFile)"]
    set ext [ string tolower [ file extension "$GidPriv(PostAnimateSaveAnimationFile)"]]
    switch "$new_format" {
	"MPEG" {# $w.f_anim.e
	    if { ( "$ext" != ".mpeg") && ( "$ext" != ".mpg") } {
		if { ( "$ext" == ".avi") || ( "$ext" == ".gif") || ( "$ext" == "")} {
		    set GidPriv(PostAnimateSaveAnimationFile) ${raiz}.mpg
		}
	    }
	}
	"AVIMJPG" {
	    if { "$ext" != ".avi"} {
		if { ( "$ext" == ".mpeg") || ( "$ext" == ".mpg") || ( "$ext" == ".gif") || ( "$ext" == "")} {
		    set GidPriv(PostAnimateSaveAnimationFile) ${raiz}.avi
		}
	    }
	}
	"AVIMSVC" {
	    if { "$ext" != ".avi"} {
		if { ( "$ext" == ".mpeg") || ( "$ext" == ".mpg") || ( "$ext" == ".gif") || ( "$ext" == "")} {
		    set GidPriv(PostAnimateSaveAnimationFile) ${raiz}.avi
		}
	    }
	}
	"AVI" {
	    if { "$ext" != ".avi"} {
		if { ( "$ext" == ".mpeg") || ( "$ext" == ".mpg") || ( "$ext" == ".gif") || ( "$ext" == "")} {
		    set GidPriv(PostAnimateSaveAnimationFile) ${raiz}.avi
		}
	    }
	}
	"AVI15" {
	    if { "$ext" != ".avi"} {
		if { ( "$ext" == ".mpeg") || ( "$ext" == ".mpg") || ( "$ext" == ".gif") || ( "$ext" == "")} {
		    set GidPriv(PostAnimateSaveAnimationFile) ${raiz}.avi
		}
	    }
	}
	"AVI16" {
	    if { "$ext" != ".avi"} {
		if { ( "$ext" == ".mpeg") || ( "$ext" == ".mpg") || ( "$ext" == ".gif") || ( "$ext" == "")} {
		    set GidPriv(PostAnimateSaveAnimationFile) ${raiz}.avi
		}
	    }
	}
	"GIF" {
	    if { "$ext" != ".gif"} {
		if { ( "$ext" == ".mpeg") || ( "$ext" == ".mpg") || ( "$ext" == ".avi") || ( "$ext" == "")} {
		    set GidPriv(PostAnimateSaveAnimationFile) ${raiz}.gif
		}
	    }
	}
    }
}

proc PostAnimateTogleAnimEntry { name1 name2 op} {
    global GidPriv

    set w $GidPriv(PostAnimateWindow)
    if { $GidPriv(PostAnimateSaveAnimation) } {
	if {  [ info exists GidPriv(PostAnimateControlsSavingAnimation) ] && \
		$GidPriv(PostAnimateControlsSavingAnimation) } {
	    WarnWin "Sorry, but couldn't save the animation while another one is active (Animation Controls Window)"
	    set GidPriv(PostAnimateSaveAnimation) 0
	    return
	}
	$w.f_anim.f.f.cb configure -foreground black
	$w.f_anim.f.f.mb configure -state normal
	$w.f_anim.f.f.l configure -foreground black
	$w.f_anim.f.b configure -state normal
	$w.f_anim.e configure -state normal -foreground black
	focus $w.f_anim.e
	PostAnimateMPEGLeds FREE
	trace add variable GidPriv(PostAnimateSavingAnimation) write PostAnimateTogleMPEGLeds
    } else {
	$w.f_anim.f.f.cb configure -foreground grey60
	$w.f_anim.f.f.mb configure -state disabled
	$w.f_anim.f.f.l configure -foreground grey60
	$w.f_anim.f.b configure -state disabled
	$w.f_anim.e configure -state disabled -foreground grey60
	PostAnimateMPEGLeds DISABLED
	trace remove variable GidPriv(PostAnimateSavingAnimation) write PostAnimateTogleMPEGLeds
    }
}

proc PostAnimateCheckDelayTime { name1 name2 op} {
    global GidPriv
    set w $GidPriv(PostAnimateWindow)
    set len [string length $GidPriv(PostAnimateDelayTime)]
    set cur_digit [ string index $GidPriv(PostAnimateDelayTime) [ expr $len - 1]]
    if { ( $cur_digit >= 0) && ( $cur_digit <= 9)} { return}
    if { ( $cur_digit == "e") || ( $cur_digit == "E") ||
	 ( $cur_digit == "+") || ( $cur_digit == "-") || ( $cur_digit == ".")} {
	return
    }
    set GidPriv(PostAnimateDelayTime) [ string range $GidPriv(PostAnimateDelayTime) 0 [ expr $len-2]]
}

proc PostAnimateCheckDurationTime { name1 name2 op} {
    global GidPriv
    set w $GidPriv(PostAnimateWindow)
    set len [string length $GidPriv(PostAnimateDurationTime)]
    set cur_digit [ string index $GidPriv(PostAnimateDurationTime) [ expr $len - 1]]
    if { ( $cur_digit >= 0) && ( $cur_digit <= 9)} { return}
    if { ( $cur_digit == "e") || ( $cur_digit == "E") ||
	 ( $cur_digit == "+") || ( $cur_digit == "-") || ( $cur_digit == ".")} {
	return
    }
    set GidPriv(PostAnimateDurationTime) [ string range $GidPriv(PostAnimateDurationTime) 0 [ expr $len-2]]
}

proc PostAnimateCheckRangeFrame { { msg 1}} {
    global GidPriv

    set ok 0
    if { !$GidPriv(PostAnimateRangeFrames)} { return $ok}
    set w $GidPriv(PostAnimateWindow)
    set end_step [ llength $GidPriv(PostAnimate_all_step)]
    set ini_step 1
    if { $GidPriv(PostAnimateDeform)} {
	set ini_step 0
    }

    # el from
    if { [ string is integer $GidPriv(PostAnimateRangeFrameFrom)]} {
	if { ( $GidPriv(PostAnimateRangeFrameFrom) >= $ini_step) && \
		 ( $GidPriv(PostAnimateRangeFrameFrom) <= $end_step)} {
	    set ok 1
	}
    }
    if { !$ok} {
	set val_ant $GidPriv(PostAnimateRangeFrameFrom)
	set GidPriv(PostAnimateRangeFrameFrom) $ini_step
	if { $msg} {
	    WarnWin [ format [_ "Wrong initial step: '%s', should be between %d and %d."] \
		          $val_ant $ini_step $end_step]
	}
    }

    # el to
    if { $ok} {
	set ok 0
	if { [ string is integer $GidPriv(PostAnimateRangeFrameTo)]} {
	    if { ( $GidPriv(PostAnimateRangeFrameTo) >= 0) && ( $GidPriv(PostAnimateRangeFrameTo) <= $end_step)} {
		set ok 1
	    }
	}
	if { !$ok} {
	    set val_ant $GidPriv(PostAnimateRangeFrameTo)
	    set GidPriv(PostAnimateRangeFrameTo) $end_step
	    if { $msg} {
		WarnWin [ format [_ "Wrong final step: '%s', should be between %d and %d."] \
		              $val_ant $ini_step $end_step]
	    }
	}
    }

    # si from <= to
    if { $ok} {
	if { $GidPriv(PostAnimateRangeFrameFrom) > $GidPriv(PostAnimateRangeFrameTo)} {
	    set ok 0
	    set val_ant $GidPriv(PostAnimateRangeFrameFrom)
	    set GidPriv(PostAnimateRangeFrameFrom) $ini_step
	    if { $msg} {
		WarnWin [ format [_ "Crosing steps %d > %d."] \
		              $GidPriv(PostAnimateRangeFrameFrom) $GidPriv(PostAnimateRangeFrameTo)]
	    }
	}
    }
    #WarnWinText "  Check: $ini_step <= $GidPriv(PostAnimateRangeFrameFrom), $GidPriv(PostAnimateRangeFrameTo) <= $end_step = $ok"
    update idletasks
    return $ok
}

proc PostAnimateDoingSlide { } {
    global GidPriv

    if { $GidPriv(PostAnimateSlideDelay)} {
	set GidPriv(PostAnimateSlideDelay) [ expr $GidPriv(PostAnimateSlideDelay)-1]
	after 100 PostAnimateDoingSlide
    } else {
	set GidPriv(PostAnimateSlideDelay) 10
	if { $GidPriv(PostAnimateDoing) == "Nothing"} {
	    set oldskipframes $GidPriv(PostAnimateRangeFrames)
	    set old $GidPriv(PostAnimateDefaultDelayTime)
	    set old $GidPriv(PostAnimateDefaultDurationTime)
	    set oldsave $GidPriv(PostAnimateSaveFrame)
	    set oldsaveanim $GidPriv(PostAnimateSaveAnimation)
	    set GidPriv(PostAnimateRangeFrames) 0
	    set GidPriv(PostAnimateDefaultDelayTime) 0
	    set GidPriv(PostAnimateDefaultDurationTime) 0
	    set GidPriv(PostAnimateSaveFrame) 0
	    set GidPriv(PostAnimateSaveAnimation) 0
	    # para que tambien actualize las ventanas
	    PostAnimatePlay "" 1
	    PostAnimateStop ""
	    set GidPriv(PostAnimateRangeFrames) $oldskipframes
	    set GidPriv(PostAnimateSaveAnimation) $oldsaveanim
	    set GidPriv(PostAnimateSaveFrame) $oldsave
	    set GidPriv(PostAnimateDefaultDelayTime) $old
	    set GidPriv(PostAnimateDefaultDurationTime) $old
	}
	set GidPriv(PostAnimateSliding) 0
    }
}

proc PostAnimateChangeScale { frame} {
    global GidPriv

    if { $GidPriv(PostAnimateInitializing)} { return}
    if { $GidPriv(PostAnimateDoing) == "Nothing"} {
	set GidPriv(PostAnimateCurrentFrame) [ expr $frame-1]
	set GidPriv(PostAnimateSlideDelay) 10
	if { !$GidPriv(PostAnimateSliding) } {
	    after 100 PostAnimateDoingSlide
	    set GidPriv(PostAnimateSliding) 1
	}
    }
}

proc PostAnimateCheckedDeform {} {
    global GidPriv

    if { $GidPriv(PostAnimateDeform) } {
	set mainst [GiD_Info postprocess get main_geom_state]
	if { $mainst != "Deformed" } {
	    #WarnWin "Animation currently not supported for Main Geometry state $mainst"
	    WarnWin [_ "Please choose a Main Deformation Visualization first."] $GidPriv(PostAnimateWindow)
	    set GidPriv(PostAnimateDeform) 0
	    return
	}
    }

    PostAnimateConfigureSlide
}


proc PostAnimateCheckedContour {} {
    global GidPriv

    regsub -all {_} $GidPriv(PostAnimate_cur_resv) {} pepe
    set GidPriv(PostAnimate_cur_resv) $pepe
    if { $GidPriv(PostAnimateResultView) == "" } {
	#WarnWin "Animation currently not suported for Results View $cur_resv"
	WarnWin [_ "Please choose a Results Visualization first."] $GidPriv(PostAnimateWindow)
	set GidPriv(PostAnimateResultViewCb) 0
	return
    }

    if { $GidPriv(PostAnimateResultViewCb) } {
	#$GidPriv(PostAnimateResButtons).l configure -foreground black
	$GidPriv(PostAnimateResButtons).b1 configure -state normal
	#$GidPriv(PostAnimateResButtons).b2 configure -state normal
    } else {
	#$GidPriv(PostAnimateResButtons).l configure -foreground grey60
	$GidPriv(PostAnimateResButtons).b1 configure -state disabled
	#$GidPriv(PostAnimateResButtons).b2 configure -state disabled
    }
    #set GidPriv(PostAnimateAnalysisLimitsCb) 1

    PostAnimateConfigureSlide
}

proc PostAnimateCheckWhichAnimation {} {
    global GidPriv

    regsub -all {_} $GidPriv(PostAnimate_cur_resv) {} pepe
    set GidPriv(PostAnimate_cur_resv) $pepe
    if { $GidPriv(PostAnimateResultViewCb) && ( $GidPriv(PostAnimateResultView) == "") } {
	#WarnWin "Animation currently not suported for Results View $cur_resv"
	WarnWin [_ "Please choose a Results Visualization first. Or check 'Results' out."] $GidPriv(PostAnimateWindow)
	return 0
    }

    if { $GidPriv(PostAnimateDeform)  && ( $GidPriv(PostAnimate_cur_d_defor) == "")} {
	#set mainst [GiD_Info postprocess get main_geom_state]
	#if { $mainst != "Deformed" } {
	    #WarnWin "Animation currently not supported for Main Geometry state $mainst"
	WarnWin [_ "Please choose a Main Deformation Visualization first. Or check 'Deformation' out."] $GidPriv(PostAnimateWindow)
	    set GidPriv(PostAnimateDeform) 0
	    return 0
	#}
    }
    return 1
}

proc PostAnimateChooseSavePrefix {} {
    global GidPriv

    set GidPriv(PostAnimateSaveFrame) 1
    if { $GidPriv(PostAnimateSaveFrame) } {
	set w $GidPriv(PostAnimateWindow)
	if { "$GidPriv(PostAnimateSaveFrameFormat)" == "TIFF"} {
	    set GidPriv(PostAnimateSavePrefix) [Browser-ramR file write $w [_ "Prefix for '*.tif' files"]...]
	    if { [ regexp -nocase {(.*).tif$} $GidPriv(PostAnimateSavePrefix) dum prefix]} {
		set GidPriv(PostAnimateSavePrefix) $prefix
	    }
	    if { [ regexp -nocase {(.*).tiff$} $GidPriv(PostAnimateSavePrefix) dum prefix]} {
		set GidPriv(PostAnimateSavePrefix) $prefix
	    }
	} elseif { "$GidPriv(PostAnimateSaveFrameFormat)" == "JPEG"} {
	    set GidPriv(PostAnimateSavePrefix) [Browser-ramR file write $w [_ "Prefix for '*.jpg' files"]...]
	    if { [ regexp -nocase {(.*).jpg$} $GidPriv(PostAnimateSavePrefix) dum prefix]} {
		set GidPriv(PostAnimateSavePrefix) $prefix
	    }
	    if { [ regexp -nocase {(.*).jpeg$} $GidPriv(PostAnimateSavePrefix) dum prefix]} {
		set GidPriv(PostAnimateSavePrefix) $prefix
	    }
	} else {
	    set GidPriv(PostAnimateSavePrefix) [Browser-ramR file write $w [_ "Prefix for '*.gif' files"]...]
	    if { [ regexp -nocase {(.*).gif$} $GidPriv(PostAnimateSavePrefix) dum prefix]} {
		set GidPriv(PostAnimateSavePrefix) $prefix
	    }
	}
	#$w.f_save.e del 0 end
	#$w.f_save.e ins 0 $GidPriv(PostAnimateSavePrefix)
    }
}

proc PostAnimateChooseAnimationFile {} {
    global GidPriv

    set GidPriv(PostAnimateSaveAnimation) 1
    if { $GidPriv(PostAnimateSaveAnimation) } {
	set w $GidPriv(PostAnimateWindow)
	switch "$GidPriv(PostAnimateSaveAnimationFormat)" {
	    "MPEG" {
		set GidPriv(PostAnimateSaveAnimationFile) [Browser-ramR file write $w [_ "Save MPEG on"]... \
		{} {{{Mpeg animation} {.mpg .mpeg}} {{All files} {.*}}} ".mpg" ]
	    }
	    "AVIMJPG" {
		set GidPriv(PostAnimateSaveAnimationFile) [Browser-ramR file write $w [_ "Save AVI on"]... \
		{} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "AVIMSVC" {
		set GidPriv(PostAnimateSaveAnimationFile) [Browser-ramR file write $w [_ "Save AVI on"]... \
		{} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "AVI" {
		set GidPriv(PostAnimateSaveAnimationFile) [Browser-ramR file write $w [_ "Save AVI on"]... \
		{} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "AVI15" {
		set GidPriv(PostAnimateSaveAnimationFile) [Browser-ramR file write $w [_ "Save AVI on"]... \
		{} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "AVI16" {
		set GidPriv(PostAnimateSaveAnimationFile) [Browser-ramR file write $w [_ "Save AVI on"]... \
		{} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "GIF" {
		set GidPriv(PostAnimateSaveAnimationFile) [Browser-ramR file write $w [_ "Save GIF on"]... \
		{} {{{GIF animation} {.gif}} {{All files} {.*}}} ".gif" ]
	    }
	}
	#$w.f_anim.e del 0 end
	#$w.f_anim.e ins 0 $GidPriv(PostAnimateSaveAnimationFile)
    }
}

proc PostAnimatePushLimits {} {
    global GidPriv
    set GidPriv(PostAnimateSavedLimits) [ lindex [ GiD_Info postprocess get contour_limits] 0]
}

proc PostAnimatePopLimits {} {
    global GidPriv

    if { [ lindex $GidPriv(PostAnimateSavedLimits) 0] == "STD"} {
	GiD_Process Mescape Results ContOptions SetMinOptions ResetValue
    } else {
	GiD_Process Mescape Results ContOptions SetMinOptions SetValue [ lindex $GidPriv(PostAnimateSavedLimits) 1]
    }

    if { [ lindex $GidPriv(PostAnimateSavedLimits) 2] == "STD"} {
	GiD_Process Mescape Results ContOptions SetMaxOptions ResetValue
    } else {
	GiD_Process Mescape Results ContOptions SetMaxOptions SetValue [ lindex $GidPriv(PostAnimateSavedLimits) 3]
    }

}

proc PostAnimateGetAnalysisLimits { name1 name2 op} {
    global GidPriv

    if { $GidPriv(PostAnimateInitializing)} { return}
    if { $GidPriv(PostAnimateResultViewCb) && $GidPriv(PostAnimateAnalysisLimitsCb) } {
	PostAnimatePushLimits
	set GidPriv(PostAnimateInitializing) 1
#WarnWinText "hola($GidPriv(PostAnimateAnalysisLimitsCb)) -> $name1 $name2"
	# si hay varios resultados, buscamos los limites del c.fill/lines/rango
	if { $GidPriv(PostAnimateVariosResultados)} {
	    set GidPriv(PostAnimateOldAutoRedraw) [GiD_Set AutomaticRedraw]
#WarnWinText "old = $GidPriv(PostAnimateOldAutoRedraw)"
	    #DebugPostAnim "GET_lim AutomaticRedraw $GidPriv(PostAnimateOldAutoRedraw)"
	    #DebugPostAnim "SET_lim AutomaticRedraw -1"
	    GiD_Set AutomaticRedraw -1

	    GiD_Process Mescape results geometry noresults Mescape
	    # pintamos solo el c.fill para conseguir los limites
	    foreach estado_res $GidPriv(PostAnimateListaResultados) {
		set resv [ string tolower [ lindex $estado_res 1]]
		set res_name [ lindex $estado_res 4]
		set res_comp [ lindex $estado_res 5]
		set res_factor [ lindex $estado_res 6]
		regsub -all { } $resv {} resv
		if { $resv == "contourfill" || $resv == "smoothcontourfill" || \
		        $resv == "contourlines" || $resv == "contourranges" } {
		    GiD_Process Mescape $resv $res_name $res_comp
		}
	    }
	}
	GiD_Process Mescape Results ContOptions FixAnalysisLim
	set GidPriv(PostAnimateAnalysisLimits) [ lindex [ GiD_Info postprocess get contour_limits] 0]
#WarnWinText "analysis limits = $GidPriv(PostAnimateAnalysisLimits)"

	#devolvemos lo que estaba
	if { $GidPriv(PostAnimateVariosResultados)} {
	    GiD_Process Mescape results geometry noresults Mescape
	    if { $GidPriv(PostAnimateResultViewCb) && $GidPriv(PostAnimateResultView) != ""} {
		foreach estado_res $GidPriv(PostAnimateListaResultados) {
		    set resv [ string tolower [ lindex $estado_res 1]]
		    set res_name [ lindex $estado_res 4]
		    set res_comp [ lindex $estado_res 5]
		    set res_factor [ lindex $estado_res 6]
		    regsub -all { } $resv {} resv
		    if { $resv == "displayvectors"} {
		        GiD_Process Mescape results $resv $res_name $res_comp $res_factor
		    } elseif { $resv == "scalarlinediagram"} {
		        GiD_Process Mescape results LineDiagram ScalarDiagram $res_name $res_comp $res_factor
		    } elseif { $resv == "vectorlinediagram"} {
		        GiD_Process Mescape results LineDiagram VectorDiagram $res_name $res_factor
		    } else {
		        GiD_Process Mescape results $resv $res_name $res_comp
		    }
		}
	    }
	    #DebugPostAnim "GET_lim AutomaticRedraw $GidPriv(PostAnimateOldAutoRedraw)"
	    GiD_Set AutomaticRedraw $GidPriv(PostAnimateOldAutoRedraw)
	    #WarnWinText "dejando como antes =  $GidPriv(PostAnimateOldAutoRedraw)"
	}
	PostAnimatePopLimits
	set GidPriv(PostAnimateInitializing) 0
    }
}

proc PostAnimateSetAnalysisLimits {} {
    global GidPriv

    GiD_Process Mescape Results ContOptions SetMinOptions SetValue [ lindex $GidPriv(PostAnimateAnalysisLimits) 1]

    GiD_Process Mescape Results ContOptions SetMaxOptions SetValue [ lindex $GidPriv(PostAnimateAnalysisLimits) 3]
}

# this func is necessary to aviod the warning when going from pre to post
proc PostAnimateM { { w .gid.wPostAnimate } } {

    set mm [ GiD_Info postprocess get all_volumes]
    set ss [ GiD_Info postprocess get all_surfaces]
    if { ( $mm == "") && ( $ss == "") } {
	set w .gid
	if { [ info exists GidPriv(PostAnimateWindow)] && [ winfo exists $GidPriv(PostAnimateWindow)]} {
	    set w $GidPriv(PostAnimateWindow)
	}
	WarnWin [_ "Please load a model first."] $w
	return
    }
    PostAnimate $w
}

proc PostAnimateResize { } {
    global GidPriv

    set info [ wm geometry .gid]
    set info2 [.central.s configure]
    set height_list [ lindex $info2 0]
    set width_list [ lindex $info2 1]
    if { ![ regexp {([0-9]*)x([0-9]*)} $info trozo top_width top_height] } { return }
    set width_offset [ expr $top_width - [ lindex $width_list 4]]
    set height_offset [ expr $top_height - [ lindex $height_list 4]]

    if { "$GidPriv(PostAnimateResize)" == "Default"} {
	set GidPriv(PostAnimateResize) $GidPriv(PostAnimateResizeDefault)
    }
    if { ![ regexp {([0-9]*)x([0-9]*)} $GidPriv(PostAnimateResize) trozo new_width new_height] } { return }

    #WarnWinText ".gid = $info = $top_width x $top_height"
    #WarnWinText "togl = [ lindex $width_list 4]x[ lindex $height_list 4]"
    #WarnWinText "offset = $width_offset x $height_offset"
    ## 768x576 640x480 512x384 320x240
    wm geometry .gid [ expr $width_offset + $new_width]x[ expr $height_offset + $new_height]
}

proc PostAnimateCrearAnimacion { w} {
    global GidPriv AnimacionEstatica
    set win [ AnimacionEstatica::Crear $w]
    tkwait window $win

    if { $GidPriv(PostAnimateDeform)} {
	AnimacionEstaticaCreaFactores $GidPriv(PostAnimate_cur_d_factor)
	#WarnWin $AnimacionEstatica(factores)
	PostAnimateConfigureSlide
    }
    #WarnWin "Animacion $AnimacionEstatica(tipo) con $AnimacionEstatica(pasos) pasos"

}

proc PostAnimate { { w .gid.wPostAnimate } } {
    global GidPriv GIDDEFAULT AnimacionEstatica

    if { [ winfo exists $w]} {
	raise $w
	return
    }

    QuitaTraces
    set mm [ GiD_Info postprocess get all_volumes]
    set ss [ GiD_Info postprocess get all_surfaces]
    if { ( $mm == "") && ( $ss == "") } {
	return
    }

    set GidPriv(PostAnimateInitializing) 1
    PostAnimateInitValues

    InitWindow $w [_ "Animate"] PostAnimateWindowGeom PostAnimate
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
	
    # Las opciones
    frame $w.f_opt -relief ridge -bd 2



    #label $w.f_opt.l -text [_ "Check"]:
    frame $w.f_opt.res -bd 0
    checkbutton $w.f_opt.res.cb1 -text [_ "Results View"] -variable GidPriv(PostAnimateResultViewCb) \
	    -command PostAnimateCheckedContour
    frame $w.f_opt.res.opt -bd 0
    checkbutton $w.f_opt.res.opt.b1 -text [_ "Automatic Limits"] \
	    -variable GidPriv(PostAnimateAnalysisLimitsCb)
    grid $w.f_opt.res.opt.b1 -padx 22 -sticky we

    GidHelp $w.f_opt.res.cb1 [_ "The result view evolution is shown. \n\
	    NOTE: the results view should be selected previously."]
    GidHelp $w.f_opt.res.opt.b1 [_ "The limits of the results view will be the same for the whole animation."]

    set GidPriv(PostAnimateResButtons) $w.f_opt.res.opt
    #$GidPriv(PostAnimateResButtons).l configure -foreground grey60
    $GidPriv(PostAnimateResButtons).b1 configure -state disabled
    #$GidPriv(PostAnimateResButtons).b2 configure -state disabled

    grid $w.f_opt.res.cb1 -sticky w
    grid $w.f_opt.res.opt -sticky we
    grid rowconf $w.f_opt.res 1 -weight 1
    grid columnconf $w.f_opt.res 0 -weight 1

    checkbutton $w.f_opt.cb2 -text [_ "Deformation"] -variable GidPriv(PostAnimateDeform) \
	    -command PostAnimateCheckedDeform
    checkbutton $w.f_opt.cb3 -text [_ "Endless"] -variable GidPriv(PostAnimateEndless)

    GidHelp $w.f_opt.cb2 [_ "The evolution of the deformation is shown. \n\
	    NOTE: to use this option, the model should be deformed previously."]
    GidHelp $w.f_opt.cb3 [_ "After pressing the 'Play' button, the \
	    animation will not stop. \nNOTE: if the animation is saved, the entire disk may be filled."]

    frame $w.f_opt.f_rangefr
    checkbutton $w.f_opt.f_rangefr.cb -text [_ "From step"] -variable GidPriv(PostAnimateRangeFrames)
    entry $w.f_opt.f_rangefr.ef -relief sunken -width 5 -textvariable GidPriv(PostAnimateRangeFrameFrom) \
	-validate focus -validatecommand PostAnimateCheckRangeFrame
    label $w.f_opt.f_rangefr.lt -text [_ "to step"]
    entry $w.f_opt.f_rangefr.et -relief sunken -width 5 -textvariable GidPriv(PostAnimateRangeFrameTo) \
	-validate focus -validatecommand PostAnimateCheckRangeFrame
    $w.f_opt.f_rangefr.ef configure -state disabled -foreground grey60
    $w.f_opt.f_rangefr.et configure -state disabled -foreground grey60
    #label $w.f_opt.f_rangefr.l -text [_ "step(s)."]
    grid $w.f_opt.f_rangefr.cb $w.f_opt.f_rangefr.ef $w.f_opt.f_rangefr.lt $w.f_opt.f_rangefr.et -sticky w

    GidHelp $w.f_opt.f_rangefr [_ "With this option the first N steps will be skiped."]

    button $w.f_opt.static -text [_ "Static analysis animation profile"] -wraplength 65 -bd 1 \
	    -command "PostAnimateCrearAnimacion $w" -padx 8 -pady 3
    GidHelp $w.f_opt.static [_ "Configures the behaviour of the pseudo-animation\n \
	    of the deformation for analysis with only one step."]
    set AnimacionEstatica(boton) $w.f_opt.static

    #grid $w.f_opt.l
    grid $w.f_opt.res -sticky we
    grid $w.f_opt.cb2 -sticky w
    grid $w.f_opt.cb3 -sticky w
    grid $w.f_opt.f_rangefr -sticky w -columnspan 3
    #grid $w.f_opt.dt -sticky w
    #grid $w.f_opt.f_dur -sticky w
    #grid $w.f_opt.f_sca -sticky w
    #grid $w.f_opt.f_del -sticky w
    #grid $w.f_opt.cb4 -sticky w
    grid $w.f_opt.static -row 0 -column 1 -rowspan 3 -sticky e
    grid rowconf $w.f_opt 0 -weight 1
    grid columnconf $w.f_opt 0 -weight 1
    grid rowconf $w.f_opt 4 -weight 1
    grid rowconf $w.f_opt 5 -weight 1
    grid columnconf $w.f_opt 0 -weight 1

    frame $w.f_dur -relief ridge -bd 2

    label $w.f_dur.dt -text [_ "Set duration by"]:

    frame $w.f_dur.dur
    radiobutton $w.f_dur.dur.cb -text [_ "Total Time"]:  -value TotalTime -variable GidPriv(PostAnimateDurationType)
    entry $w.f_dur.dur.e -relief sunken -width 5 -textvariable GidPriv(PostAnimateDurationTime)
    $w.f_dur.dur.e configure -state normal -foreground black
    label $w.f_dur.dur.l -text [_ "s."]
    grid $w.f_dur.dur.cb $w.f_dur.dur.e $w.f_dur.dur.l -sticky w

    GidHelp $w.f_dur.dur [_ "With this option the duration of the animation /
	    will be set with the entered seconds."]

    frame $w.f_dur.f_sca
    checkbutton $w.f_dur.f_sca.cb -text [_ "use step values as scaled delays"] -variable GidPriv(PostAnimateDurationWStep)
    grid $w.f_dur.f_sca.cb -padx 44 -sticky we

    GidHelp $w.f_dur.f_dur [_ "With this option the duration of the animation /
	    will be scaled with the step values."]

    frame $w.f_dur.f_del
    radiobutton $w.f_dur.f_del.cb -text [_ "Delay between steps"]:  -value Delay -variable GidPriv(PostAnimateDurationType)
    entry $w.f_dur.f_del.e -relief sunken -width 5 -textvariable GidPriv(PostAnimateDelayTime)
    $w.f_dur.f_del.e configure -state disabled -foreground grey60
    label $w.f_dur.f_del.l -text [_ "ms."]
    #grid $w.f_opt.f_del.cb -sticky w
    #grid $w.f_opt.f_del.e -row 0 -column 1 -sticky w
    #grid $w.f_opt.f_del.l -row 0 -column 2 -sticky w
    grid $w.f_dur.f_del.cb $w.f_dur.f_del.e $w.f_dur.f_del.l -sticky w
    #grid rowconf $w.f_opt.f_del 0 -weight 1
    #grid columnconf $w.f_opt.f_del 1 -weight 1

    GidHelp $w.f_dur.f_del [_ "With this option a DelayTime of the entered milliseconds \
	    will be used between frames."]

    radiobutton $w.f_dur.cb4 -text [_ "Use step values as seconds"]  -value StepValue -variable GidPriv(PostAnimateDurationType)

    grid $w.f_dur.dt -sticky w
    grid $w.f_dur.dur -padx 22 -sticky w
    grid $w.f_dur.f_sca -padx 22 -sticky w
    grid $w.f_dur.f_del -padx 22 -sticky w
    grid $w.f_dur.cb4 -padx 22 -sticky w
    grid columnconf $w.f_dur 0 -weight 1
    grid rowconf $w.f_dur 0 -weight 1
    grid rowconf $w.f_dur 1 -weight 1
    grid rowconf $w.f_dur 2 -weight 1
    grid rowconf $w.f_dur 3 -weight 1
    grid rowconf $w.f_dur 4 -weight 1

    # los controles
    frame $w.f_ctr -relief ridge -bd 2

    # el chivato
    frame $w.f_ctr.f1
    label $w.f_ctr.f1.l -text [_ "Step number"]:
    entry $w.f_ctr.f1.e -relief sunken -width 6 -state disabled
    label $w.f_ctr.f1.lv -text [_ "Step value"]:
    entry $w.f_ctr.f1.ev -relief sunken -width 6 -state disabled
    label $w.f_ctr.f1.l2 -fg black -font SmallFont \
	    -textvariable GidPriv(PostAnimateFileSize)
    set GidPriv(PostAnimateFileSizeLabel) $w.f_ctr.f1.l2
    grid $w.f_ctr.f1.l -sticky e
    grid $w.f_ctr.f1.e -row 0 -column 1 -sticky w
    grid $w.f_ctr.f1.lv -row 0 -column 2 -sticky e
    grid $w.f_ctr.f1.ev -row 0 -column 3 -sticky w
    grid $w.f_ctr.f1.l2 -row 0 -column 4 -sticky ew
    grid rowconf $w.f_ctr.f1 0 -weight 1
    grid columnconf $w.f_ctr.f1 1 -weight 1
    grid columnconf $w.f_ctr.f1 3 -weight 1
    grid columnconf $w.f_ctr.f1 4 -weight 1

    scale $w.f_ctr.b -highlightthickness 0 -orient h -from 1 -to 2 -command PostAnimateChangeScale \
	-bd 1 -sliderlength 16
    #ttk::scale $w.f_ctr.b -orient horizontal -from 1 -to 2 -command PostAnimateChangeScale

    set GidPriv(PostAnimateSlide) $w.f_ctr.b
    set GidPriv(PostAnimateStepNumberEntry) $w.f_ctr.f1.e
    set GidPriv(PostAnimateStepValueEntry) $w.f_ctr.f1.ev

    frame $w.f_ctr.f2
    #use gif instead png because some problem on $::tcl_platform(os) == "Darwin" (maybe this problem has been solved)
    button $w.f_ctr.f2.play -image [GetImage play.gif] -command "PostAnimatePlay $w.f_ctr.f2.play"
    button $w.f_ctr.f2.stop -image [GetImage stop.gif] -command "PostAnimateStop $w.f_ctr.f2.stop"
    button $w.f_ctr.f2.rewind -image [GetImage rewind.gif] -command "PostAnimateRewind $w.f_ctr.f2.rewind"
    button $w.f_ctr.f2.step -image [GetImage skipforward.gif] -command "PostAnimateStep $w.f_ctr.f2.step"

    set leave_bg [$w.f_ctr.f2.play cget -background]
    set enter_bg [CCColorActivo $leave_bg]
    foreach item [list $w.f_ctr.f2.play $w.f_ctr.f2.stop $w.f_ctr.f2.rewind $w.f_ctr.f2.step] {
	bind $item <ButtonPress-1> "$item configure -bg $leave_bg"
	bind $item <Enter> "$item configure -bg $enter_bg "
	bind $item <Leave> "$item configure -bg $leave_bg"
	#$item configure -relief flat ;#hay que corregir muchas funciones que lo cambian
	TryRoundRelief $item raised 1
	#$item configure -relief raised
    }

    grid $w.f_ctr.f2.rewind $w.f_ctr.f2.stop $w.f_ctr.f2.play $w.f_ctr.f2.step -padx 2 -pady 2 -sticky we

    grid $w.f_ctr.f1 -sticky we
    grid $w.f_ctr.b -sticky we
    grid $w.f_ctr.f2 -sticky we
    grid columnconf $w.f_ctr 0 -weight 1
    grid rowconf $w.f_ctr 0 -weight 1
    grid rowconf $w.f_ctr 1 -weight 1
    grid rowconf $w.f_ctr 2 -weight 1

    frame $w.f_save
    frame $w.f_save.f
    frame $w.f_save.f.f -bd 0
    checkbutton $w.f_save.f.f.cb -text [_ "Save"] -variable GidPriv(PostAnimateSaveFrame)

    #ComboBoxRAM $w.f_save.f.f.mb GidPriv(PostAnimateSaveFrameFormat) \
    #            [list [_ "TIFF"] [_ "JPEG"] [_ "GIF"]] \
    #            {TIFF JPEG GIF}
    TTKMenubutton $w.f_save.f.f.mb -textvariable ::GidPriv(PostAnimateSaveFrameFormat) \
	-labels [list [_ "TIFF"] [_ "JPEG"] [_ "GIF"]] -values {TIFF JPEG GIF} \
	-width 10

    label $w.f_save.f.f.l -text [_ "on"]
    grid $w.f_save.f.f.cb $w.f_save.f.f.mb $w.f_save.f.f.l \
	    -padx 0 -ipadx 0 -pady 0 -ipady 0 -sticky nsew
    button $w.f_save.f.b -bd 1 -image [GetImage "openfold.gif"] -command PostAnimateChooseSavePrefix \
	-padx 8 -pady 3
    grid $w.f_save.f.f -sticky w
    grid $w.f_save.f.b -row 0 -column 1 -sticky e

    entry $w.f_save.e -relief sunken -width 5 -state disabled -textvariable GidPriv(PostAnimateSavePrefix)
		grid $w.f_save.f -sticky w
    grid $w.f_save.e -sticky we

    grid columnconf $w.f_save 0 -weight 1
    grid rowconf $w.f_save 0 -weight 1
    grid rowconf $w.f_save 1 -weight 1

    GidHelp $w.f_save [_ "To create a image sequence, the prefix of the images names must be entered here."]
    GidHelp $w.f_save.f.f.mb [_ "Choose the file format of the image sequence."]
    GidHelp $w.f_save.f.b [_ "A file browser will be openned, so a file can be selected."]

    frame $w.f_anim
    frame $w.f_anim.f
    frame $w.f_anim.f.f -bd 0

    checkbutton $w.f_anim.f.f.cb -text [_ "Save"] -variable GidPriv(PostAnimateSaveAnimation)

    # ComboBoxRAM $w.f_anim.f.f.mb GidPriv(PostAnimateSaveAnimationFormat) \
    #         [list [_ "MPEG"] [_ "AVI/mjpeg"] [_ "AVI/MS Video 1"] [_ "AVI/raw True Color"] \
    #              [_ "AVI/raw 15 bpp (VD)"] [_ "AVI/raw 16 bpp (MS)"] [_ "GIF"]] \
    #             {MPEG AVIMJPG AVIMSVC AVI AVI15 AVI16 GIF}
    TTKMenubutton $w.f_anim.f.f.mb -textvariable ::GidPriv(PostAnimateSaveAnimationFormat) \
	-labels [ list [_ "MPEG"] [_ "AVI/mjpeg"] [_ "AVI/MS Video 1"] [_ "AVI/raw True Color"] \
		      [_ "AVI/raw 15 bpp (VD)"] [_ "AVI/raw 16 bpp (MS)"] [_ "GIF"]] \
	-values {MPEG AVIMJPG AVIMSVC AVI AVI15 AVI16 GIF} \
	-width 16

    label $w.f_anim.f.f.l -text [_ "on"]
    grid $w.f_anim.f.f.cb $w.f_anim.f.f.mb $w.f_anim.f.f.l \
	    -padx 0 -ipadx 0 -pady 0 -ipady 0 -sticky nsew

    button $w.f_anim.f.b -bd 1 -image [GetImage "openfold.gif"] -command PostAnimateChooseAnimationFile \
	-padx 8 -pady 3
    canvas $w.f_anim.f.cv -width 18 -height 18
    set led_libre [ $w.f_anim.f.cv create oval 2 2 17 17 -fill grey60]
    #set led_ocupado [ $w.f_anim.f.cv create oval 20 2 35 17 -fill grey60]
    set GidPriv(PostAnimateMPEG_led_libre) $led_libre
    #set GidPriv(PostAnimateMPEG_led_ocupado) $led_ocupado
    PostAnimateMPEGLeds DISABLED

    GidHelp $w.f_anim.f.cv [_ "Animation status leds:\n\
	    Green: no animation is being done, \n\
		   the animation file is closed.\n\
	    Red:   GiD is storing frames ( added \n\
		   by the user, or storing redraws)\n\
		   in an opened animation file."]

    grid $w.f_anim.f.f -sticky w
    grid $w.f_anim.f.b -row 0 -column 1 -sticky e
    grid $w.f_anim.f.cv -row 0 -column 2 -sticky e -padx 2

    entry $w.f_anim.e -relief sunken -width 5 -state disabled -textvariable GidPriv(PostAnimateSaveAnimationFile)
    grid $w.f_anim.f -sticky w
    grid $w.f_anim.e -sticky we

    grid columnconf $w.f_anim 0 -weight 1
    grid rowconf $w.f_anim 0 -weight 1
    grid rowconf $w.f_anim 1 -weight 1

    GidHelp $w.f_anim [_ "Here the name of the animation file must be entered."]
    GidHelp $w.f_anim.f.f.mb [_ "Choose the file format of the animation file."]
    GidHelp $w.f_anim.f.b [_ "A file browser will be openned, so a file can be selected."]

    # close
    frame $w.f_but -bg [CCColorActivo [$w cget -background]]
    frame $w.f_but.siz -relief sunken -bd 1

    # ComboBoxRAM $w.f_but.siz.mb GidPriv(PostAnimateResize) \
    #             [list [_ "Default"] "800x600" "720x576" "640x480" "512x384" "352x288" "320x240"] \
    #             {Default 800x600 720x576 640x480 512x384 352x288 320x240}
    TTKMenubutton $w.f_but.siz.mb -textvariable ::GidPriv(PostAnimateResize) \
	-labels [ list [_ "Default"] \
		      "1920x1200" "1920x1080 HD" "1680x1050" "1680x945" \
		      "1440x900" "1440x810" "1366x768" \
		      "1280x1024" "1280x800" "1280x768" "1280x720 HD" \
		      "1024x768" "1024x640" "1024x600" "1024x576" \
		      "800x600" "720x576" "640x480" "512x384" "352x288" "320x240"] \
	-values {Default \
		     1920x1200 1920x1080 1680x1050 1680x945 \
		     1440x900 1440x810 1366x768 \
		     1280x1024 1280x800 1280x768 1280x720 \
		     1024x768 1024x640 1024x600 1024x576 \
		     800x600 720x576 640x480 512x384 352x288 320x240} \
	-width 10
    #other sizes "352x288 (VCD-PAL)" "352x240 (VCD-NTSC)

    button $w.f_but.siz.resize -text [_ "Resize"] \
	-command "PostAnimateResize; update; after 200; PostAnimateResize" \
	-bd 1 \
	-padx 8 -pady 3

    grid $w.f_but.siz.mb $w.f_but.siz.resize

    button $w.f_but.close -text [_ "Close"] -command "destroy $w" -padx 8 -pady 3
    SetWidgetsWidthFromText $w.f_but.siz.resize $w.f_but.close

    grid $w.f_but.siz -sticky w -ipady 1 -pady 1 -ipadx 1 -padx 1
    grid $w.f_but.close -column 1 -row 0 -sticky e -padx 2 -pady 3

    grid rowconf $w.f_but 0 -weight 1
    grid rowconf $w.f_but 1 -weight 1
    grid columnconf $w.f_but 0 -weight 1
    GidHelp $w.f_but.siz [_ "For MPEG files on windows its recommended \n\
	    to choose a windows-standard frame size:\n \
	    320x240 / 352x288 / 512x384 / 640x480 / 720x576 or 800x600"]
    GidHelp $w.f_but.siz.mb [_ "For MPEG files on windows its recommended \n\
	    to choose a windows-standard frame size:\n \
	    320x240 / 352x288 / 512x384 / 640x480 / 720x576 or 800x600"]
    GidHelp $w.f_but.siz.resize [_ "For MPEG files on windows its recommended \n\
	    to choose a windows-standard frame size:\n \
	    320x240 / 352x288 / 512x384 / 640x480 / 720x576 or 800x600"]

    grid $w.f_opt -sticky news
    grid $w.f_dur -sticky news
    grid $w.f_ctr -sticky news
    grid $w.f_save -sticky ew
    grid $w.f_anim -sticky ew
    grid $w.f_but -sticky sew
    if { $::tcl_version >= 8.5 } { grid anchor $w.f_but center }

    grid rowconf $w 1 -weight 1
    grid rowconf $w 2 -weight 1
    grid rowconf $w 3 -weight 1
    grid rowconf $w 0 -weight 1
    grid rowconf $w 4 -weight 1
    grid columnconf $w 0 -weight 1

    set GidPriv(PostAnimateInitializing) 0
    trace add variable GidPriv(PostAnimateDeform) write CambioPostAnimateDeform
    PostAnimateInitVariables
    update

    bind $w <Destroy> [list +DestroyPostAnimate %W $w]

    trace add variable GidPriv(PostAnimateDurationType) write PostAnimateGetDurationType

    trace add variable GidPriv(PostAnimateDelay) write PostAnimateTogleDelayEntry
    trace add variable GidPriv(PostAnimateDelayTime) write PostAnimateCheckDelayTime
    trace add variable GidPriv(PostAnimateDuration) write PostAnimateTogleDurationEntry
    trace add variable GidPriv(PostAnimateDurationTime) write PostAnimateCheckDurationTime
    trace add variable GidPriv(PostAnimateStepvalues) write PostAnimateTogleStepvaluesEntry
    trace add variable GidPriv(PostAnimateRangeFrames) write PostAnimateTogleRangeFramesEntry
    #trace add variable GidPriv(PostAnimateRangeFrameFrom) write PostAnimateCheckRangeFrame
    trace add variable GidPriv(PostAnimateSaveFrame) write PostAnimateTogleSaveEntry
    trace add variable GidPriv(PostAnimateSaveAnimation) write PostAnimateTogleAnimEntry
    trace add variable GidPriv(PostAnimateAnalysisLimitsCb) write PostAnimateGetAnalysisLimits

    #set GidPriv(PostAnimateDelay) 1

    if { !$GidPriv(PostAnimateSaveFrame) } {
	$w.f_save.f.f.cb configure -foreground grey60
	$w.f_save.f.f.mb configure -state disabled
	$w.f_save.f.f.l configure -foreground grey60
	$w.f_save.f.b configure -state disabled
	$w.f_save.e configure -state disabled -foreground grey60
    }
    if { !$GidPriv(PostAnimateSaveAnimation) } {
	$w.f_anim.f.f.cb configure -foreground grey60
	$w.f_anim.f.f.mb configure -state disabled
	$w.f_anim.f.f.l configure -foreground grey60
	$w.f_anim.f.b configure -state disabled
	$w.f_anim.e configure -state disabled -foreground grey60
    }


    #focus $w.f_but.close
    bind $w <Escape> "tkButtonInvoke $w.f_but.close"

    set GidPriv(PostAnimateAnalysisLimitsCb) 1
}

proc QuitaTraces {} {
    global GidPriv
    trace remove variable GidPriv(PostAnimateDelay) write PostAnimateTogleDelayEntry
    trace remove variable GidPriv(PostAnimateDelayTime) write PostAnimateCheckDelayTime
    trace remove variable GidPriv(PostAnimateDuration) write PostAnimateTogleDurationEntry
    trace remove variable GidPriv(PostAnimateDurationTime) write PostAnimateCheckDurationTime
    trace remove variable GidPriv(PostAnimateStepvalues) write PostAnimateTogleStepvaluesEntry
    trace remove variable GidPriv(PostAnimateRangeFrames) write PostAnimateTogleRangeFramesEntry
    #trace remove variable GidPriv(PostAnimateRangeFrameFrom) write PostAnimateCheckRangeFrame
    trace remove variable GidPriv(PostAnimateSaveFrame) write PostAnimateTogleSaveEntry
    trace remove variable GidPriv(PostAnimateSaveAnimation) write PostAnimateTogleAnimEntry
    trace remove variable GidPriv(PostAnimateAnalysisLimitsCb) write PostAnimateGetAnalysisLimits
    trace remove variable GidPriv(PostAnimateSavingAnimation) write PostAnimateTogleMPEGLeds
    trace remove variable GidPriv(PostAnimateDeform) write CambioPostAnimateDeform
}

proc DestroyPostAnimate { W  w } {
    if { $W != $w } return
    global GidPriv
    set GidPriv(PostAnimateDoing) Stop
    AnimacionEstatica::Cerrar
    QuitaTraces
}

proc PostAnimateShowFileSize { } {
    global GidPriv

    if { ( [info exists GidPriv(PrePostAnimateWindow)] && [ winfo exists $GidPriv(PrePostAnimateWindow)]) || \
	( [info exists GidPriv(PostAnimateWindow)] && [ winfo exists $GidPriv(PostAnimateWindow)])} {
	file stat "$GidPriv(PostAnimateSaveAnimationFile)" pp
# GidPriv(PostAnimateCurrentFrame) GidPriv(PostAnimateDefaultDelayTime)
	# set GidPriv(PostAnimateFileSize) "[format \"%.3g MB\" [ expr $pp(size)/(1024.0*1024.0)]]"
	if { ![ catch { set pp [ expr $GidPriv(PostAnimateDelayTime)]}] } {
	    set GidPriv(PostAnimateTime) [ expr $GidPriv(PostAnimateTime) + $GidPriv(PostAnimateDelayTime)]
	}
	set time [ expr $GidPriv(PostAnimateTime) / 1000]
	set GidPriv(PostAnimateFileSize) [format "%02d:%02d - %.3gMB" [ expr int( $time / 60)] [ expr int( $time % 60)] [ expr $pp(size)/(1024.0*1024.0)]]
    }
}

proc PostAnimateShowTime { } {
    global GidPriv

    if { ( [info exists GidPriv(PrePostAnimateWindow)] && [ winfo exists $GidPriv(PrePostAnimateWindow)]) || \
	( [info exists GidPriv(PostAnimateWindow)] && [ winfo exists $GidPriv(PostAnimateWindow)])} {
	if { ![ catch { set pp [ expr $GidPriv(PostAnimateDelayTime)]}] } {
	    set GidPriv(PostAnimateTime) [ expr $GidPriv(PostAnimateTime) + $GidPriv(PostAnimateDelayTime)]
	}
	set time [ expr $GidPriv(PostAnimateTime) / 1000]
	set GidPriv(PostAnimateFileSize) [format "%02d:%02d" [ expr $time / 60] [ expr $time % 60]]
    }
}

######################################################################
##### Animation Controls Window #####
######################################################################

proc PostAnimateControlsResize { } {
    global GidPriv

    set info [ wm geometry .gid]
    set info2 [.central.s configure]
    set height_list [ lindex $info2 0]
    set width_list [ lindex $info2 1]
    if { ![ regexp {([0-9]*)x([0-9]*)} $info trozo top_width top_height] } { return }
    set width_offset [ expr $top_width - [ lindex $width_list 4]]
    set height_offset [ expr $top_height - [ lindex $height_list 4]]

    if { $GidPriv(PostAnimateControlsResize) == "Default"} {
	set GidPriv(PostAnimateControlsResize) $GidPriv(PostAnimateControlsResizeDefault)
    }
    if { ![ regexp {([0-9]*)x([0-9]*)} $GidPriv(PostAnimateControlsResize) trozo new_width new_height] } { return }

    #WarnWinText ".gid = $info = $top_width x $top_height"
    #WarnWinText "togl = [ lindex $width_list 4]x[ lindex $height_list 4]"
    #WarnWinText "offset = $width_offset x $height_offset"
    ## 768x576 640x480 512x384 320x240
    wm geometry .gid [ expr $width_offset + $new_width]x[ expr $height_offset + $new_height]
}

proc PostAnimateControlsInitValues {} {
    global GidPriv

    set GidPriv(PostAnimateControlsDoing) Nothing
    set GidPriv(PostAnimateControlsDefaultDelayTime) 200
    if { ![ info exists GidPriv(PostAnimateControlsDelayTime)]} {
	set GidPriv(PostAnimateControlsDelayTime) $GidPriv(PostAnimateControlsDefaultDelayTime)
    }

    set GidPriv(PostAnimateControlsDefaultDurationTime) 200
    if { ![ info exists GidPriv(PostAnimateControlsDurationTime)]} {
	set GidPriv(PostAnimateControlsDurationTime) $GidPriv(PostAnimateControlsDefaultDurationTime)
    }

    set GidPriv(PostAnimateControlsDelay) 0
    set GidPriv(PostAnimateControlsDuration) 0
    set GidPriv(PostAnimateControlsSaveAnimation) 0
    set GidPriv(PostAnimateControlsSavingAnimation) 0
    set GidPriv(PostAnimateControlsSavingRepes) 1
    set GidPriv(PostAnimateControlsSaveAnimationFormat) [GiD_Info postprocess get animationformat]
    set GidPriv(PostAnimateControlsSaveFrameFormat) "TIFF"
    set GidPriv(PostAnimateControlsSaveAnimationFormat) AVIMJPG
    set info2 [.central.s configure]
    set height_list [ lindex $info2 0]
    set width_list [ lindex $info2 1]
    set current [format "%dx%d" [ lindex $width_list 4] [ lindex $height_list 4]]
    set GidPriv(PostAnimateControlsResizeDefault) "$current"
    set GidPriv(PostAnimateControlsResize) Default

    set GidPriv(PostAnimateControlsLastFile) ""
    if { ![ info exists GidPriv(PostAnimateControlsSaveRedraws)]} {
	set GidPriv(PostAnimateControlsSaveRedraws) 0
    }
    set GidPriv(PostAnimateControlsDisableList) ""
    set GidPriv(PostAnimateControlsDisableColorList) ""
    set GidPriv(PostAnimateControlsFileSize) ""
    set GidPriv(PostAnimateControlsTime) 0
}

proc PostAnimateControlsMPEGLeds { estado } {
    global GidPriv

    set w $GidPriv(PostAnimateControlsMPEGCanvas)
    set led_libre $GidPriv(PostAnimateControlsMPEG_led_libre)

    switch $estado {
	DISABLED {
	    $w itemconfigure $led_libre -fill grey60
	}
	FREE {
	    $w itemconfigure $led_libre -fill green
	}
	BUSY {
	    $w itemconfigure $led_libre -fill red
	}
	default {
	    WarnWin [_ "Unknown led state: %s" $estado] $GidPriv(PostAnimateControlsWindow)
	    $w itemconfigure $led_libre -fill grey60
	}
    }

}

proc PostAnimateControlsTogleDelayEntry { name1 name2 op} {
    global GidPriv

    set w $GidPriv(PrePostAnimateControlsWindow)
    if { $GidPriv(PostAnimateControlsDelay) } {
	$w.f_opt.f_del.e configure -state normal -foreground black
	focus $w.f_opt.f_del.e
    } else {
	$w.f_opt.f_del.e configure -state disabled -foreground grey60
    }
}

proc PostAnimateControlsTogleDurationEntry { name1 name2 op} {
    global GidPriv

    set w $GidPriv(PrePostAnimateControlsWindow)
    if { $GidPriv(PostAnimateControlsDuration) } {
	$w.f_opt.f_dur.e configure -state normal -foreground black
	focus $w.f_opt.f_dur.e
    } else {
	$w.f_opt.f_dur.e configure -state disabled -foreground grey60
    }
}


proc PostAnimateControlsTogleMPEGLeds { name1 name2 op} {
    global GidPriv

    if { $GidPriv(PostAnimateControlsSavingAnimation) == 0} {
	PostAnimateControlsMPEGLeds FREE
	foreach i $GidPriv(PostAnimateControlsDisableList) {
	    $i configure -state normal
	}
	foreach i $GidPriv(PostAnimateControlsDisableColorList) {
	    $i configure -foreground black
	}
    }

    if { $GidPriv(PostAnimateControlsSavingAnimation) == 1} {
	PostAnimateControlsMPEGLeds BUSY
	foreach i $GidPriv(PostAnimateControlsDisableList) {
	    $i configure -state disabled
	}
	foreach i $GidPriv(PostAnimateControlsDisableColorList) {
	    $i configure -foreground grey60
	}
    }
}

proc PostAnimateControlsTogleAnimEntry { name1 name2 op} {
    global GidPriv

    set w $GidPriv(PrePostAnimateControlsWindow)
    if { $GidPriv(PostAnimateControlsSaveAnimation) } {
	$w.f_opt.f_anim.e configure -state normal -foreground black
	focus $w.f_opt.f_anim.e
	PostAnimateControlsMPEGLeds FREE
	trace add variable GidPriv(PostAnimateControlsSavingAnimation) write PostAnimateControlsTogleMPEGLeds
    } else {
	$w.f_opt.f_anim.e configure -state disabled -foreground grey60
	PostAnimateControlsMPEGLeds DISABLED
	trace remove variable GidPriv(PostAnimateControlsSavingAnimation) write PostAnimateControlsTogleMPEGLeds
    }
}

proc PostAnimateControlsCheckDelayTime { name1 name2 op} {
    global GidPriv

    set w $GidPriv(PrePostAnimateControlsWindow)
    set len [string length $GidPriv(PostAnimateControlsTime)]
    set cur_digit [ string index $GidPriv(PostAnimateControlsDelayTime) [ expr $len - 1]]
    if { ( $cur_digit >= 0) && ( $cur_digit <= 9)} { return}
    if { ( $cur_digit == "e") || ( $cur_digit == "E") ||
    ( $cur_digit == "+") || ( $cur_digit == "-") || ( $cur_digit == ".")} {
	return
    }
    set GidPriv(PostAnimateControlsDelayTime) [ string range $GidPriv(PostAnimateControlsDelayTime) 0 [ expr $len-2]]
}

proc PostAnimateControlsAddStep { w} {
    global GidPriv

    if { $w != ""} {
	TryRoundRelief $w sunken
	#$w configure -relief sunken
    }

    if { ( [ info exists GidPriv(PostAnimateSaveAnimation) ] && \
	    $GidPriv(PostAnimateSaveAnimation)) || \
	    ( [ info exists GidPriv(PostAnimateSavingAnimation) ] && \
	    $GidPriv(PostAnimateSavingAnimation)) } {
	WarnWin "Sorry, but couldn't save the animation while another one is active (Post Animate Window)"
	if { $w != ""} {
	    TryRoundRelief $w raised
	    #$w configure -relief raised
	}
	return
    }

    if { !$GidPriv(PostAnimateControlsSavingAnimation)} {
	if { "$GidPriv(PostAnimateControlsSaveAnimationFile)" == ""} {
	    WarnWin [_ "Sorry but a file name is needed to save the animation."] $w
	    if { $w != ""} {
		TryRoundRelief $w raised
		#$w configure -relief raised
	    }
	    return
	} else {

	    if { "$GidPriv(PostAnimateControlsLastFile)" == "$GidPriv(PostAnimateControlsSaveAnimationFile)" } {
		set resp [ tk_messageBox -parent $GidPriv(PrePostAnimateControlsWindow) -icon warning -type yesno \
		        -default no -message \
		        "Warning: Do you want to overwrite the file '$GidPriv(PostAnimateControlsSaveAnimationFile)'?" ]
		if { $resp == "no"} {
		    if { $w != ""} {
		        TryRoundRelief $w raised
		        #$w configure -relief raised
		    }
		    return
		}
	    }

	    if { !$GidPriv(PostAnimateControlsDelay) } {
		WarnWin [_ "There is no delay selected, using default of 200 ms. \n If you want no delay, please check the delay time entry."] $w
	    }

	    if { ![ PostAnimateVerificaPermisos $w $GidPriv(PostAnimateControlsSaveAnimationFile)]} {
		if { $w != ""} {
		    TryRoundRelief $w raised
		    #$w configure -relief raised
		}
		return
	    }

	    GiD_Process animationfile format $GidPriv(PostAnimateControlsSaveAnimationFormat)

	    if { $GidPriv(PostAnimateControlsSaveRedraws) } {
		GiD_Process animationfile SaveRedraws Yes
	    }
	
	    if { ( "$GidPriv(PostAnimateControlsSaveAnimationFormat)" == "AVIMJPG") || \
		    ( "$GidPriv(PostAnimateControlsSaveAnimationFormat)" == "AVIMSVC") || \
		    ( "$GidPriv(PostAnimateControlsSaveAnimationFormat)" == "AVI") || \
		    ( "$GidPriv(PostAnimateControlsSaveAnimationFormat)" == "AVI15") || \
		    ( "$GidPriv(PostAnimateControlsSaveAnimationFormat)" == "AVI16")} {
		set info2 [.central.s configure]
		set height_list [ lindex $info2 0]
		set width_list [ lindex $info2 1]
		set width [ lindex $width_list 4]
		set height [ lindex $height_list 4]
		
		set avisize [ expr $width * $height * 1]
		if { "$GidPriv(PostAnimateControlsSaveAnimationFormat)" == "AVIMJPG" } {
		    # estimacion aproximada
		    set avisize [ expr $avisize * 3 * 0.1]
		} elseif { "$GidPriv(PostAnimateControlsSaveAnimationFormat)" == "AVIMSVC" } {
		    # estimacion aproximada
		    set avisize [ expr $avisize * 3 * 0.15]
		} elseif { "$GidPriv(PostAnimateControlsSaveAnimationFormat)" == "AVI" } {
		    set avisize [ expr $avisize * 3]
		} else {
		    set avisize [ expr $avisize * 2]
		}
		set avisize [ expr ( $avisize / 1024.0) / 1024.0]
		
		if { $avisize > 95.00 } {
		    set resp [ tk_messageBox -parent $GidPriv(PrePostAnimateControlsWindow) -icon warning -type yesno \
		            -default no -message \
		            "Warning: the AVI file will be [ format %.3g $avisize] MB big !!!\n Are you sure you want continue?" ]
		    if { $resp == "no"} {
		        if { $w != ""} {
		            TryRoundRelief $w raised
		            #$w configure -relief raised
		        }
		        return
		    }
		}
		#WarnWin "The AVI file will be [ format %.3g $avisize] MB big !!!"
	    }
	
	    # Frame rate = 25 FPS == 40 ms.
	    set repe 1
	    if { $GidPriv(PostAnimateControlsDelay) } {
		if { ( $GidPriv(PostAnimateControlsDelayTime) == 0) && \
		        ( "$GidPriv(PostAnimateControlsSaveAnimationFormat)" == "MPEG") } {
		    set resp [ tk_messageBox -parent $GidPriv(PrePostAnimateControlsWindow) -icon warning -type yesno \
		            -default no -message \
		            "Saving a MPEG animation file without delay between Steps can cause some strange efects in Microsoft Windows 95/98/NT.\n Are you sure you want continue?" ]
		    if { $resp == "no"} {
		        if { $w != ""} {
		            TryRoundRelief $w raised
		            #$w configure -relief raised
		        }
		        return
		    }
		}
		#            set repe [ expr int(0.5 + $GidPriv(PostAnimateControlsDefaultDelayTime)/40.0)]
		set repe [ expr int(0.5 + $GidPriv(PostAnimateControlsDelayTime)/40.0)]
		if { $repe == 0} { set repe 1}
	    } else {
		# por defecto 200 ms # medio segundo
		set repe [ expr int(0.5 + 200.0/40.0)]
		if { $repe == 0} { set repe 1}
	    }

	    set GidPriv(PostAnimateControlsSavingRepes) $repe
	    GiD_Process animationfile framesperstep \
		    $GidPriv(PostAnimateControlsSavingRepes) escape escape escape escape
	    GiD_Process animationfile start \
		    \"$GidPriv(PostAnimateControlsSaveAnimationFile)\" yes escape escape escape escape
	    set GidPriv(PostAnimateControlsSavingAnimation) 1
	    update

	    # para mostrar al usuario el tamanyo del archivo
	    #$GidPriv(PostAnimateControlsFileSizeLabel) configure -fg black
	    set GidPriv(PostAnimateControlsTime) 0
	}
    }

    if { $GidPriv(PostAnimateControlsSavingAnimation)} {
	if { $GidPriv(PostAnimateControlsSavingAnimation) } {
	    GiD_Process animationfile addstep
	    #PostAnimateControlsShowFileSize
	}
    }

    if { $w != ""} {
	TryRoundRelief $w raised
	#$w configure -relief raised
    }
}

proc PostAnimateControlsShowFileSize { } {
    global GidPriv

    if { ( [info exists GidPriv(PrePostAnimateControlsWindow)] && [ winfo exists $GidPriv(PrePostAnimateControlsWindow)]) || \
	( [info exists GidPriv(PostAnimateControlsWindow)] && [ winfo exists $GidPriv(PostAnimateControlsWindow)])} {
	file stat "$GidPriv(PostAnimateControlsSaveAnimationFile)" pp
# GidPriv(PostAnimateControlsCurrentFrame) GidPriv(PostAnimateControlsDefaultDelayTime)
	# set GidPriv(PostAnimateControlsFileSize) "[format \"%.3g MB\" [ expr $pp(size)/(1024.0*1024.0)]]"
	set GidPriv(PostAnimateControlsTime) [ expr $GidPriv(PostAnimateControlsTime) + $GidPriv(PostAnimateControlsDelayTime)]
	set time [ expr $GidPriv(PostAnimateControlsTime) / 1000]
	set GidPriv(PostAnimateControlsFileSize) [format "%02d:%02d - %.3gMB" [ expr int( $time / 60)] [ expr int( $time % 60)] [ expr $pp(size)/(1024.0*1024.0)]]
    }
}

proc PostAnimateControlsShowTime { } {
    global GidPriv

    if { ( [info exists GidPriv(PrePostAnimateControlsWindow)] && [ winfo exists $GidPriv(PrePostAnimateControlsWindow)]) || \
	( [info exists GidPriv(PostAnimateControlsWindow)] && [ winfo exists $GidPriv(PostAnimateControlsWindow)])} {
	set GidPriv(PostAnimateControlsTime) [ expr $GidPriv(PostAnimateControlsTime) + $GidPriv(PostAnimateControlsDelayTime)]
	set time [ expr $GidPriv(PostAnimateControlsTime) / 1000]
	set GidPriv(PostAnimateControlsFileSize) [format "%02d:%02d" [ expr $time / 60] [ expr $time % 60]]
    }
}

proc PostAnimateControlsEndAnim { w} {
    global GidPriv

    if { $w != ""} {
	TryRoundRelief $w sunken
	#$w configure -relief sunken
    }

    if { $GidPriv(PostAnimateControlsSavingAnimation) } {
	GiD_Process animationfile end
	set GidPriv(PostAnimateControlsSavingAnimation) 0
	set GidPriv(PostAnimateControlsLastFile) $GidPriv(PostAnimateControlsSaveAnimationFile)
	if { $GidPriv(PostAnimateControlsSaveRedraws) } {
	    GiD_Process animationfile SaveRedraws No
	}
	#$GidPriv(PostAnimateControlsFileSizeLabel) configure -fg grey60
    }

    if { $w != ""} {
	TryRoundRelief $w raised
	#$w configure -relief raised
    }
}

proc PostAnimateControlsChooseAnimationFile {} {
    global GidPriv

    if { $GidPriv(PostAnimateControlsSaveAnimation) } {
	set w $GidPriv(PrePostAnimateControlsWindow)
	switch "$GidPriv(PostAnimateControlsSaveAnimationFormat)" {
	    "MPEG" {
		set GidPriv(PostAnimateControlsSaveAnimationFile) [Browser-ramR file write $w [_ "Save MPEG on"]... \
		{} {{{Mpeg animation} {.mpg .mpeg}} {{All files} {.*}}} ".mpg" ]
	    }
	    "AVIMJPG" {
		set GidPriv(PostAnimateControlsSaveAnimationFile) [Browser-ramR file write $w [_ "Save AVI on"]... \
		{} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "AVIMSVC" {
		set GidPriv(PostAnimateControlsSaveAnimationFile) [Browser-ramR file write $w [_ "Save AVI on"]... \
		{} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "AVI" {
		set GidPriv(PostAnimateControlsSaveAnimationFile) [Browser-ramR file write $w [_ "Save AVI on"]... \
		{} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "AVI15" {
		set GidPriv(PostAnimateControlsSaveAnimationFile) [Browser-ramR file write $w [_ "Save AVI on"]... \
		{} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "AVI16" {
		set GidPriv(PostAnimateControlsSaveAnimationFile) [Browser-ramR file write $w [_ "Save AVI on"]... \
		{} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "GIF" {
		set GidPriv(PostAnimateControlsSaveAnimationFile) [Browser-ramR file write $w [_ "Save GIF on"]... \
		{} {{{GIF animation} {.gif}} {{All files} {.*}}} ".gif" ]
	    }
	}
	#$w.f_anim.e del 0 end
	#$w.f_anim.e ins 0 $GidPriv(PostAnimateControlsSaveAnimationFile)
    }
}

proc PostAnimateControls { { w .gid.wPostAnimateControls } } {
    global GidPriv

    if { [ winfo exists $w] } {return}


    set GidPriv(PostAnimateControlsInitializing) 1
    PostAnimateControlsInitValues

    InitWindow $w [_ "Animation Controls"] PrePostAnimateControlsWindowGeom PostAnimateControls
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0

    set color_fondo [CCGetRGB $w [$w cget -background]]

    # Las opciones
    frame $w.f_opt -relief ridge -bd 2

    frame $w.f_opt.f_del
    checkbutton $w.f_opt.f_del.cb -text [_ "Delay"]: -variable GidPriv(PostAnimateControlsDelay)
    entry $w.f_opt.f_del.e -relief sunken -width 5 -textvariable GidPriv(PostAnimateControlsDelayTime)
    $w.f_opt.f_del.e configure -state disabled -foreground grey60
    label $w.f_opt.f_del.l -text [_ "ms."]
    grid $w.f_opt.f_del.cb -sticky w
    grid $w.f_opt.f_del.e -row 0 -column 1 -sticky we
    grid $w.f_opt.f_del.l -row 0 -column 2 -sticky e
    grid rowconf $w.f_opt.f_del 0 -weight 1
    grid columnconf $w.f_opt.f_del 1 -weight 1

    lappend GidPriv(PostAnimateControlsDisableList) $w.f_opt.f_del.cb
    lappend GidPriv(PostAnimateControlsDisableList) $w.f_opt.f_del.e
    lappend GidPriv(PostAnimateControlsDisableColorList) $w.f_opt.f_del.l

    frame $w.f_opt.f_dur
    checkbutton $w.f_opt.f_dur.cb -text [_ "Duration"]: -variable GidPriv(PostAnimateControlsDuration)
    entry $w.f_opt.f_dur.e -relief sunken -width 5 -textvariable GidPriv(PostAnimateControlsDurationTime)
    $w.f_opt.f_dur.e configure -state disabled -foreground grey60
    label $w.f_opt.f_dur.l -text [_ "s."]
    grid $w.f_opt.f_dur.cb -sticky w
    grid $w.f_opt.f_dur.e -row 0 -column 1 -sticky we
    grid $w.f_opt.f_dur.l -row 0 -column 2 -sticky e
    grid rowconf $w.f_opt.f_dur 0 -weight 1
    grid columnconf $w.f_opt.f_dur 1 -weight 1

    lappend GidPriv(PostAnimateControlsDisableList) $w.f_opt.f_dur.cb
    lappend GidPriv(PostAnimateControlsDisableList) $w.f_opt.f_dur.e
    lappend GidPriv(PostAnimateControlsDisableColorList) $w.f_opt.f_dur.l

		
    frame $w.f_opt.f_anim
    frame $w.f_opt.f_anim.f
    frame $w.f_opt.f_anim.f.f -bd 0
    label $w.f_opt.f_anim.f.f.cb -text [_ "Save"]

    #ComboBoxRAM $w.f_opt.f_anim.f.f.mb GidPriv(PostAnimateControlsSaveAnimationFormat) \
    #            [list [_ "MPEG"] [_ "AVI/mjpeg"] [_ "AVI/MS Video 1"] [_ "AVI/raw True Color"] \
    #                 [_ "AVI/raw 15 bpp (VD)"] [_ "AVI/raw 16 bpp (MS)"] [_ "GIF"]] \
    #            {MPEG AVIMJPG AVIMSVC AVI AVI15 AVI16 GIF}
    TTKMenubutton $w.f_opt.f_anim.f.f.mb -textvariable ::GidPriv(PostAnimateControlsSaveAnimationFormat) \
	-labels [ list [_ "MPEG"] [_ "AVI/mjpeg"] [_ "AVI/MS Video 1"] [_ "AVI/raw True Color"] \
		      [_ "AVI/raw 15 bpp (VD)"] [_ "AVI/raw 16 bpp (MS)"] [_ "GIF"]] \
	-values {MPEG AVIMJPG AVIMSVC AVI AVI15 AVI16 GIF} \
	-width 16

    label $w.f_opt.f_anim.f.f.l -text [_ "on"]

    set GidPriv(PostAnimateControlsMPEGCanvas) $w.f_opt.f_anim.f.cv
    canvas $w.f_opt.f_anim.f.cv -width 18 -height 18
    set led_libre [$w.f_opt.f_anim.f.cv create oval 2 2 17 17 -fill grey60]
    set GidPriv(PostAnimateControlsMPEG_led_libre) $led_libre
    PostAnimateControlsMPEGLeds DISABLED

    grid $w.f_opt.f_anim.f.f.cb $w.f_opt.f_anim.f.f.mb $w.f_opt.f_anim.f.f.l \
	    -padx 0 -ipadx 0 -pady 0 -ipady 0 -sticky nsew

    grid columnconf $w.f_opt.f_anim.f.f 1 -weight 1
    grid rowconf $w.f_opt.f_anim.f.f 0 -weight 1

    button $w.f_opt.f_anim.f.b -bd 1 -image [GetImage "openfold.gif"] -command PostAnimateControlsChooseAnimationFile \
	-padx 8 -pady 3
    grid $w.f_opt.f_anim.f.f -sticky w
    grid $w.f_opt.f_anim.f.b -row 0 -column 1 -sticky e
    grid $w.f_opt.f_anim.f.cv -row 0 -column 2 -sticky e

    grid columnconf $w.f_opt.f_anim.f 0 -weight 1
    grid rowconf $w.f_opt.f_anim.f 0 -weight 1

    entry $w.f_opt.f_anim.e -relief sunken -width 8 -state normal -textvariable GidPriv(PostAnimateControlsSaveAnimationFile)
    grid $w.f_opt.f_anim.f -sticky w
    grid $w.f_opt.f_anim.e -sticky we

    lappend GidPriv(PostAnimateControlsDisableColorList) $w.f_opt.f_anim.f.f.cb
    lappend GidPriv(PostAnimateControlsDisableList) $w.f_opt.f_anim.f.f.mb
    lappend GidPriv(PostAnimateControlsDisableColorList) $w.f_opt.f_anim.f.f.l
    lappend GidPriv(PostAnimateControlsDisableList) $w.f_opt.f_anim.f.b
    lappend GidPriv(PostAnimateControlsDisableList) $w.f_opt.f_anim.e

    grid columnconf $w.f_opt.f_anim 0 -weight 1
    grid rowconf $w.f_opt.f_anim 0 -weight 1
    grid rowconf $w.f_opt.f_anim 1 -weight 1

    GidHelp $w.f_opt.f_del [_ "With this option a DelayTime of the entered milliseconds will be used between frames."]

    GidHelp $w.f_opt.f_anim [_ "Here the name of the animation file must be entered."]
    GidHelp $w.f_opt.f_anim.f.f.mb [_ "Choose the file format of the animation file."]
    GidHelp $w.f_opt.f_anim.f.b [_ "A file browser will be openned, so a file can be selected."]

    grid $w.f_opt.f_anim -sticky ew
    grid $w.f_opt.f_del -sticky we
    grid columnconf $w.f_opt 0 -weight 1
    grid rowconf $w.f_opt 0 -weight 1
    grid rowconf $w.f_opt 1 -weight 1

    checkbutton $w.f_opt.cb_redraw -text [_ "Save redraws"] -variable GidPriv(PostAnimateControlsSaveRedraws)
    grid $w.f_opt.cb_redraw -sticky w
    GidHelp $w.f_opt.cb_redraw [_ "Check this option if you want to save each redraw into the animation file.\n\
	    GiD will start saving redraws into the file after clicking the AddSet button in this windows."]

    grid rowconf $w.f_opt 2 -weight 1

    lappend GidPriv(PostAnimateControlsDisableList) $w.f_opt.cb_redraw

    frame $w.f_opt.f_siz -relief sunken -bd 0

    # ComboBoxRAM $w.f_opt.f_siz.mb GidPriv(PostAnimateControlsResize) \
    #             [list [_ "Default"] "800x600" "720x576" "640x480" "512x384" "352x288" "320x240"] \
    #             {Default 800x600 720x576 640x480 512x384 352x288 320x240}
    TTKMenubutton $w.f_opt.f_siz.mb -textvariable ::GidPriv(PostAnimateControlsResize) \
	-labels [ list [_ "Default"] \
		      "1920x1200" "1920x1080 HD" "1680x1050" "1680x945" \
		      "1440x900" "1440x810" "1366x768" \
		      "1280x1024" "1280x800" "1280x768" "1280x720 HD" \
		      "1024x768" "1024x640" "1024x600" "1024x576" \
		      "800x600" "720x576" "640x480" "512x384" "352x288" "320x240"] \
	-values {Default \
		     1920x1200 1920x1080 1680x1050 1680x945 \
		     1440x900 1440x810 1366x768 \
		     1280x1024 1280x800 1280x768 1280x720 \
		     1024x768 1024x640 1024x600 1024x576 \
		     800x600 720x576 640x480 512x384 352x288 320x240} \
	-width 10
    #other sizes "352x288 (VCD-PAL)" "352x240 (VCD-NTSC)

    button $w.f_opt.f_siz.resize -text [_ "Resize"] \
	-command "PostAnimateControlsResize; update; after 200 PostAnimateControlsResize" \
	-bd 1 \
	-padx 8 -pady 3

    grid $w.f_opt.f_siz.mb $w.f_opt.f_siz.resize -sticky w
    #grid configure $w.f_opt.f_siz.mb -sticky ew

    grid $w.f_opt.f_siz -sticky w
    GidHelp $w.f_opt.f_siz [_ "For MPEG files on windows its recommended \n\
	    to choose a windows-standard frame size:\n \
	    320x240 / 352x288 / 512x384 / 640x480 / 720x576 or 800x600"]

    lappend GidPriv(PostAnimateControlsDisableList) $w.f_opt.f_siz.mb
    lappend GidPriv(PostAnimateControlsDisableList) $w.f_opt.f_siz.resize



    frame $w.f_ctr -relief ridge -bd 2
    frame $w.f_ctr.f2

    button $w.f_ctr.f2.add -image [GetImage AddStep.gif] \
	    -command "PostAnimateControlsAddStep $w.f_ctr.f2.add" -bd 1 \
	-padx 8 -pady 3
    button $w.f_ctr.f2.end -image [GetImage EndAnim.gif] \
	    -command "PostAnimateControlsEndAnim $w.f_ctr.f2.end" -bd 1 \
	-padx 8 -pady 3

    grid $w.f_ctr.f2.add $w.f_ctr.f2.end -padx 2 -pady 2 -sticky we

    #label $w.f_ctr.f2.file_size -fg grey60 -textvariable GidPriv(PostAnimateControlsFileSize) -font SmallFont
    #set GidPriv(PostAnimateControlsFileSizeLabel) $w.f_ctr.f2.file_size
    #grid $w.f_ctr.f2.file_size

    GidHelp $w.f_ctr.f2.add \
	    [_ "AddSet button: Adds a frame \n\
	    into the animation file.\n\
	    If the 'Save redraws' checkbox \n\
	    is checked, pressing this button \n\
	    starts saving redraws into the file."]

    GidHelp $w.f_ctr.f2.end \
	    [_ "EndAnimation button: Ends and \n\
	    closes the animation file.\n"]

    GidHelp $w.f_ctr.f2.cv 7000 [_ "Animation status leds:\n\
	    Green: no animation is being done, \n\
		   the animation file is closed.\n\
	    Red:   GiD is storing frames ( added \n\
		   by the user, or storing redraws)\n\
		   in an opened animation file."]



    # close
    frame $w.f_but -bd 0 -background [CCColorActivo $color_fondo]

    button $w.f_but.close -text [_ "Close"] -command "destroy $w" \
	-padx 8 -pady 3
    SetWidgetsWidthFromText $w.f_but.close

    grid $w.f_but.close -sticky wes -pady 5 -padx 5

    lappend GidPriv(PostAnimateControlsDisableList) $w.f_but.close

    grid $w.f_ctr.f2



    grid $w.f_opt -sticky news
    grid $w.f_opt.f_dur -sticky news
    grid $w.f_ctr -sticky ew
    grid $w.f_but -sticky ews
    if { $::tcl_version >= 8.5 } { grid anchor $w.f_but center }

    grid rowconf $w 0 -weight 1
    grid rowconf $w 1 -weight 1
    grid rowconf $w 2 -weight 1
    grid rowconf $w 3 -weight 1
    grid columnconf $w 0 -weight 1

    set GidPriv(PostAnimateControlsInitializing) 1
    update
    set GidPriv(PostAnimateControlsInitializing) 0

    bind $w <Escape> [list destroy $w]
    bind $w <Destroy> [list +DestroyPrePostAnimateControls %W $w]

    trace add variable GidPriv(PostAnimateControlsDelay) write PostAnimateControlsTogleDelayEntry
    trace add variable GidPriv(PostAnimateControlsDelayTime) write PostAnimateControlsCheckDelayTime
    trace add variable GidPriv(PostAnimateControlsSaveAnimation) write PostAnimateControlsTogleAnimEntry

    trace add variable GidPriv(PostAnimateControlsDuration) write PostAnimateControlsTogleDurationEntry

    # set GidPriv(PostAnimateControlsDuration) 1
    set GidPriv(PostAnimateControlsDelay) 1
    set GidPriv(PostAnimateControlsSaveRedraws) 1

    # no hay checkbox
    set GidPriv(PostAnimateControlsSaveAnimation) 1
}

proc DestroyPrePostAnimateControls { W w } {
    if { $W != $w } return

    global GidPriv
    if { $GidPriv(PostAnimateControlsSavingAnimation) } {
	GiD_Process animationfile end
	set GidPriv(PostAnimateControlsSavingAnimation) 0
    }
    trace remove variable GidPriv(PostAnimateControlsDelay) write PostAnimateControlsTogleDelayEntry
    trace remove variable GidPriv(PostAnimateControlsDelayTime) write PostAnimateControlsCheckDelayTime
    trace remove variable GidPriv(PostAnimateControlsSaveAnimation) write PostAnimateControlsTogleAnimEntry
    trace remove variable GidPriv(PostAnimateControlsSavingAnimation) write PostAnimateControlsTogleMPEGLeds
    trace remove variable GidPriv(PostAnimateControlsDuration) write PostAnimateControlsTogleDurationEntry
}
