#!/bin/sh
#PostPoint -*- TCL -*- Created: miguel Mar-2001, Modified: miguel ???-2001

#Post widgets:

#############################
### ATTK: para esar widgets tk o tile desde la sintaxis tk
### ATTK button .b -text hola -width 8 -height 8
### intenta traducir las opciones de tk a tile, las que no puede no las pasa
### dentro de ATTK_Inicializa se puede escoger si dejar tk o tile
### para el tema del aspecto
#############################

# ResultSelectionTree pahtName options

# UpDownEntry: campo con flechitas de incrmento/decremento
# ScrolledCanvas: canvas con barritas de scroll a la derecha y abajo

##############################
# Funciones que crean un ScrolledCanvas
# donde se pueden meter widgets, ...
#
# CreateScrolledCanvas nombre_de_widget -> retorna el nombre del canvas
# AddToScrolledCanvas nombre_de_widget cosa_a_aadir -> aade el widget al canvas
# ResizeScrolledCanvas nombre_de_widget -> redimensiona las barras de scroll
# ResetScrolledCanvas nombre_de_widget -> borra todos los dibujos/windows del canvas
#                                         sin destruir los widgets
##############################
# CCformatFloat2Hex { lstFloats} --> dado una lista de, al menos, 3 floats (rgb o rgba) devuelve #rrggbb, como quiere Tk
# CCGetRGB { w color} -> dado un color encuentra su #rrggbb
# CCColorActivo { color { factor 17}} -> dado un color #rrggbb lo eleva segun factor
# CCColorSombra { color { factor 17}} ->  dado un color #rrggbb lo eleva segun factor

# SwitchButton { w on_command off_command args} -> crea un button $args
#                        que si se clickea queda apretado y ejecuta on_command y
#                        si se clickea otra vez vuleve como antes y ejecuta off_command
##############################

# NOTA: Mejor usar GidHelp , para no duplicar funciones, asi el comportamiento
# es homogeneo entre pre y post, y cualquier mejora afecta a ambos.

# GiDPopUpHelp { w args} -> bocado de ayuda ( texto ayuda en args) sobre el widget w
#                           al cabo de un rato aparece la ayuda y despues de otro
#                           rato, dependiendo de la longitud del texto en args,
#                           desaparece, o al moverse el raton.
# args = { ShowMiliSeconds max( 3000, 500 * \[ string length text\])} Text

# UpDownEntry widget_name arguments
#         arguments:
#                    -up-command "command when up button is pressed"
#                    -down-command "command when down button is pressed"
#                    -show-double-buttons          <- shows rapid incrment buttons, by default disabled
#                    -up-up-command "command when up up button is pressed"
#                    -down-down-command "command when down down button is pressed"
#                    -variable variable_for_the_entry
#                    -textvariable variable_for_the_entry
#                    -foreground fore_color_for_entry_and_buttons
#                    -background back_color_for_entry_and_buttons
#                    -up-color fore_color_for_bitmap_on_up_button
#                    -up-up-color fore_color_for_bitmap_on_up_up_button
#                    -down-color fore_color_for_bitmap_on_down__button
#                    -down-down-color fore_color_for_bitmap_on_down_down_button
#                    -entry-options "Options for the entry widget"
#                    -button-options "Options for the button widgets"
#                    -up-button-options "Options for the up button widget"
#                    -down-button-options "Options for the down button widget"
#                    -up-up-button-options "Options for the up up button widget"
#                    -down-down-button-options "Options for the down down button widget"

# UpDownEntryConf widget_name arguments
#         argumenst:
#                    -state normal/disabled
#                    -foreground fore_color_for_entry_and_buttons
#                    -background back_color_for_entry_and_buttons
#                    -entry-options "Options for the entry widget"
#                    -button-options "Options for the button widgets"
#                    -up-button-options "Options for the up button widget"
#                    -down-button-options "Options for the down button widget"

# proc TextWindow wparent varname title label_text args
#         displays a window asking for some text which is stored in 'varname'
#         it waits until the user click on 'Apply' or 'Close'
#         there is a couple of bindings:
#         <Alt-Return> and <Alt-KP_Enter> which invoques the 'Apply' button
#         <Escape> which invoques the 'Colse' button
#         argumenst:
#                    wparent - parent window to appear over tit
#                    varname - variable with the text to be showed / edited
#                    title - title of the window
#                    label_text - text of the label wich appears on the surrounding frame
#                    args - arguments passed directly to the text widget
#         returns the window name
##########################################################################################
### ScrolledCanvas
##########################################################################################

################################
# TTKMenubutton:
# TTKMenubutton widget
#         opciones validas:
#         -labels lista_etiquetas
#         -values lista_valores
#         -textvariable variable_para_guardar_el_valor
#         -modifycmd comando_a_llamar_cuando_se_selecciona_la_opcion
#         -commands lista_comandos_para_cada_label/value
#         -images lista_imagenes_para_cada_label/value
#      tambien admite las opciones estandard:
#         -width -height -state -style -takefocus -text -image -compount -cursor -underline -direction
# TTKMenubuttonInvoke widget TextoEntradaMenu
#                     --> selecciona e invoca la entrada de menu con texto TextoEntradaMenu
# TTKMenubuttonSelect widget TextoEntradaMenu
#                     --> muestra la entrada de menu con texto TextoEntradaMenu en el boton
# TTKMenubuttonConfigure widget opciones
#                     --> para redefinir opcionesl del widget
# TTKMenubuttonCGet widget opcion
#                     --> para conseguir informacion de alguna opcion del widget
################################

################################
# TTKMessagebox:
# TTKMessagebox widget como el messagebox, pero con una lista de etiquetas/valores donde elegir
#         la etiqueta/valor seleccionado devuelve el valor
#         opciones validas:
#         -title titulo
#         -message mensaje_de_la_ventana
#         -labels lista_etiquetas
#         -values lista_valores
#         -textvariable variable_para_guardar_el_valor
#         -images lista_imagenes_para_cada_label/value
#      tambien admite las opciones estandard:
#         -parent
#         -icon nombre del icono a mostrar
################################

################################
# TTKComboBox:
# TTKComboBox widget
#         opciones validas:
#         -labels lista_etiquetas
#         -values lista_valores
#         -textvariable variable_para_guardar_el_valor
#         -modifycmd comando_a_llamar_cuando_se_selecciona_la_opcion
#  ( QUITADO)        -commands lista_comandos_para_cada_label/value
#  ( QUITADO)        -images lista_imagenes_para_cada_label/value
#      tambien admite las opciones estandard:
#         -width -height -state -style -takefocus -text -image -compount -cursor -underline -direction
# TTKComboBoxConfigure widget opciones
#                     --> para redefinir opcionesl del widget
# TTKComboBoxCGet widget opcion
#                     --> para conseguir informacion de alguna opcion del widget
#                     get --> devuelve la etiqueta actual seleccionada, no el value actual
################################

################################
# adjustButtonWidth { width_org} - devuelve el tamano ajustado en MacOSX, que con los extremos redondos
#                                  de los botones necesita algo mas de espacio
# adjustButton { widget} - ajusta el tamanno del boton teniendo en cuenta los extremos redondos en MacOSX
################################

################################
# LabelButton:
# boton para poder definir un color. el boton cambia de color al seleccionar un color
# se implementa con un label, pues en mac no se pueden poner colores en los botones
################################
# setTooltip para definir globos de ayuda, tb en los menus
# set Tooltip widget opciones
# opciones validas:
# texto --> texto a aparecer
# -text texto --> texto a apareces
# -textvariable nombreVariable --> variable con la que el balon se actualizara ( para menus)
# para el balon de los menus, se usa en conjuncion con el DynamicHelp de BWidget
# ejemplo con menus:
#
# menu .m -type menubar
# # associate menubar to toplevel BEFORE DynamicHelp::register
# # to make it works with menu clone name
# . configure -menu .m
# .m add cascade -label "File" -menu .m.file
# menu .m.file
# .m.file add command -label "Open..."
# .m.file add command -label "Quit"
#
# # la variable donde se guardara el texto de ayuda que toca
# set ::varinfo ""
# # associate all entries of menu .m.file to variable varinfo
# DynamicHelp::register .m.file menu ::varinfo
# # then declare entries of .m.file
# DynamicHelp::register .m.file menuentry 0 "Detach menu"
# DynamicHelp::register .m.file menuentry 1 "Open a file"
# DynamicHelp::register .m.file menuentry 2 "Exit demo"
# setTooltip .m.file -textvariable ::varinfo

##############################
# CreateApplyCloseDecorationWindow { window top_frame but_frame apply_cmd close_cmd}
##############################
# creates window decoration, top_frame and but_frame with Apply and Close buttons
##############################
# CreateDecorationWindow { window top_frame but_frame lst_button_labels lst_button_cmds lst_button_keys}
##############################
# creates window decoration, top_frame, but_frame and the list of buttons with commands and key bindings


proc CreateScrolledCanvas { { w .scw}} {
    if { [ winfo exists $w]} {
	puts "widget name $w already exists."
	return
    }

    frame $w -relief ridge -bd 2
    set v [ scrollbar $w.vscroll -highlightthickness 0 -bd 1 -elementborderwidth 1 \
	    -orient vertical]
    set h [ scrollbar $w.hscroll -highlightthickness 0 -bd 1 -elementborderwidth 1 \
	    -orient horizontal]
    set c [ canvas $w.c -width 100 -height 100 -borderwidth 2 \
	    -xscrollcommand "$h set" -yscrollcommand "$v set"]
    $h config -command "$c xview"
    $v config -command "$c yview"
    $c config -scrollregion [ $c bbox all]
    grid $c -column 0 -row 0 -sticky news
    grid $v -column 1 -row 0 -rowspan 2 -sticky ns
    grid $h -column 0 -row 1 -sticky ew
    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1

    return $w.c
}

proc AddToScrolledCanvas { { w .scw} { what ""}} {
    if { ![ winfo exists $w]} {
	puts "widget name $w does not exist."
	return
    }

    if { "$what" == ""} {
	puts "Nothing to add to the Scrolled Canvas"
	return
    }

    update idletasks

    set region [ $w.c bbox all]
    set posx 0
    if { [ llength $region] == 4 } {
	set posx [ lindex $region 3]
    }

    $w.c create window 0 $posx -anchor nw -window $what
    $w.c config -scrollregion [ $w.c bbox all]
}

proc ResetScrolledCanvas { { w .scw}} {
    if { ![ winfo exists $w]} {
	puts "widget name $w does not exist."
	return
    }

    $w.c del all
    $w.c config -scrollregion [ $w.c bbox all]
}

proc ResizeScrolledCanvas { { w .scw}} {
    if { ![ winfo exists $w]} {
	puts "widget name $w does not exist."
	return
    }

    $w.c config -scrollregion [ $w.c bbox all]
}

##########################################################################################
### UpDownEntry
##########################################################################################

proc __UpDownEntry_Incr_Cmd { w paso } {

    if { "$::UpDownEntry($w,Variable)" != ""} {
	set nuevo [ eval expr $$::UpDownEntry($w,Variable) + $paso]
	if { $nuevo > $::UpDownEntry($w,To)} {
	    set nuevo $::UpDownEntry($w,To)
	}
	if { $nuevo < $::UpDownEntry($w,From)} {
	    set nuevo $::UpDownEntry($w,From)
	}
	set $::UpDownEntry($w,Variable) $nuevo
    }
}

proc UpDownEntry { w args} {
    global UpDownEntry

    set flags_entry ""
    set flags_up_button ""
    set flags_down_button ""
    set up_command ""
    set down_command ""
    set flags_up_up_button ""
    set flags_down_down_button ""
    set up_up_command ""
    set down_down_command ""
    set variable_entry ""
    set show_double_buttons 0
    set up_color black
    set up_up_color black
    set down_color black
    set down_down_color black
    set increment 1
    set big_increment 10
    set limit_from 0
    set limit_to 10

    set ll [ llength $args]
    for { set i 0} { $i < $ll} { incr i} {
	# parejas "-opcion cosas"
	set toca [ lindex $args $i]
	incr i
	if { $i >= $ll} { break}
	switch -- "$toca" {
	    "-up-command" {
		set up_command [ lindex $args $i]
	    }
	    "-down-command" {
		set down_command [ lindex $args $i]
	    }
	    "-show-double-buttons" {
		set show_double_buttons 1
		set i [ expr $i - 1]
	    }
	    "-up-up-command" {
		set up_up_command [ lindex $args $i]
	    }
	    "-down-down-command" {
		set down_down_command [ lindex $args $i]
	    }
	    "-variable" {
		set variable_entry [ lindex $args $i]
	    }
	    "-textvariable" {
		set variable_entry [ lindex $args $i]
	    }
	    "-entry-options" {
		append flags_entry " [ lindex $args $i]"
	    }
	    "-button-options" {
		append flags_up_button " [ lindex $args $i]"
		append flags_down_button " [ lindex $args $i]"
		append flags_up_up_button " [ lindex $args $i]"
		append flags_down_down_button " [ lindex $args $i]"
	    }
	    "-up-button-options" {
		append flags_up_button " [ lindex $args $i]"
	    }
	    "-down-button-options" {
		append flags_down_button " [ lindex $args $i]"
	    }
	    "-up-up-button-options" {
		append flags_up_up_button " [ lindex $args $i]"
	    }
	    "-down-down-button-options" {
		append flags_down_down_button " [ lindex $args $i]"
	    }
	    "-foreground" {
		append flags_entry " -foreground [ lindex $args $i]"
		append flags_up_button " -foreground [ lindex $args $i]"
		append flags_down_button " -foreground [ lindex $args $i]"
		append flags_up_up_button " -foreground [ lindex $args $i]"
		append flags_down_down_button " -foreground [ lindex $args $i]"
	    }
	    "-background" {
		append flags_entry " -background [ lindex $args $i]"
		append flags_up_button " -background [ lindex $args $i]"
		append flags_down_button " -background [ lindex $args $i]"
		append flags_up_up_button " -background [ lindex $args $i]"
		append flags_down_down_button " -background [ lindex $args $i]"
	    }
	    "-up-color" {
		set up_color [ lindex $args $i]
	    }
	    "-down-color" {
		set down_color [ lindex $args $i]
	    }
	    "-up-up-color" {
		set up_up_color [ lindex $args $i]
	    }
	    "-down-down-color" {
		set down_down_color [ lindex $args $i]
	    }
	    "-increment" {
		set increment [ lindex $args $i]
	    }
	    "-big-increment" {
		set big_increment [ lindex $args $i]
	    }
	    "-from" {
		set limit_from [ lindex $args $i]
	    }
	    "-to" {
		set limit_to [ lindex $args $i]
	    }
	}
    }

    frame $w -bd 0
    entry $w.e
    set UpDownEntry($w,Variable) $variable_entry
    if { "$variable_entry" != ""} {
	$w.e configure -textvariable $variable_entry
	set ::UpDownEntry($w,From) $limit_from
	set ::UpDownEntry($w,To) $limit_to
	if { $up_command == ""} {
	    set up_command "__UpDownEntry_Incr_Cmd $w $increment"
	}
	if { $down_command == ""} {
	    set down_command "__UpDownEntry_Incr_Cmd $w  [ expr -1 * $increment]"
	}
	if { $up_up_command == ""} {
	    set up_up_command "__UpDownEntry_Incr_Cmd $w  $big_increment"
	}
	if { $down_down_command == ""} {
	    set down_down_command "__UpDownEntry_Incr_Cmd $w [ expr -1 * $big_increment]"
	}
    }
    if { "$flags_entry" != ""} {
	eval [ concat $w.e configure $flags_entry]
    }

    if { ![info exists UpDownEntry(triangle_up_image,$up_color)] } {
	set UpDownEntry(triangle_up_image,$up_color) [ image create bitmap -data {
	    #define triangle_up_width 15
	    #define triangle_up_height 9
	    static unsigned char triangle_up_bits[] = {
		0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0xc0, 0x01, 0xe0, 0x03, 0xf0, 0x07,
		0xf8, 0x0f, 0x00, 0x00, 0x00, 0x00};
	    } -foreground $up_color ]
    }

    if { ![info exists UpDownEntry(triangle_down_image,$down_color)] } {
	set UpDownEntry(triangle_down_image,$down_color) [ image create bitmap -data {
	    #define triangle_down_width 15
	    #define triangle_down_height 9
	    static unsigned char triangle_down_bits[] = {
		0x00, 0x00, 0x00, 0x00, 0xf8, 0x0f, 0xf0, 0x07, 0xe0, 0x03, 0xc0, 0x01,
		0x80, 0x00, 0x00, 0x00, 0x00, 0x00};
	    } -foreground $down_color ]
    }

    if { ![info exists UpDownEntry(triangle_up_up_image,$up_up_color)] } {
	set UpDownEntry(triangle_up_up_image,$up_up_color) [ image create bitmap -data {
	    #define triangle_up_up_width 15
	    #define triangle_up_up_height 9
	    static unsigned char triangle_up_up_bits[] = {
		0x00, 0x00, 0x80, 0x00, 0x40, 0x01, 0x20, 0x02, 0x90, 0x04, 0xc8, 0x09,
		0xe4, 0x13, 0x00, 0x00, 0x00, 0x00};
	    } -foreground $up_up_color ]
    }

    if { ![info exists UpDownEntry(triangle_down_down_image,$down_down_color)] } {
	set UpDownEntry(triangle_down_down_image,$down_down_color) [ image create bitmap -data {
	    #define triangle_down_down_width 15
	    #define triangle_down_down_height 9
	    static unsigned char triangle_down_down_bits[] = {
		0x00, 0x00, 0x00, 0x00, 0xe4, 0x13, 0xc8, 0x09, 0x90, 0x04, 0x20, 0x02,
		0x40, 0x01, 0x80, 0x00, 0x00, 0x00};
	    } -foreground $down_down_color ]
    }

    frame $w.fb -bd 0
    button $w.fb.up -image $UpDownEntry(triangle_up_image,$up_color)
    if { "$up_command" != ""} {
	$w.fb.up configure -command $up_command
    }
    if { "$flags_up_button" != ""} {
	eval [ concat $w.fb.up configure $flags_up_button]
    }

    button $w.fb.down -image $UpDownEntry(triangle_down_image,$down_color)
    if { "$down_command" != ""} {
	$w.fb.down configure -command $down_command
    }
    if { "$flags_down_button" != ""} {
	eval [ concat $w.fb.down configure $flags_down_button]
    }

    if { $show_double_buttons} {
	button $w.fb.upup -image $UpDownEntry(triangle_up_up_image,$up_up_color)
	if { "$up_up_command" != ""} {
	    $w.fb.upup configure -command $up_up_command
	}
	if { "$flags_up_up_button" != ""} {
	    eval [ concat $w.fb.upup configure $flags_up_up_button]
	}
	
	button $w.fb.downdown -image $UpDownEntry(triangle_down_down_image,$down_down_color)
	if { "$down_down_command" != ""} {
	    $w.fb.downdown configure -command $down_down_command
	}
	if { "$flags_down_down_button" != ""} {
	    eval [ concat $w.fb.downdown configure $flags_down_down_button]
	}
    }

    grid $w.fb.up -row 0 -column 0
    grid $w.fb.down -row 1 -column 0
    if { $show_double_buttons} {
	grid $w.fb.upup -row 0 -column 1
	grid $w.fb.downdown -row 1 -column 1
    }

    grid $w.e -sticky ew -row 0 -column 0
    grid $w.fb -sticky ns -row 0 -column 1
    grid rowconfigure $w 0 -weight 1
    grid columnconfigure $w 0 -weight 1

    set UpDownEntry(ShowDoubles) $show_double_buttons
}

proc UpDownEntryConf { w args} {
    global UpDownEntry

    set flags_entry ""
    set flags_up_button ""
    set flags_down_button ""
    set flags_up_up_button ""
    set flags_down_down_button ""
    set flag_estado ""

    set ll [ llength $args]
    for { set i 0} { $i < $ll} { incr i} {
	# parejas "-opcion cosas"
	set toca [ lindex $args $i]
	incr i
	if { $i >= $ll} { break}
	switch -- "$toca" {
	    "-state" {
		set flag_estado [ lindex $args $i]
	    }
	    "-entry-options" {
		append flags_entry " [ lindex $args $i]"
	    }
	    "-button-options" {
		append flags_up_button " [ lindex $args $i]"
		append flags_down_button " [ lindex $args $i]"
		append flags_up_up_button " [ lindex $args $i]"
		append flags_down_down_button " [ lindex $args $i]"
	    }
	    "-up-button-options" {
		append flags_up_button " [ lindex $args $i]"
	    }
	    "-down-button-options" {
		append flags_down_button " [ lindex $args $i]"
	    }
	    "-up-up-button-options" {
		append flags_up_up_button " [ lindex $args $i]"
	    }
	    "-down-down-button-options" {
		append flags_down_down_button " [ lindex $args $i]"
	    }
	    "-foreground" {
		append flags_entry " -foreground [ lindex $args $i]"
		append flags_up_button " -foreground [ lindex $args $i]"
		append flags_down_button " -foreground [ lindex $args $i]"
		append flags_up_up_button " -foreground [ lindex $args $i]"
		append flags_down_down_button " -foreground [ lindex $args $i]"
	    }
	    "-background" {
		append flags_entry " -background [ lindex $args $i]"
		append flags_up_button " -background [ lindex $args $i]"
		append flags_down_button " -background [ lindex $args $i]"
		append flags_up_up_button " -background [ lindex $args $i]"
		append flags_down_down_button " -background [ lindex $args $i]"
	    }
	}
    }

    switch "$flag_estado" {
	"normal" {
	    $w.e configure -state normal
	    $w.fb.up configure -state normal
	    $w.fb.down configure -state normal
	    if { $UpDownEntry(ShowDoubles)} {
		$w.fb.upup configure -state normal
		$w.fb.downdown configure -state normal
	    }
	}
	"disabled" {
	    $w.e configure -state disabled
	    $w.fb.up configure -state disabled
	    $w.fb.down configure -state disabled
	    if { $UpDownEntry(ShowDoubles)} {
		$w.fb.upup configure -state disabled
		$w.fb.downdown configure -state disabled
	    }
	}
    }

    if { "$flags_entry" != ""} {
	eval [ concat $w.e configure $flags_entry]
    }

    if { "$flags_up_button" != ""} {
	eval [ concat $w.fb.up configure $flags_up_button]
    }

    if { "$flags_down_button" != ""} {
	eval [ concat $w.fb.down configure $flags_down_button]
    }

    if { $UpDownEntry(ShowDoubles)} {
	if { "$flags_up_up_button" != ""} {
	    eval [ concat $w.fb.upup configure $flags_up_up_button]
	}
	
	if { "$flags_down_down_button" != ""} {
	    eval [ concat $w.fb.downdown configure $flags_down_down_button]
	}
    }
}


proc HidePopUpHelp { w} {
    global GiDPrivPopUpHelp

    if { [ info exists GiDPrivPopUpHelp($w)]} {
	while { "$GiDPrivPopUpHelp($w)" == "Busy"} {
	    update idletasks
	    after 100
	}
	if { [ info exists GiDPrivPopUpHelp($w)]} {
	    after cancel $GiDPrivPopUpHelp($w)
	}
    }

    set GiDPrivPopUpHelp($w) Busy

    if { [ winfo exists $w.__popup_help]} {
	destroy $w.__popup_help
    }

    bind $w <Motion> ""
    bind $w <Button-3> ""
    unset GiDPrivPopUpHelp($w)
}

proc ShowPopUpHelp { w hide_delay text } {
    global GiDPrivPopUpHelp

    if { [ info exists GiDPrivPopUpHelp($w)]} {
	if { "$GiDPrivPopUpHelp($w)" == "Busy"} {
	    return
	}
	#while { "$GiDPrivPopUpHelp($w)" == "Busy"} {
	#    update idletasks
	#    after 100
	#}
	after cancel $GiDPrivPopUpHelp($w)
    }
    set GiDPrivPopUpHelp($w) Busy

    if { [ winfo exists $w.__popup_help]} {
	destroy $w.__popup_help
    }

    if { ![ winfo exists $w]} {
	return
    }

    set x [winfo pointerx $w]
    set y [winfo pointery $w]

    if { $y < [expr [winfo screenheight $w]/2.0] } {
	set y +[expr $y+3]
    } else {
	set y -[expr [winfo screenheight $w]-$y+3]
    }
    if { $x < [expr [winfo screenwidth $w]/2.0] } {
	set x +[expr $x+3]
    } else {
	set x -[expr [winfo screenwidth $w]-$x+3]
    }

    toplevel $w.__popup_help

    wm overrideredirect $w.__popup_help 1
    wm geom $w.__popup_help $x$y
    label $w.__popup_help.l -bg #fff7e7 -fg black \
	    -justify left -text $text -wraplength 10c
    #  -relief ridge
    pack $w.__popup_help.l

    set GiDPrivPopUpHelp($w) [ after $hide_delay "HidePopUpHelp $w"]
    bind $w <Motion> "HidePopUpHelp $w"
    bind $w <Button-3> "HidePopUpHelp $w"
}

proc ShowPopUpHelpDelayed { w delay hide_delay text} {
    global GiDPrivPopUpHelp

    set par [ winfo parent $w]
    set top [ winfo toplevel $w]
    while { ( "$par" != "") && ( $par != $top)} {
	if { [ info exists GiDPrivPopUpHelp($par)]} {
	    while { "$GiDPrivPopUpHelp($par)" == "Busy"} {
		update idletasks
		after 100
	    }
	    after cancel $GiDPrivPopUpHelp($par)
	}
	if { [ winfo exists $par.__popup_help]} {
	    destroy $par.__popup_help
	}
	set par [ winfo parent $par]
    }

    set GiDPrivPopUpHelp($w) [ after $delay "ShowPopUpHelp $w $hide_delay \"$text\""]
    bind $w <Button-3> "ShowPopUpHelp $w $hide_delay \"$text\""
}

proc GiDPopUpHelp { w args } {
    global GiDPrivPopUpHelp
    #set hide_delay 3000
    # el tiempo durante el cual se muestra el mensaje
    #set hide_delay [ expr int( 1100 * [llength [ join $args ]] / 3)]
    set hide_delay [ expr int( 500 * [string length [ join $args ]] / 3)]
    if { $hide_delay < 3000} {
	set hide_delay 3000
    }
    if { [ llength $args] > 1} {
	if { [ regexp {^([0-9]+)$} [ lindex $args 0] dum del] } {
	    if { $del > 0} {
		set hide_delay $del
		set args [ lrange $args 1 end]
	    }
	}
    }

    bind $w <Enter> "+ShowPopUpHelpDelayed $w 1500 $hide_delay \"[ join $args]\""
    bind $w <Leave> "+HidePopUpHelp $w"
    bind $w <Motion> "+HidePopUpHelp $w"
    bind $w <ButtonPress-1> "+HidePopUpHelp $w"
    bind $w <ButtonPress-2> "+HidePopUpHelp $w"
    #bind $w <ButtonPress-3> "+HidePopUpHelp $w"
    bind $w <Button-1> "+HidePopUpHelp $w"
    bind $w <Button-2> "+HidePopUpHelp $w"
    #bind $w <Button-3> "+HidePopUpHelp $w"
    #bind $w <Button-3> "ShowPopUpHelp $w $hide_delay \"[ join $args]\""
    #foreach ww [ winfo children $w] {
    #         bind $ww <Enter> "+ShowPopUpHelpDelayed $w 1500 $hide_delay \"[ join $args]\""
    #         bind $ww <Leave> "+HidePopUpHelp $w"
    #         bind $ww <Motion> "+HidePopUpHelp $w"
    #         bind $ww <ButtonPress-1> "+HidePopUpHelp $w"
    #         bind $ww <ButtonPress-2> "+HidePopUpHelp $w"
    #         #bind $w <ButtonPress-3> "+HidePopUpHelp $w"
    #         bind $ww <Button-1> "+HidePopUpHelp $w"
    #         bind $ww <Button-2> "+HidePopUpHelp $w"
    #         #bind $w <Button-3> "+HidePopUpHelp $w"
    #         bind $ww <Button-3> "ShowPopUpHelp $w $hide_delay \"[ join $args]\""
    #}
}



##########################################################################################
### CCformatFloat2Hex CCGetRGB CCColorActivo CCColorSombra -> para ContourColores
##########################################################################################

proc CCformatFloat2Hex { lstFloats} {
    set r [ expr int( 0.5 + [ lindex $lstFloats 0] * 255.0)]
    set g [ expr int( 0.5 + [ lindex $lstFloats 1] * 255.0)]
    set b [ expr int( 0.5 + [ lindex $lstFloats 2] * 255.0)]
    set ret [ format #%02x%02x%02x $r $g $b]
}

proc CCGetRGB { w color} {
    set ret $color
    set n [ scan $color #%2x%2x%2x r g b]
    if { $n != 3} {
	set rgb [ winfo rgb $w $color]
	#set r [ expr int( 0.5 + [ lindex $rgb 0]/256.0)]
	#set g [ expr int( 0.5 + [ lindex $rgb 1]/256.0)]
	#set b [ expr int( 0.5 + [ lindex $rgb 2]/256.0)]
	set r [ expr int( [ lindex $rgb 0]/256.0)]
	set g [ expr int( [ lindex $rgb 1]/256.0)]
	set b [ expr int( [ lindex $rgb 2]/256.0)]
	set ret [ format #%02x%02x%02x $r $g $b]
    }
    return $ret
}

proc CCColorActivo { color_usuario { factor 17} } {
    set ret $color_usuario
    catch {
	set color_nuevo [ CCGetRGB . $color_usuario]
	set n [ scan $color_nuevo #%2x%2x%2x r g b]
	if { $n == 3} {
	    set r [ expr $r + $factor]
	    if { $r > 255} { set r 255}
	    set g [ expr $g + $factor]
	    if { $g > 255} { set g 255}
	    set b [ expr $b + $factor]
	    if { $b > 255} { set b 255}
	    set ret [ format #%02x%02x%02x $r $g $b]
	}
    }
    return $ret
}

proc CCColorSombra { color_usuario { factor 17} } {
    set ret $color_usuario
    catch {
	set color_nuevo [ CCGetRGB . $color_usuario]
	set n [ scan $color_nuevo #%2x%2x%2x r g b]
	if { $n == 3} {
	    set r [ expr $r - $factor]
	    if { $r < 0} { set r 0}
	    set g [ expr $g - $factor]
	    if { $g < 0} { set g 0}
	    set b [ expr $b - $factor]
	    if { $b < 0} { set b 0}
	    set ret [ format #%02x%02x%02x $r $g $b]
	}
    }
    return $ret
}

##########################################################################################
### Switch Button
##########################################################################################

proc SwitchButtonOn { w } {
    global SwitchButton

    set ret [ eval $SwitchButton($w,on_cmd)]

    if { "[ string tolower $ret]" != "error"} {
	$w configure -foreground $SwitchButton($w,activeforeground) \
		-background $SwitchButton($w,activebackground) \
		-relief sunken

	$w invoke
	bind $w <1> "SwitchButtonOff $w; break"
    }
}

proc SwitchButtonOff { w } {
    global SwitchButton

    set ret [ eval $SwitchButton($w,off_cmd)]

    if { "[ string tolower $ret]" != "error"} {
	$w configure -foreground $SwitchButton($w,foreground) \
		-background $SwitchButton($w,background) \
		-relief $SwitchButton($w,relief)
	
	bind $w <1> "SwitchButtonOn $w; break"
    }
}

proc SwitchButton { w on_command off_command args} {
    global SwitchButton

    eval [ concat button $w $args]
    foreach attr "foreground background activeforeground activebackground relief" {
	set SwitchButton($w,$attr) [ $w cget -$attr]
    }
    set SwitchButton($w,on_cmd) $on_command
    set SwitchButton($w,off_cmd) $off_command

    bind $w <1> "SwitchButtonOn $w; break"
}


##########################################################################################
### BotonPlano
##########################################################################################

proc BotonPlano { w texto comando color_fondo_normal color_fondo_activo { color_normal ""} { color_activo ""}} {
    global Plano

    button $w -text $texto -command $comando -bd 0 -background $color_fondo_normal \
	    -highlightthickness 1 -highlightbackground $color_fondo_normal
    set enter_cmd "$w configure -background $color_fondo_activo -highlightbackground #ffffff"
    set leave_cmd "$w configure -background $color_fondo_normal -highlightbackground $color_fondo_normal"
    if { "$color_normal" != ""} {
	$w configure -foreground $color_normal
	append leave_cmd " -foreground $color_normal"
    }
    if { "$color_activo" != ""} {
	append enter_cmd " -foreground $color_activo"
    }
    #-takefocus 0 -bd 1
    bind $w <Enter> $enter_cmd
    bind $w <Leave> $leave_cmd
    set Plano($w,Enter) $enter_cmd
    set Plano($w,Leave) $leave_cmd
}

proc BotonMenuPlano { w texto menu color_fondo_normal color_fondo_activo { color_normal ""} { color_activo ""}} {
    global Plano

    menubutton $w -text $texto -menu $menu -bd 0 -background $color_fondo_normal \
	    -highlightthickness 1 -highlightbackground $color_fondo_normal
    set enter_cmd "$w configure -background $color_fondo_activo -highlightbackground #ffffff"
    set leave_cmd "$w configure -background $color_fondo_normal -highlightbackground $color_fondo_normal"
    if { "$color_normal" != ""} {
	$w configure -foreground $color_normal
	append leave_cmd " -foreground $color_normal"
    }
    if { "$color_activo" != ""} {
	append enter_cmd " -foreground $color_activo"
    }
    #-takefocus 0 -bd 1
    bind $w <Enter> $enter_cmd
    bind $w <Leave> $leave_cmd
    set Plano($w,Enter) $enter_cmd
    set Plano($w,Leave) $leave_cmd
}

proc OptionMenuPlano { w variable menu_names menu_lst color_fondo_normal color_fondo_activo} {
    global Plano CCOtroLook

    set menu [ tk_optionMenuRAM $w $variable $menu_names $menu_lst]
    $w configure -bd 0 -highlightthickness 1 -background $color_fondo_normal
    $menu configure -bd 1 -activeborderwidth 1 -background $color_fondo_normal
    bind $w <Enter> "$w configure -background $color_fondo_activo -highlightbackground #ffffff"
    bind $w <Leave> "$w configure -background $color_fondo_normal -highlightbackground $color_fondo_normal"
    set Plano($w,Enter) "$w configure -background $color_fondo_activo -highlightbackground #ffffff"
    set Plano($w,Leave) "$w configure -background $color_fondo_normal -highlightbackground $color_fondo_normal"
}

proc PlanoConf { w que como} {
    global Plano CCOtroLook

    switch "[ string tolower $que]" {
	"coloractivo" {
	    bind $w <Enter> "$w configure -background $como -highlightbackground #ffffff"
	    set Plano($w,Enter) "$w configure -background $como -highlightbackground #ffffff"
	}
	"colornormal" {
	    $w configure -background $como
	    bind $w <Leave> "$w configure -background $como -highlightbackground $como"
	    set Plano($w,Leave) "$w configure -background $como -highlightbackground $como"
	}
	"estado" {
	    switch "[string tolower $como]" {
		"disabled" {
		    bind $w <Enter> ""
		    bind $w <Leave> ""
		    $w configure -state $como
		}
		"normal" {
		    $w configure -state $como
		    bind $w <Enter> $Plano($w,Enter)
		    bind $w <Leave> $Plano($w,Leave)
		}
	    }
	}
    }
}

proc GIDChooseColor { w args} {
    set nuevo [ eval GiDSelectColor::dialog $w $args]
    return $nuevo
}

proc GIDChooseColorMenu { w where args} {
    # where puede ser: [ list { "at" "center" "left" "right" "above" "below"} $widget]

    set nuevo [ eval GiDSelectColor::menu $w [ list $where] $args]
    if { [ string length $nuevo] == 13} {
	# es de la forma #rrrrggggbbbb -> cada componente 0..65535
	scan $nuevo #%4x%4x%4x r g b
	set r [ expr int( 0.5 + $r * 255.0 / 65535.0)]
	set g [ expr int( 0.5 + $g * 255.0 / 65535.0)]
	set b [ expr int( 0.5 + $b * 255.0 / 65535.0)]
	set nuevo [ format #%02x%02x%02x $r $g $b]
    }
    return $nuevo
}

proc BWChooseColor { w args} {
    WarnWin Deprecated
    set nuevo [ eval SelectColor::dialog $w $args]
    if { [ string length $nuevo] == 13} {
	# es de la forma #rrrrggggbbbb -> cada componente 0..65535
	scan $nuevo #%4x%4x%4x r g b
	set r [ expr int( 0.5 + $r * 255.0 / 65535.0)]
	set g [ expr int( 0.5 + $g * 255.0 / 65535.0)]
	set b [ expr int( 0.5 + $b * 255.0 / 65535.0)]
	set nuevo [ format #%02x%02x%02x $r $g $b]
    }
    return $nuevo
}

proc BWChooseColorMenu { w where args} {
    WarnWin Deprecated
    # where puede ser: [ list { "at" "center" "left" "right" "above" "below"} $widget]

    set nuevo [ eval SelectColor::menu $w [ list $where] $args]
    if { [ string length $nuevo] == 13} {
	# es de la forma #rrrrggggbbbb -> cada componente 0..65535
	scan $nuevo #%4x%4x%4x r g b
	set r [ expr int( 0.5 + $r * 255.0 / 65535.0)]
	set g [ expr int( 0.5 + $g * 255.0 / 65535.0)]
	set b [ expr int( 0.5 + $b * 255.0 / 65535.0)]
	set nuevo [ format #%02x%02x%02x $r $g $b]
    }
    return $nuevo
}

proc AjustaPosicion { w parent_w} {
    # ajuste geometria
    wm withdraw $w
    update idletasks

    # # centrada en la pantalla
    # set x [expr {[winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \
    #               - [winfo vrootx [winfo parent $w]]}]
    # set y [expr {[winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
    #               - [winfo vrooty [winfo parent $w]]}]
    set w2 [ expr [ winfo reqwidth $w] / 2]
    set h2 [ expr [ winfo reqheight $w] / 2]
    set x [ expr [ winfo pointerx $parent_w] - $w2]
    set y [ expr [ winfo pointery $parent_w] - $h2]

    # miramos si sale la X
    set off_scr_x [ expr ( $x + $w2 + $w2) - [ winfo screenwidth $w]]
    if { $off_scr_x >= 0} {
	set x [ expr $x - $off_scr_x - 10]
    }
    if { $x < 0} { set x 0}
    # miramos si sale la Y
    set off_scr_y [ expr ( $y + $h2 + $h2) - [ winfo screenheight $w]]
    if { $off_scr_y >= 0} {
	set y [ expr $y - $off_scr_y - 20]
    }
    if { $y < 0} { set y 0}
    wm geom $w +$x+$y
    wm deiconify $w
}

# otro look
proc ChangeToNewLook { boton { color_fondo -1}} {
    global GidPriv

    set par [ winfo parent $boton]
    if { "$par" == ""} { set par .gid}
    if { $color_fondo == -1} {
	set DefaultBG [ $par cget -bg]
    } else {
	set DefaultBG $color_fondo
    }
    set err [
	     catch {
		 set bdw [ $boton cget -bd]
	     }
	     ]
    if { $err} {
	# seguramente este widget es de ttk
	# y estos no aceptan opciones de configuracin estticas,
	# todo ha de ir por estilos
	# $boton configure -background $DefaultBG -relief round_raised
	return
    }
    if { $bdw > 0} { set bdw [ expr $bdw - 1]}
    set hlt [ $boton cget -highlightthickness]
    incr hlt
    #incr hlt
    $boton configure -bd $bdw -highlightthickness $hlt -highlightbackground $DefaultBG \
	-bg $DefaultBG
    if { [ info exists ::tk_hasRoundRelief] && $::tk_hasRoundRelief} {
	$boton configure -activebackground $GidPriv(Color,BotonActivo)
    }

    proc CTNL_EnterProc { w} {
	set ::GidPriv($w,DefaultBG) [ $w cget -bg]
	set cba $::GidPriv(Color,BotonActivo)
	set cbma $::GidPriv(Color,BotonMarcoActivo)
	set ::CTNL($w,PrevRelief) [ $w cget -relief]
	if { $::CTNL($w,PrevRelief) eq ""} { set ::CTNL($w,PrevRelief) flat}
	$w configure -highlightbackground $cbma -highlightcolor $cbma \
	    -background $cba -state active
	if { [ info exists ::tk_hasRoundRelief] && $::tk_hasRoundRelief} {
	    $w conf -relief round_raised
	} else {
	    $w conf -relief raised
	}
    }

    bind $boton <Enter> "+CTNL_EnterProc %W"

    proc CTNL_LeaveProc { w} {
	set bg $::GidPriv($w,DefaultBG)
	$w configure -highlightbackground $bg -highlightcolor $bg \
	    -background $bg -state normal -relief $::CTNL($w,PrevRelief)
    }
	
    bind $boton <Leave> "+CTNL_LeaveProc %W"
}

proc TextWindow { wparent varname title label_text args} {
    upvar $varname __textvar

    if { "$wparent" == "."} {
	set w ".__TextWindow"
    } else {
	set w $wparent.__TextWindow
    }

    # algo de informacion de los argumentos
    # miramos si es editable
    # si hacen falta las barras de scroll
    set solo_lectura 0
    set hay_barras_scroll 0
    set nargs_1 [ expr [ llength $args] - 1]
    for { set i 0} { $i < $nargs_1} { incr i} {
	set toca [ string tolower [ lindex $args $i]]
	set sig [ string tolower [ lindex $args [ expr $i + 1]]]
	if { ( "$toca" == "-state") && ( "$sig" == "disabled")} {
	    set solo_lectura 1
	}
	if { ( "$toca" == "-wrap") && ( "$sig" == "none")} {
	    set hay_barras_scroll 1
	}
    }


    toplevel $w
    wm title $w $title

    set color_fondo [ CCGetRGB $w [ $w cget -background]]

    # Titulo y descripcion
    TitleFrame $w.tf -text $label_text
    set ftext [ $w.tf getframe]

    if { $hay_barras_scroll} {
	scrollbar $ftext.yscroll -relief sunken -orient vertical \
		-command "$ftext.t1 yview" \
		-bd 1 -elementborderwidth 1 -takefocus 0
	scrollbar $ftext.xscroll -relief sunken -orient horizontal \
		-command "$ftext.t1 xview" \
		-bd 1 -elementborderwidth 1 -takefocus 0
	set txt_args "-yscroll \"$ftext.yscroll set\" -xscroll \"$ftext.xscroll set\" -wrap none "
    } else {
	set txt_args " -takefocus 0"
    }
    if { "$args" == ""} { \
	append txt_args " -width 20 -height 3 -bd 1"
    } else {
	append txt_args " $args"
    }
    eval text $ftext.t1 $txt_args
    grid $ftext.t1 -sticky ewns
    if { $hay_barras_scroll} {
	grid  $ftext.xscroll -sticky ew
	grid  $ftext.yscroll -rowspan 2 -row 0 -column 1 -sticky ns
    }
    grid rowconfigure $ftext 0 -weight 1
    grid columnconfigure $ftext 0 -weight 1

    if { $solo_lectura} {
	# para que podamos aadir el texto
	$ftext.t1 configure -state normal
    }
    $ftext.t1 del 0.0 end
    $ftext.t1 ins end $__textvar
    if { $solo_lectura} {
	$ftext.t1 configure -state disabled
    }

    ####################################
    ### Botones
    ####################################
    frame $w.botones -bd 0 -background [ CCColorActivo $color_fondo]
    proc ActualizaVariable { var wtext} {
	#upvar $var __tt
	set tmp [ $wtext get 0.0 end]
	# quitamos el lf del final
	set $var [ string range $tmp 0 [ expr [ string length $tmp] - 2]]
    }

    button $w.botones.cerrar -text [_ "Close"] -bd 1 \
	    -command "if { !$solo_lectura} { \
	    bind $ftext.t1 <Alt-Return> {} \
	}; \
	bind $w.tf <Escape> {}; \
	bind $ftext.t1 <Escape> {}; \
	destroy $w"

    SetWidgetsWidthFromText $w.botones.cerrar

    if { !$solo_lectura} {
	button $w.botones.aceptar -text [_ "Apply"] -bd 1 \
		-command  "ActualizaVariable $varname $ftext.t1 ; after idle destroy $w"
	grid $w.botones.aceptar $w.botones.cerrar -pady 10 -padx 4 -sticky ews
    } else {
	grid $w.botones.cerrar -pady 10 -padx 4 -sticky ews
    }

    grid $w.tf -sticky wens -pady 4 -padx 4
    grid $w.botones -sticky sew
    if { $::tcl_version >= 8.5 } { grid anchor $w.botones center }

    grid rowconfigure $w 0 -weight 1
    grid columnconfigure $w 0 -weight 1

    #bind $w.tf <Shift-Return> "$w.botones.aceptar invoke"
    #bind $ftext.t1 <Shift-Return> "$w.botones.aceptar invoke"
    if { !$solo_lectura} {
	bind $ftext.t1 <Alt-Return> "$w.botones.aceptar invoke"
	bind $ftext.t1 <Alt-KP_Enter> "$w.botones.aceptar invoke"
    }
    bind $w.tf <Escape> "$w.botones.cerrar invoke"
    bind $ftext.t1 <Escape> "$w.botones.cerrar invoke"

    if { "$wparent" == "."} {
	set wp2 [ expr [ winfo screenwidth $wparent] / 2]
	set hp2 [ expr [ winfo screenheight $wparent] / 2]
    } else {
	set wp2 [ expr [ winfo width $wparent] / 2]
	set hp2 [ expr [ winfo height $wparent] / 2]
    }

    set cpx [ expr [ winfo rootx $wparent] + $wp2]
    set cpy [ expr [ winfo rooty $wparent] + $hp2]

    set wp2 [ expr [ winfo reqwidth $w] / 2]
    set hp2 [ expr [ winfo reqheight $w] / 2]

    set wx [ expr $cpx - $wp2]
    set wy [ expr $cpy - $hp2]
    if { $wx < 0} { set wx 1}
    if { $wy < 0} { set wy 1}

    wm geometry $w +${wx}+${wy}
    if { !$solo_lectura} {
	focus $ftext.t1
    } else {
	focus $w.botones.cerrar
    }

    tkwait window $w
    return $w
}


proc PostFrameLabel { w text { rel groove}} {
    frame $w -bd 2 -relief $rel
    set i 0
    set parent [winfo parent $w]
    if { $parent == "." } { set parent "" }
    set label $parent.__label$i
    while { [winfo exists $label] } {
	incr i
	set label $parent.__label$i
    }
    label $label -text $text -pady 0
    place $label -in $w -x 10 -y -1 -anchor w -bordermode outside
    after idle raise $label
    return $w
}


proc TryRoundRelief { w r { force_round 0}} {
    set new_relief $r

    if { ( $r != "raised") && ( $r != "sunken")} {
	$w configure -relief $r
	return
    }
    set has_round 0
    if { [ info exists ::tk_hasRoundRelief] && $::tk_hasRoundRelief} {
	if { $force_round || ( [ string first "round_" [ $w cget -relief]] != -1)} {
	    set has_round 1
	}
    }

    if { !$has_round} {
	$w configure -relief $r
	return
    }

    if { $r == "raised"} {
	set new_relief round_raised
    } elseif { $r == "sunken"} {
	set new_relief round_sunken
    }
    $w configure -relief $new_relief
}

########################################################################
### TraduceWidget
########################################################################
### procedimiento para usar widgets Tk o TileTk
########################################################################

namespace eval TraduceWidget {
    # 0 - tk; 1 - tile
    variable _tipo_widgets     0
    # valores para padx, pady cuando no se especifica alguno de los dos
    variable _padx_por_defecto 2
    variable _pady_por_defecto 2
    variable _trad_a_tile

    # _tbl_widets(widget,propiedad) = {variante_tk variante_tile}
    array set _a_tile_nombre {
	frame              ttk::frame
	button             ttk::button
	checkbutton        ttk::checkbutton
	combobox           ttk::combobox
	entry              ttk::entry
	label              ttk::label
	labelframe         ttk::labelframe
	menubutton         ttk::menubutton
	notebook           ttk::notebook
	radiobutton        ttk::radiobutton
	scrollbar          ttk::scrollbar
    }

    # propias de tile:
    #     -style             -style
    #     -padding           -padding
    array set _a_tile_frame {
	-class             -class
	-cursor            -cursor
	-takefocus         -takefocus

	-bd                -borderwidth
	-border            -borderwidth
	-borderwidth       -borderwidth
	-relief            -relief
	-height            -height
	-width             -width
    }

    # propias de tile:
    #     -style             -style
    array set _a_tile_button {
	-class             -class
	-compound          -compound
	-cursor            -cursor
	-image             -image
	-state             -state
	-takefocus         -takefocus
	-text              -text
	-textvariable      -textvariable
	-und               -underline
	-under             -underline
	-underline         -underline
	-width             -width

	-command           -command
	-default           -default
    }

    # propias de tile:
    #     -style             -style
    array set _a_tile_checkbutton {
	-class             -class
	-compound          -compound
	-cursor            -cursor
	-image             -image
	-state             -state
	-takefocus         -takefocus
	-text              -text
	-textvariable      -textvariable
	-und               -underline
	-under             -underline
	-underline         -underline
	-width             -width

	-command           -command
	-offvalue          -offvalue
	-onvalue           -onvalue
	-var               -variable
	-variable          -variable
    }

    # propias de tile:
    #     -style             -style
    #     -justify           -justify
    array set _a_tile_combobox {
	-class             -class
	-cursor            -cursor
	-takefocus         -takefocus

	-exportselection   -exportselection
	-height            -height
	-listvar           -values
	-opencommand       -postcommand
	-postcommand       -postcommand
	-state             -state
	-value             -value
	-values            -values
	-state             -state
	-width             -width
    }

    # propias de tile:
    #     -style             -style
    array set _a_tile_entry {
	-class             -class
	-cursor            -cursor
	-takefocus         -takefocus
	-xscroll           -xscrollcommand
	-xscrollcommand    -xscrollcommand

	-exportselection   -exportselection
	-invalidcommand    -invalidcommand
	-invcmd            -invalidcommand
	-justify           -justify
	-show              -show
	-state             -state
	-text              -text
	-textvariable      -textvariable
	-validate          -validate
	-validatecommand   -validatecommand
	-vcmd              -validatecommand
	-width             -width
    }

    # propias de tile:
    #     -style             -style
    #     -padding           -padding
    array set _a_tile_label {
	-class             -class
	-compound          -compound
	-cursor            -cursor
	-image             -image
	-takefocus         -takefocus
	-text              -text
	-textvariable      -textvariable
	-und               -underline
	-under             -underline
	-underline         -underline
	-width             -width

	-anchor            -anchor
	-bg                -background
	-background        -background
	-font              -font
	-fg                -foreground
	-foreground        -foreground
	-justify           -justify
	-relief            -relief
	-wraplength        -wraplength
    }

    # propias de tile:
    #     -style             -style
    #     -padding           -padding
    array set _a_tile_labelframe {
	-class             -class
	-cursor            -cursor
	-takefocus         -takefocus

	-text              -text
	-labelanchor       -labelanchor
	-labelwidget       -labelwidget
	-und               -underline
	-under             -underline
	-underline         -underline
	-width             -width
	-height            -height
    }

    # propias de tile:
    #     -style             -style
    array set _a_tile_menubutton {
	-class             -class
	-compound          -compound
	-cursor            -cursor
	-image             -image
	-state             -state
	-takefocus         -takefocus
	-text              -text
	-textvariable      -textvariable
	-und               -underline
	-under             -underline
	-underline         -underline
	-width             -width

	-direction         -direction
	-menu              -menu
    }

    # propias de tile:
    #     -style             -style
    array set _a_tile_notebook {
	-class             -class
	-cursor            -cursor
	-takefocus         -takefocus

	-width             -width
	-height            -height
    }

    # propias de tile:
    #     -style             -style
    array set _a_tile_radiobutton {
	-class             -class
	-compound          -compound
	-cursor            -cursor
	-image             -image
	-state             -state
	-takefocus         -takefocus
	-text              -text
	-textvariable      -textvariable
	-und               -underline
	-under             -underline
	-underline         -underline
	-width             -width

	-command           -command
	-value             -value
	-var               -variable
	-variable          -variable
    }

    # propias de tile:
    #     -style             -style
    array set _a_tile_scrollbar {
	-class             -class
	-cursor            -cursor
	-takefocus         -takefocus

	-command           -command
	-orient            -orient
    }
}

proc TraduceWidget::Transforma { clase nombre args} {
    variable _tipo_widgets
    variable _padx_por_defecto
    variable _pady_por_defecto

    variable _a_tile_nombre

    variable _a_tile_frame
    variable _a_tile_button
    variable _a_tile_checkbutton
    variable _a_tile_combobox
    variable _a_tile_entry
    variable _a_tile_label
    variable _a_tile_labelframe
    variable _a_tile_menubutton
    variable _a_tile_notebook
    variable _a_tile_radiobutton
    variable _a_tile_scrollbar

    if { ( $_tipo_widgets == 0) || ![ info exists _a_tile_nombre($clase)]} {
	return [ concat $clase $nombre $args]
    }

    set cmd [ list $_a_tile_nombre($clase) $nombre]
    set total_args 0
    set trad_args 0
    WarnWinText "[ llength $args]-$args"
    foreach {arg val} $args {
	set tbl _a_tile_${clase}($arg)
	if { [ info exists $tbl] } {
	    #WarnWinText "\t$arg --> [ subst $$tbl]"
	    lappend cmd [ subst $$tbl] $val
	    incr trad_args
	} else {
	    #WarnWinText "\t$arg --> $tbl?"
	}
	incr total_args
    }

    # vamos a ver si podemos tratar alguno mas
    if { $trad_args < $total_args} {
	set padx $_padx_por_defecto
	set pady $_pady_por_defecto
	set hay_padxy 0
	foreach {arg val} $args {
	    if { "$arg" == "-padx"} {
		set padx $val
		set hay_padxy 1
	    }
	    if { "$arg" == "-pady"} {
		set pady $val
		set hay_padxy 1
	    }
	}
	if { $hay_padxy} {
	    lappend $cmd -padding [ list $padx $pady]
	}
    }
    return [ concat $cmd]
}

proc TraduceWidget::TipoWidget { tipo} {
    variable _tipo_widgets

    set t [ string tolower $tipo]
    switch "$t" {
	"tk" {
	    set _tipo_widgets 0
	}
	"tile" {
	    if { $::tcl_version < 8.5 } {
		set _tipo_widgets 0
		set hay_err [ catch {
		    package require tile
		} err_txt]
		if { $hay_err} {
		    WarnWin "No se ha podido cargar tile: $err_txt"
		} else {
		    set _tipo_widgets 1
		}

		#if { [ lsearch [ ::tile::availableThemes] blue] == -1} {
		#        catch { [ source [ file join $::GIDDEFAULTTCL tile demos themes blue.tcl]]}
		#}
		if { [ lsearch [ ::tile::availableThemes] blue] != -1} {
		    ::tile::setTheme blue
		} else {
		    ::tile::setTheme clam
		}
	    } else {
		set _tipo_widgets 1
		if { [ lsearch [ ::tile::availableThemes] blue] != -1} {
		    ::tile::setTheme blue
		} else {
		    ::tile::setTheme clam
		}
	    }
	}
    }
}

proc TraduceWidget::TraduceWidget { clase nombre args} {
    variable _tipo_widgets
    variable _padx_por_defecto
    variable _pady_por_defecto

    variable _a_tile_nombre

    WarnWinText "-- [ concat $clase $nombre $args] --"
    set ret 0
    if { ( $_tipo_widgets == 0) || ![ info exists _a_tile_nombre($clase)]} {
	set ret [ eval [ concat $clase $nombre $args]]
    } else {
	set cmd [ eval TraduceWidget::Transforma $clase $nombre $args]
	WarnWinText "  --> -$cmd-"
	set ret [ eval $cmd]
    }
    return $ret
}

########################################################################
### ATTK a Tile Tk
########################################################################

set ATTK_inicializado 1 ;#use tile

proc ATTK_Inicializa { } {
    set ::ATTK_inicializado 1

    TraduceWidget::TipoWidget tile
    #TraduceWidget::TipoWidget tk
}

proc ATTK { clase nombre args} {
    if { !$::ATTK_inicializado } {
	ATTK_Inicializa
    }
    return [ eval TraduceWidget::TraduceWidget $clase $nombre $args]
}

########################################################################
### ResultSelectionWidget pahtName options
### options: -analysis { all | current } # default: all
###          -step { all | current}      # default: all
###          -result { all | current }   # default: all
###          -type { scalar | vector | matrix | localaxes}
###                                      # default:  scalar
###          -showcurrent { 0 | 1}       # default: 1
###          -show {{analysis} {step} {result} ?{component}?}
###          -variable var_name_dst      # a list with:
###                    # {analysis} {step} {result} ?{component}?
########################################################################

namespace eval ResultSelectionWidget {
    variable _opciones
    variable _opciones_posibles
    variable _lista_widgets    {}
    variable _tabla_widgets

    # opciones por defecto:
    array set _opciones {
	-analysis     all
	-step         all
	-result       all
	-type         scalar
	-showcurrent  1
    }

    # opciones posibles:
    array set _opciones_posibles \
	[ list \
	      -analysis    [ list all current] \
	      -step        [ list all current] \
	      -result      [ list all current] \
	      -type        [ list scalar vector matrix localaxes] \
	      -showcurrent [ list 0 1] \
	      -show        {} \
	      -variable    {} \
	     ]
	    
}

proc ResultSelectionWidget::Destroy { nombre} {
    variable _lista_widgets
    variable _tabla_widgets

    set idx [ lsearch $_lista_widgets $nombre]
    if { $idx != -1} {
	# borramos el procedimiento
	#rename $nombre
	set _lista_widgets [ lreplace $_lista_widgets $idx $idx]
	array unset _tabla_widgets ${nombre},*
    }
}

proc ResultSelectionWidget::ResultSelectionWidget { nombre args} {
    variable _lista_widgets
    variable _tabla_widgets
    variable _opciones
    global _opciones_posibles

    set err 0
    set err_msg ""
    foreach {opt val} $args {
	if { ![ info exists _opciones_posibles($opt)]} {
	    set err 1
	    set err_msg [ format [_ "incorrect option %s, should be one of %s"] \
		              $opt [ array names _opciones_posibles]]
	    break
	}
	if { "$val" == ""} {
	    set err 1
	    if { [ llength $_opciones_posibles($opt)] != 0} {
		set err_msg [ format [_ "empty value for option %s, should be one of %s"] \
		                  $opt $_opciones_posibles($opt)]
	    } else {
		set err_msg [ format [_ "empty value for option %s"] $opt]
	    }
	    break
	}
	if { ( [ llength $_opciones_posibles($opt)] != 0) && \
		 [ lsearch $_opciones_posibles($opt) $val] == -1} {
	    set err 1
	    set err_msg [ format [_ "incorrect value %s for option %s, should be one of %s"] \
		              $val $opt $_opciones_posibles($opt)]
	    break
	}
	set _opciones($opt) $val
    }

    if { $err} {
	puts $err_msg
	return -1
    }

    bind <Destroy> "+ResultSelectionWidget::Destroy %W"
    lappend _lista_widgets $nombre
    # por poner algo y acordarme donde lo tengo que meter
    set _tabla_widgets($nombre,args) $args
}

proc VerificaReal { msg texto { w .}} {
    set ret 1
    if { ![ regexp {^[  ]*([+-]?[0-9]*\.?[0-9]*([eE][+-]?[0-9]+)?)[  ]*$} $texto] } {
	WarnWin [ format "%s %s" $msg [_ "One number must be entered"]. ] $w
	set ret 0
    }
    return $ret
}

################################
# TTKMenubutton:
# TTKMenubutton widget
#         opciones validas:
#         -labels lista_etiquetas
#         -values lista_valores
#         -textvariable variable_para_guardar_el_valor
#         -modifycmd comando_a_llamar_cuando_se_selecciona_la_opcion
#         -commands lista_comandos_para_cada_label/value
#         -images lista_imagenes_para_cada_label/value
#      tambien admite las opciones estandard:
#         -width -height -state -style -takefocus -text -image -compount -cursor -underline -direction
# TTKMenubuttonInvoke widget TextoEntradaMenu
#                     --> selecciona e invoca la entrada de menu con texto TextoEntradaMenu
# TTKMenubuttonSelect widget TextoEntradaMenu
#                     --> muestra la entrada de menu con texto TextoEntradaMenu en el boton
# TTKMenubuttonConfigure widget opciones
#                     --> para redefinir opcionesl del widget
# TTKMenubuttonCGet widget opcion
#                     --> para conseguir informacion de alguna opcion del widget
################################

proc TTKMenubutton { w args} {
    if { $w == "."} {
	error ". can not be used as TTKMenubutton."
	return $w
    }
    array set opciones $args

    # opciones validas:
    # -labels lista_etiquetas
    # -values lista_valores
    # -textvariable variable_para_guardar_el_valor
    # -modifycmd comando_a_llamar_cuando_se_selecciona_la_opcion
    # -commands lista_comandos_para_cada_label/value
    # -images lista_imagenes_para_cada_label/value

    # las no definidas las ponemos vacias
    foreach opc [ list -labels -values -textvariable -modifycmd -commands -images] {
	if { ![ info exists opciones($opc)]} {
	    set opciones($opc) ""
	}
	set ::TTKMenubuttonOpciones($w,$opc) $opciones($opc)
    }

    set var_name ::ttkmb[ string map {. _ \# _} $w]
    if { $opciones(-textvariable) != "" } {
	set var_name $opciones(-textvariable)
    }

    # demas parsing de opciones
    # $::tcl_platform(os) != "Linux"
    if { [ tk windowingsystem] != "x11"} { # win32, x11 (linux/MacOSX), aqua, classic (MacOS)
	# si queremos distinguir diferentes versiones de Windows:
	# (platform) == "windows" && (osVersion) >= 5.1 (xp)
	ttk::menubutton $w -menu $w.m
    } else {
	menubutton $w -menu $w.m -indicatoron 1
    }
    menu $w.m -tearoff 0
    foreach txt $opciones(-labels) val $opciones(-values) cmd $opciones(-commands) img $opciones(-images) {
	if { ( $txt != "") && ( $val == "")} {
	    set val $txt
	}
	if { ( $txt == "") && ( $val != "")} {
	    set txt $val
	}
	set act_cmd "update; set $var_name [ list $val]; $cmd; $opciones(-modifycmd)"
	if { $img != ""} {
	    set cmd_menu "$w conf -text [ list $txt] -image $img -compound left; $act_cmd"
	    $w.m add command -label $txt -command $cmd_menu \
		-image $img -compound left
	} else {
	    set cmd_menu "$w conf -text [ list $txt] -image {} -compound left; $act_cmd"
	    $w.m add command -label $txt -command $cmd_menu
	}
    }

    foreach std_opc [ list -width -height -state -style -takefocus -text -image -compount -cursor -underline -direction] {
	if { [ info exists opciones($std_opc)]} {
	    $w configure $std_opc $opciones($std_opc)
	}
    }

    # por compatibilidad con ComboBox
    trace variable $var_name w "TTKMenubuttonSelectEntry $w $var_name"
    if { [ info exists $var_name]} {
	set $var_name [ subst $$var_name]
    } else {
	set $var_name ""
    }

    return $w
}

proc TTKMenubuttonSelectEntry { w var_name name1 name2 op} {
    if { [ winfo exists $w]} {
	#WarnWinText [ subst "TTKMenubuttonSelectEntry $w '$$var_name'"]
	TTKMenubuttonSelect $w [ subst $$var_name]
    } else {
	trace vdelete $var_name w "TTKMenubuttonSelectEntry $w $var_name"
    }
}

proc BuscaEntradaMenu { w str} {
    # set n [ $w.m index end]
    # for { set i 0} { $i <= $n} { incr i} {
    #         if { [ string equal $str [ $w.m entrycget $i -label]]} {
    #             return $i
    #         }
    # }
    # tenemos que tener encuenta que str es el valor de la variable
    set lst $::TTKMenubuttonOpciones($w,-values)
    if { [ llength $lst] == 0} {
	set lst $::TTKMenubuttonOpciones($w,-labels)
    }
    #WarnWinText "$str --> $lst"
    set idx [ lsearch $lst $str]
    return $idx
}

proc TTKMenubuttonSelect { w str} {
    if { $w == "."} {
	error ". can not be used as TTKMenubutton."
	return $w
    }
    set idx -1
    # si str es una palabra, busca entre los labels de las entradas del menu
    # pero si es un numero o 'end' lo trata como un numero y no como texto de la entrada del menu
    # set err [ catch {
    #         set idx [ $w.m index $str]
    # }]
    set idx [ BuscaEntradaMenu $w $str]
    #WarnWin "$idx|$str"
    #WarnWinText "TTKMenubuttonSelect $w '$str'"
    if { $idx != -1} {
	$w conf -text [ $w.m entrycget $idx -label] \
	    -image [ $w.m entrycget $idx -image] -compound left
    }
    return $w
}

proc TTKMenubuttonInvoke { w str} {
    set idx -1
    # si str es una palabra, busca entre los labels de las entradas del menu
    # pero si es un numero o 'end' lo trata como un numero y no como texto de la entrada del menu
    # set err [ catch {
    #         set idx [ $w.m index $str]
    # }]
    set idx [ BuscaEntradaMenu $w $str]
    if { $idx != -1} {
	$w.m invoke $idx
    }
    return $w
}

proc TTKMenubuttonConfigure { w args} {
    if { $w == "."} {
	error ". can not be used as TTKMenubutton."
	return $w
    }
    if { ![ winfo exists $w]} {
	error "TTKMenubutton $w does not exist."
	return $w
    }
    array set opciones $args

    # opciones validas:
    # -labels lista_etiquetas
    # -values lista_valores
    # -textvariable variable_para_guardar_el_valor
    # -modifycmd comando_a_llamar_cuando_se_selecciona_la_opcion
    # -commands lista_comandos_para_cada_label/value
    # -images lista_imagenes_para_cada_label/value

    # las no definidas las ponemos vacias
    foreach opc [ list -labels -values -textvariable -modifycmd -commands -images] {
	if { ![ info exists opciones($opc)]} {
	    set opciones($opc) $::TTKMenubuttonOpciones($w,$opc)
	}
	set ::TTKMenubuttonOpciones($w,$opc) $opciones($opc)
    }

    set var_name ::ttkmb[ string map {. _ \# _} $w]
    if { $opciones(-textvariable) != "" } {
	set var_name $opciones(-textvariable)
    }

    # si la variable es diferente, quitamos el trace anterior
    if { $var_name != $opciones(-textvariable)} {
	set trace_inf [ trace vinfo $opciones(-textvariable)]
	foreach it $trace_inf {
	    trace vdelete $opciones(-textvariable) [ lindex $it 0] [ lindex $it 1]
	}
    }

    # demas parsing de opciones
    # ttk::menubutton $w -menu $w.m
    # menu $w.m -tearoff 0
    $w.m delete 0 end
    foreach txt $opciones(-labels) val $opciones(-values) cmd $opciones(-commands) img $opciones(-images) {
	if { ( $txt != "") && ( $val == "")} {
	    set val $txt
	}
	if { ( $txt == "") && ( $val != "")} {
	    set txt $val
	}
	set act_cmd "update; set $var_name [ list $val]; $cmd; $opciones(-modifycmd)"
	if { $img != ""} {
	    set cmd_menu "$w conf -text [ list $txt] -image $img -compound left; $act_cmd"
	    $w.m add command -label $txt -command $cmd_menu \
		-image $img -compound left
	} else {
	    set cmd_menu "$w conf -text [ list $txt] -image {} -compound left; $act_cmd"
	    $w.m add command -label $txt -command $cmd_menu
	}
	#WarnWinText "$w --> $txt --> $cmd_menu"
    }

    # las opciones estandard
    foreach std_opc [ list -width -height -state -style -takefocus -text -image -compount -cursor -underline -direction] {
	if { [ info exists opciones($std_opc)]} {
	    $w configure $std_opc $opciones($std_opc)
	}
    }

    # por compatibilidad con ComboBox
    # si la variable es direfente, la hemos quitado antes y ahora hay que registrarla
    trace variable $var_name w "TTKMenubuttonSelectEntry $w $var_name"
    if { [ info exists $var_name]} {
	set $var_name [ subst $$var_name]
    } else {
	set $var_name ""
    }
    #
    # foreach it $trace_inf {
    #         trace variable $var_name [ lindex $it 0] [ lindex $it 1]
    # }

    return $w
}

proc TTKMenubuttonCGet { w opc} {
    set lst_opc [ list -labels -values -textvariable -modifycmd -commands -images]
    set std_opc [ list -width -height -state -style -takefocus -text -image -compount -cursor -underline -direction]
    if { [ lsearch $lst_opc $opc] != -1} {
	return $::TTKMenubuttonOpciones($w,$opc)
    } elseif { [ lsearch $std_opc $opc]} {
	return $w cget $opc
    } else {
	error "Incorrect cget-option '$opc' for $w. should be one of '[ join $lst_opc]' or '[ join $std_opc]'"
	return {}
    }
}

################################
# TTKMessagebox:
# TTKMessagebox widget como el messagebox, pero con una lista de etiquetas/valores donde elegir
#         la etiqueta/valor seleccionado devuelve el valor
#         opciones validas:
#         -title titulo
#         -message mensaje_de_la_ventana
#         -labels lista_etiquetas
#         -values lista_valores
#         -textvariable variable_para_guardar_el_valor
#         -images lista_imagenes_para_cada_label/value
#      tambien admite las opciones estandard:
#         -parent
#         -icon nombre del icono a mostrar
################################

proc TTKMessagebox { args} {
    array set opciones $args
    set windowingsystem [ tk windowingsystem]

    # opciones validas:
    # -title titulo_de_la_ventana
    # -message mensaje_de_la_ventana
    # -labels lista_etiquetas
    # -values lista_valores
    # -textvariable variable_para_guardar_el_valor
    # -images lista_imagenes_para_cada_label/value
    # -parent aunque de momento no se usa para nada
    # -icon nombre del icono a mostrar
    # devuelve el valor seleccionado

    # las no definidas las ponemos vacias
    foreach opc [ list -title -message -labels -values -textvariable -images -parent -icon] {
	if { ![ info exists opciones($opc)]} {
	    set opciones($opc) ""
	}
    }

    if { $opciones(-parent) == ""} {
	set opciones(-parent) .
    }

    if { $opciones(-parent) != "."} {
	set w $opciones(-parent).___TTKMessagebox_tmp_
    } else {
	set w .___TTKMessagebox_tmp_
    }
    if { $w == "."} {
	error ". can not be used as TTKMessagebox."
	return $w
    }

    foreach opc [ list -title -message -labels -values -textvariable -images -parent -icon] {
	set ::TTKMessageboxOpciones($w,$opc) $opciones($opc)
    }

    set var_name ::ttkmb[ string map {. _ \# _} $w]
    if { $opciones(-textvariable) != "" } {
	set var_name $opciones(-textvariable)
    }

    # set def_back [ $w cget -background]
    set def_back [ ttk::style lookup . -background]

    if { [ winfo exists $w]} {
	error "$w already exists"
	return {}
    }

    # creacion de la ventana
    toplevel $w -class Dialog -bg $def_back
    if { $opciones(-title) != ""} {
	wm title $w $opciones(-title)
    } else {
	wm title $w TTKMessagebox
    }
    wm iconname $w Dialog
    wm protocol $w WM_DELETE_WINDOW { }

    if { [ winfo viewable [ winfo toplevel $opciones(-parent)]] } {
	wm transient $w $opciones(-parent)
    }

    if {$windowingsystem eq "aqua"} {
	::tk::unsupported::MacWindowStyle style $w moveableModal {}
    }

    # top frame
    set f [ ttk::frame $w.fTop -relief flat]

    ttk::label $f.tMes -anchor nw -justify left -text $opciones(-message)
    if { $opciones(-icon) != ""} {
	label $f.lIcon -image $opciones(-icon)
	grid $f.lIcon $f.tMes -sticky news -padx 4 -pady 2
	grid columnconfigure $f 1 -weight 1
    } else  {
	grid columnconfigure $f 0 -weight 1
    }
    grid rowconfigure $f 0 -weight 1

    # bottom frame
    # set f [ ttk::frame $w.fBot -relief flat]
    set f [ frame $w.fBot -relief flat -background [ CCColorActivo $def_back]]
    set numBotonesLinea 4
    set ifila 0
    set icol 0
    set iBoton 0
    foreach txt $opciones(-labels) val $opciones(-values) img $opciones(-images) {
	if { ( $txt != "") && ( $val == "")} {
	    set val $txt
	}
	if { ( $txt == "") && ( $val != "")} {
	    set txt $val
	}
	set cmd "set $var_name [ list $val]; destroy $w"
	if { $img != ""} {
	    set opts [ list -text $txt -image $img]
	} else {
	    set opts [ list -text $txt]
	}
	eval [list tk::AmpWidget ttk::button $f.b$iBoton] $opts \
	    [list -command $cmd]

	grid $f.b$iBoton -row $ifila -column $icol -padx 3m -pady 2m
	incr icol
	if { $icol == $numBotonesLinea} {
	    incr ifila
	    set icol 0
	}
	incr iBoton
    }

    grid $w.fTop -sticky news
    grid $w.fBot -sticky ew
    grid rowconfigure $w 0 -weight 1
    grid rowconfigure $w 1 -weight 1
    grid columnconfigure $w 0 -weight 1

    # foreach std_opc [ list -width -height -state -style -takefocus -text -image -compount -cursor -underline -direction] {
    #         if { [ info exists opciones($std_opc)]} {
    #             $w configure $std_opc $opciones($std_opc)
    #         }
    # }

    # por compatibilidad con ComboBox
    tkwait window $w

    return [ subst $$var_name]
}


################################
# TTKComboBox:
# TTKComboBox widget
#         opciones validas:
#         -labels lista_etiquetas
#         -values lista_valores
#         -textvariable variable_para_guardar_el_valor
#         -modifycmd comando_a_llamar_cuando_se_selecciona_la_opcion
#  ( QUITADO)        -commands lista_comandos_para_cada_label/value
#  ( QUITADO)        -images lista_imagenes_para_cada_label/value
#      tambien admite las opciones estandard:
#         -width -height -state -style -takefocus -text -image -compount -cursor -underline -direction -state
# TTKComboBoxConfigure widget opciones
#                     --> para redefinir opcionesl del widget
# TTKComboBoxCGet widget opcion
#                     --> para conseguir informacion de alguna opcion del widget
################################

proc defineWidget_destroy { tipo w} {
    bind $w <1> ""
    foreach opc [ array names ::${tipo}Opciones ${w}*] {
	unset ::${tipo}Opciones($opc)
    }
    rename $w ""
    # rename ${w}_original $w
    destroy $w
}

proc defineWidgetProc { tipo w cmd args} {
    set nombreProc ${tipo}_$cmd
    if { [ llength [ info procs $nombreProc]] != 0} {
	return [ eval [ linsert $args 0 ${tipo}_$cmd [ list $w]]]
    } else {
	return [ eval ${w}_original $cmd $args]
    }
}

proc defineWidget { tipo w} {
    rename ${w} ${w}_original
    # proc ::$w { cmd args } \
    #         [subst {return \[eval \[linsert \$args 0 ${tipo}_\$cmd [list $w]\]\]}]
    proc ::$w { cmd args} \
	[ subst { return \[ eval defineWidgetProc ${tipo} $w \$cmd \$args\]}]

    bind $w <Destroy> [ list defineWidget_destroy $tipo $w]
}

proc TTKComboBox { w args} {
    if { $w == "."} {
	error ". can not be used as TTKComboBox."
	return $w
    }
    array set opciones $args

    # opciones validas:
    # -labels lista_etiquetas
    # -values lista_valores
    # -textvariable variable_para_guardar_el_valor
    # -modifycmd comando_a_llamar_cuando_se_selecciona_la_opcion
    # -commands lista_comandos_para_cada_label/value
    # -images lista_imagenes_para_cada_label/value

    # las no definidas las ponemos vacias
    # -commands -images
    foreach opc [ list -labels -values -textvariable -modifycmd] {
	if { ![ info exists opciones($opc)]} {
	    set opciones($opc) ""
	}
	set ::TTKComboBoxOpciones($w,$opc) $opciones($opc)
    }

    # para hacer las traducciones de etiquetas a valores se utiliza una variable interna
    set var_name_int ::ttkcb_int_[ string map {. _ \# _} $w]
    if { $opciones(-textvariable) != "" } {
	set var_name_int ::ttkcb_int_[ regsub -all {::} $opciones(-textvariable) {__}]
    }

    set var_name ::ttkcb[ string map {. _ \# _} $w]
    if { $opciones(-textvariable) != "" } {
	set var_name $opciones(-textvariable)
    }
    set ::TTKComboBoxOpciones($w,VariableInterna) $var_name_int
    set ::TTKComboBoxOpciones($w,VariableExterna) $var_name

    # demas parsing de opciones
    # $::tcl_platform(os) != "Linux"
    # if { [ tk windowingsystem] != "x11"} { # win32, x11 (linux/MacOSX), aqua, classic (MacOS)
    #         # si queremos distinguir diferentes versiones de Windows:
    #         # (platform) == "windows" && (osVersion) >= 5.1 (xp)
    #         ttk::combobox $w
    # } else {
    #         # menubutton $w -menu $w.m -indicatoron 1
    #         ComboBox $w -indicatoron 1
    # }

    set lst_lbl {}
    set lst_val {}
    # cmd $opciones(-commands) img $opciones(-images)
    foreach txt $opciones(-labels) val $opciones(-values) {
	if { ( $txt != "") && ( $val == "")} {
	    set val $txt
	}
	if { ( $txt == "") && ( $val != "")} {
	    set txt $val
	}
	# set act_cmd "update; set $var_name [ list $val]; $cmd; $opciones(-modifycmd)"
	# if { $img != ""} {
	#     set cmd_menu "$w conf -text [ list $txt] -image $img -compound left; $act_cmd"
	#     $w.m add command -label $txt -command $cmd_menu \
	#         -image $img -compound left
	# } else {
	#     set cmd_menu "$w conf -text [ list $txt] -image {} -compound left; $act_cmd"
	#     $w.m add command -label $txt -command $cmd_menu
	# }
	lappend lst_lbl $txt
	lappend lst_val $val
    }
    set ::TTKComboBoxOpciones($w,ListaEtiquetas) $lst_lbl
    set ::TTKComboBoxOpciones($w,ListaValores) $lst_val

    ttk::combobox $w -textvariable $var_name_int -values $lst_lbl
    # WarnWinText "ttk::combobox $w -textvariable $var_name_int -values $lst_lbl"

    # antes de definir que cree el widget, para que no llame al procedimiento equivocado
    defineWidget TTKComboBox $w

    # por compatibilidad con ComboBox
    if { [ info exists $var_name]} {
	set $var_name [ subst $$var_name]
    } else {
	set $var_name ""
    }

    # mapeo de la entrada seleccionada del comobox al valor a poner en la variable del usuario
    trace variable $var_name_int w "TTKComboBoxEntrySelected $w $var_name_int"
    # mapeo del valor puesto por el usuario en la variable a la entrada seleccionada en el combobox
    trace variable $var_name w "TTKComboBoxSelectEntry $w $var_name"

    # definimos el resto de opciones despues de poner los valors por defecto
    # para evitar que se llame a -modifycmd cuando se esta creando y postniendo la variable
    # a su valor por defecto
    foreach std_opc [ list -width -height -state -style -takefocus -text -image \
		          -compount -cursor -underline -direction -state] {
	if { [ info exists opciones($std_opc)]} {
	    $w configure $std_opc $opciones($std_opc)
	}
    }

    return $w
}

# Etiqueta seleccionada en la combobox --> valor en la variable del usuario
proc TTKComboBoxEntrySelected { w var_name_int name1 name2 op} {
    # if { [ winfo exists $w]} {
    #         #WarnWinText [ subst "TTKComboBoxSelectEntry $w '$$var_name'"]
    #         TTKComboBoxSelect $w [ subst $$var_name]
    # } else {
    #         trace vdelete $var_name w "TTKComboBoxSelectEntry $w $var_name"
    # }
    if { [ winfo exists $w] } {
	set idx [ lsearch $::TTKComboBoxOpciones($w,ListaEtiquetas) [ subst $$var_name_int]]
	if { $idx >= 0} {
	    set val [ lindex $::TTKComboBoxOpciones($w,ListaValores) $idx]
	} else {
	    set val [ subst $$var_name_int]
	}
	# WarnWinText "set $::TTKComboBoxOpciones($w,VariableExterna) $val"
	set $::TTKComboBoxOpciones($w,VariableExterna) $val
	if { $::TTKComboBoxOpciones($w,-modifycmd) != ""} {
	    eval $::TTKComboBoxOpciones($w,-modifycmd)
	}
    } else {
	trace vdelete $var_name_int w "TTKComboBoxEntrySelected $w $var_name_int"
    }
}

# valor puesto por el usuario en la variable --> seleccionar etiqueta en la combobox
proc TTKComboBoxSelectEntry { w var_name name1 name2 op} {
    if { [ winfo exists $w] } {
	set idx [ lsearch $::TTKComboBoxOpciones($w,ListaValores) [ subst $$var_name]]
	if { $idx >= 0} {
	    set etiq [ lindex $::TTKComboBoxOpciones($w,ListaEtiquetas) $idx]
	} else {
	    set etiq [ subst $$var_name]
	}
	# WarnWinText "set $::TTKComboBoxOpciones($w,VariableInterna) $etiq"
	set $::TTKComboBoxOpciones($w,VariableInterna) $etiq
    } else {
	trace vdelete $var_name w "TTKComboBoxSelectEntry $w $var_name"
    }
}

### proc TTKComboBoxExample {} {
###     toplevel .pepito
###     TTKComboBox .pepito.tcb -textvariable ::hola -values "A1 A2 A3" -labels "a1 a2 a3"
###     ttk::frame .pepito.fb
###     ttk::button .pepito.fb.b1 -text "Show" -command { WarnWin "::hola = $::hola"}
###     ttk::button .pepito.fb.b2 -text "Close" -command "destroy .pepito"
###     grid .pepito.fb.b1 .pepito.fb.b2 -padx 4 -pady 2
###
###     grid .pepito.tcb -sticky news
###     grid .pepito.fb -sticky ew
### }

### proc BuscaEntradaMenu { w str} {
###     # set n [ $w.m index end]
###     # for { set i 0} { $i <= $n} { incr i} {
###     #         if { [ string equal $str [ $w.m entrycget $i -label]]} {
###     #             return $i
###     #         }
###     # }
###     # tenemos que tener encuenta que str es el valor de la variable
###     set lst $::TTKComboBoxOpciones($w,-values)
###     if { [ llength $lst] == 0} {
###         set lst $::TTKComboBoxOpciones($w,-labels)
###     }
###     #WarnWinText "$str --> $lst"
###     set idx [ lsearch $lst $str]
###     return $idx
### }
###
### proc TTKComboBoxSelect { w str} {
###     if { $w == "."} {
###         error ". can not be used as TTKComboBox."
###         return $w
###     }
###     set idx -1
###     # si str es una palabra, busca entre los labels de las entradas del menu
###     # pero si es un numero o 'end' lo trata como un numero y no como texto de la entrada del menu
###     # set err [ catch {
###     #         set idx [ $w.m index $str]
###     # }]
###     set idx [ BuscaEntradaMenu $w $str]
###     #WarnWin "$idx|$str"
###     #WarnWinText "TTKComboBoxSelect $w '$str'"
###     if { $idx != -1} {
###         $w conf -text [ $w.m entrycget $idx -label] \
###             -image [ $w.m entrycget $idx -image] -compound left
###     }
###     return $w
### }
###
### proc TTKComboBoxInvoke { w str} {
###     set idx -1
###     # si str es una palabra, busca entre los labels de las entradas del menu
###     # pero si es un numero o 'end' lo trata como un numero y no como texto de la entrada del menu
###     # set err [ catch {
###     #         set idx [ $w.m index $str]
###     # }]
###     set idx [ BuscaEntradaMenu $w $str]
###     if { $idx != -1} {
###         $w.m invoke $idx
###     }
###     return $w
### }

proc TTKComboBox_configure { w args} {
    # WarnWin "TTKComboBox_configure $w $args"
    if { $w == "."} {
	error ". can not be used as TTKComboBox."
	return $w
    }
    if { ![ winfo exists $w]} {
	error "TTKComboBox $w does not exist."
	return $w
    }
    array set opciones $args

    # opciones validas:
    # -labels lista_etiquetas
    # -values lista_valores
    # -textvariable variable_para_guardar_el_valor
    # -modifycmd comando_a_llamar_cuando_se_selecciona_la_opcion
    # -commands lista_comandos_para_cada_label/value
    # -images lista_imagenes_para_cada_label/value

    # las no definidas las ponemos vacias
    #  -commands -images
    foreach opc [ list -labels -values -textvariable -modifycmd] {
	if { ![ info exists opciones($opc)]} {
	    if { [ info exists ::TTKComboBoxOpciones($w,$opc)]} {
		set opciones($opc) $::TTKComboBoxOpciones($w,$opc)
	    } else {
		set opciones($opc) ""
	    }
	}
	set ::TTKComboBoxOpciones($w,$opc) $opciones($opc)
    }

    # para hacer las traducciones de etiquetas a valores se utiliza una variable interna
    set var_name_int ::ttkcb_int_[ string map {. _ \# _} $w]
    if { $opciones(-textvariable) != "" } {
	    set var_name_int ::ttkcb_int_[ regsub -all {::} $opciones(-textvariable) {__}]
    }

    set var_name ::ttkcb[ string map {. _ \# _} $w]
    if { $opciones(-textvariable) != "" } {
	    set var_name $opciones(-textvariable)
    }

    # si la variable es diferente, quitamos el trace anterior
    if { $var_name != $opciones(-textvariable)} {
	    set trace_inf [ trace vinfo $opciones(-textvariable)]
	    foreach it $trace_inf {
		trace vdelete $opciones(-textvariable) [ lindex $it 0] [ lindex $it 1]
	    }
    }

    # set var_name_int $::TTKComboBoxOpciones($w,VariableExterna)
    # set var_name $::TTKComboBoxOpciones($w,VariableInterna)
    #
    # # borramos nuestros trace's para evitar lanzarlos
    # trace vdelete $var_name_int w "TTKComboBoxEntrySelected $w $var_name_int"
    # # mapeo del valor puesto por el usuario en la variable a la entrada seleccionada en el combobox
    # trace vdelete $var_name w "TTKComboBoxSelectEntry $w $var_name"

    # demas parsing de opciones
    # ttk::menubutton $w -menu $w.m
    # menu $w.m -tearoff 0
    # $w.m delete 0 end
    set lst_lbl {}
    set lst_val {}
    #  cmd $opciones(-commands) img $opciones(-images)
    foreach txt $opciones(-labels) val $opciones(-values) {
	if { ( $txt != "") && ( $val == "")} {
	    set val $txt
	}
	if { ( $txt == "") && ( $val != "")} {
	    set txt $val
	}
	# set act_cmd "update; set $var_name [ list $val]; $cmd; $opciones(-modifycmd)"
	# if { $img != ""} {
	#     set cmd_menu "$w conf -text [ list $txt] -image $img -compound left; $act_cmd"
	#     $w.m add command -label $txt -command $cmd_menu \
	#         -image $img -compound left
	# } else {
	#     set cmd_menu "$w conf -text [ list $txt] -image {} -compound left; $act_cmd"
	#     $w.m add command -label $txt -command $cmd_menu
	# }
	#WarnWinText "$w --> $txt --> $cmd_menu"
	lappend lst_lbl $txt
	lappend lst_val $val
    }
    set ::TTKComboBoxOpciones($w,ListaEtiquetas) $lst_lbl
    set ::TTKComboBoxOpciones($w,ListaValores) $lst_val

    # WarnWinText "${w}_original configure -values $lst_lbl [ llength $lst_lbl]"
    ${w}_original configure -values $lst_lbl
    # WarnWinText "${w}_original configure -values $lst_lbl"

    # las opciones estandard
    foreach std_opc [ list -width -height -state -style -takefocus -text -image \
		          -compount -cursor -underline -direction -state] {
	if { [ info exists opciones($std_opc)]} {
	    ${w}_original configure $std_opc $opciones($std_opc)
	}
    }

    # por compatibilidad con ComboBox
    # si la variable es direfente, la hemos quitado antes y ahora hay que registrarla
    # mapeo del valor puesto por el usuario en la variable a la entrada seleccionada en el combobox

    # para evitar lanzar modifycmd que no tocan:
    set antes $::TTKComboBoxOpciones($w,-modifycmd)
    set ::TTKComboBoxOpciones($w,-modifycmd) ""
    if { [ info exists $var_name]} {
	set $var_name [ subst $$var_name]
    } else {
	set $var_name ""
    }
    set ::TTKComboBoxOpciones($w,-modifycmd) $antes

    trace variable $var_name w "TTKComboBoxSelectEntry $w $var_name"

    # # volvemos a definir nuestros traces
    # trace variable $var_name_int w "TTKComboBoxEntrySelected $w $var_name_int"
    # trace variable $var_name w "TTKComboBoxSelectEntry $w $var_name"

    #
    # foreach it $trace_inf {
    #         trace variable $var_name [ lindex $it 0] [ lindex $it 1]
    # }

    return $w
}

proc TTKComboBox_cget { w args} {
    # WarnWin "TTKComboBox_cget $w $args"
    # WarnWinText "TTKComboBox_cget $w $args"
    # WarnWinText "namespace: [ namespace current]"
    # set fr_level [ info frame]
    # while { $fr_level >= 0} {
    #         WarnWinText "     ${fr_level}:[ info frame $fr_level]"
    #         set fr_level [ expr $fr_level - 1]
    # }

    # desde donde nos llaman
    # si es desde ttk --> no hacemos nada
    # si es desde cualquier otro lado --> hacemos parsing de nuestras variables
    set desdeTTK 0
    set fr_level [ info frame]
    while { $fr_level >= 0} {
	array set infoLvl [ info frame $fr_level]
	# if { ![ info exists infoLvl(proc)] } {
	#     WarnWinText "$fr_level - [ array get infoLvl]"
	# }
	if { [ info exists infoLvl(proc)] && [ regexp {.*::ttk::combobox.*} $infoLvl(proc)] } {
	    set desdeTTK 1
	    break
	}
	set fr_level [ expr $fr_level - 1]
	unset infoLvl
    }

    # set lst_opc [ list -labels -values -textvariable -modifycmd -commands -images]
    # set std_opc [ list -width -height -state -style -takefocus -text -image \
    #                       -compount -cursor -underline -direction -state]
    # if { [ lsearch $lst_opc $opc] != -1} {
    #         return $::TTKComboBoxOpciones($w,$opc)
    # } elseif { [ lsearch $std_opc $opc]} {
    #         return ${w}_original cget $opc
    # } else {
    #         error "Incorrect cget-option '$opc' for $w. should be one of '[ join $lst_opc]' or '[ join $std_opc]'"
    #         return {}
    # }

    if { !$desdeTTK} {
	# opciones a interceptar:
	set lst_opc [ list -labels -values -textvariable -modifycmd -commands -images]
	
	set cuantos [ llength $args]
	set ret {}
	if { $cuantos == 0} {
	    # todos
	    set ret [ ${w}_original cget]
	    foreach opc $lst_opc {
		if { [ info exists ::TTKComboBoxOpciones($w,$opc)]} {
		    lappend ret [ list $opc $::TTKComboBoxOpciones($w,$opc)]
		}
	    }
	} else {
	    # solo hacemos caso al primero
	    set opc [ lindex $args 0]
	    if { [ info exists ::TTKComboBoxOpciones($w,$opc)]} {
		set ret $::TTKComboBoxOpciones($w,$opc)
	    } else {
		set ret [ ${w}_original cget $opc]
	    }
	}
    } else {
	set ret [ ${w}_original cget $args]
    }

    return $ret
}

# # solo trato los comandos configure y cget, el resto:
# foreach cmd [ list current get identify instate set state selection] {
#     proc TTKComboBox_${cmd} { w args } \
#         [subst {return \[eval \${w}_original ${cmd} \$args \]}]
# }

# setTooltip para definir globos de ayuda, tb en los menus
# set Tooltip widget opciones
# opciones validas:
# texto --> texto a aparecer
# -text texto --> texto a apareces
# -textvariable nombreVariable --> variable con la que el balon se actualizara ( para menus)
# para el balon de los menus, se usa en conjuncion con el DynamicHelp de BWidget
# ejemplo con menus:
#
# menu .m -type menubar
# # associate menubar to toplevel BEFORE DynamicHelp::register
# # to make it works with menu clone name
# . configure -menu .m
# .m add cascade -label "File" -menu .m.file
# menu .m.file
# .m.file add command -label "Open..."
# .m.file add command -label "Quit"
#
# # la variable donde se guardara el texto de ayuda que toca
# set ::varinfo ""
# # associate all entries of menu .m.file to variable varinfo
# DynamicHelp::register .m.file menu ::varinfo
# # then declare entries of .m.file
# DynamicHelp::register .m.file menuentry 0 "Detach menu"
# DynamicHelp::register .m.file menuentry 1 "Open a file"
# DynamicHelp::register .m.file menuentry 2 "Exit demo"
# setTooltip .m.file -textvariable ::varinfo

proc setTooltip { widget args} {
    # WarnWinText "setting tooltip: $widget - [ llength $args] = $args"
    if { $args != "" } {
	set parsedArgs {}
	foreach ar $args {
	    lappend parsedArgs [ regsub -all {%} $ar {%%}]
	}
	# 2) Adjusted timings and added key and button bindings. These seem to
	# make artifacts tolerably rare.
	bind $widget <Any-Enter>    [ list after 2000 [ list showTooltip %W $parsedArgs]]
	# bind $widget <Motion>       [ list after    0 [ list destroy %W.tooltip]]
	bind $widget <Any-Leave>    [ list after  500 [ list destroy %W.tooltip]]
	bind $widget <Any-KeyPress> [ list after  500 [ list destroy %W.tooltip]]
	bind $widget <Any-Button>   [ list after  500 [ list destroy %W.tooltip]]
	# after 2000 [ list showTooltip $widget $args]
    }
}

proc showTooltip { widget lst_args} {
    global tcl_platform

    if { [ string match $widget* [winfo containing  [winfo pointerx .] [winfo pointery .]] ] == 0  } {
# WarnWinText "string did not match: got '[winfo containing  [winfo pointerx .] [winfo pointery .]]'"
	return
    }

    catch { destroy $widget.tooltip }
    # WarnWinText "showing tooltip: $widget - [ llength $lst_args] $lst_args"
    # parsing de parametros:
    set varName ""
    set text ""
    set args $lst_args
    if { [ llength $args] == 1} {
	set text [ lindex $args 0]
    } else {
	array set opciones $args
	# opciones validas:
	# -text texto
	# -textvariable variable_para_actualizar el contenido de la ayuda
	if { [ info exists opciones(-text)] } {
	    set text $opciones(-text)
	}
	if { [ info exists opciones(-textvariable)] } {
	    set varName $opciones(-textvariable)
	}
    }
    # fin parsing parametros

    set scrh [winfo screenheight $widget]    ; # 1) flashing window fix
    set scrw [winfo screenwidth $widget]     ; # 1) flashing window fix
    set tooltip [toplevel $widget.tooltip -bd 1 -bg black]
    wm geometry $tooltip +$scrh+$scrw        ; # 1) flashing window fix
    wm overrideredirect $tooltip 1

    if {$tcl_platform(platform) == {windows}} { ; # 3) wm attributes...
	wm attributes $tooltip -topmost 1   ; # 3) assumes...
    }                                           ; # 3) Windows
    if { $varName == ""} {
	pack [label $tooltip.label -bg lightyellow -fg black -text $text -justify left]
    } else {
	pack [label $tooltip.label -bg lightyellow -fg black -textvariable $varName -justify left] -fill x
    }

    set width [winfo reqwidth $tooltip.label]
    set height [winfo reqheight $tooltip.label]

    set positionX [winfo pointerx .]
    set positionY [expr [winfo pointery .] + 25]

    # a.) Ad-hockery: Set positionX so the entire tooltip widget will be displayed.
    if  {[expr $positionX + $width] > [winfo screenwidth .]} {
	set positionX [expr ($positionX - (($positionX + $width) - [winfo screenwidth .]))]
    }

    wm geometry $tooltip [join  "$width x $height + $positionX + $positionY" {}]
    raise $tooltip

    # 2) Kludge: defeat rare artifact by passing mouse over a tooltip to destroy it.
    bind $widget.tooltip <Any-Enter> {destroy %W}
    bind $widget.tooltip <Any-Leave> {destroy %W}

    bind $widget <Any-Leave>    [ list after  500 [ list destroy %W.tooltip]]
    bind $widget <Any-KeyPress> [ list after  500 [ list destroy %W.tooltip]]
    #bind $widget <Any-Button>   [ list after  500 [ list destroy %W.tooltip]]
    # despues de un momento matarlo:
    # after  3000 [ list destroy $tooltip]
}

#ajustar el ancho de los botones en mac OS X
proc adjustButtonWidth { width_org} {
    set width $width_org
    if { $::tcl_platform(os) == "Darwin"} {
	# en macOsX los botoncitos tienen los extremos redondos: necesitan un poco mas de espacio
	incr width 5
    }
    return $width
}

proc adjustButton { widget} {
    if { ![ winfo exists $widget]} {
	return
    }
    set width [ string length [ $widget cget -text]]
    if { $::tcl_platform(os) == "Darwin"} {
	# en macOsX los botoncitos tienen los extremos redondos: necesitan un poco mas de espacio
	incr width 5
	$widget configure -width $width
    }
}

################################
# LabelButton:
# boton para poder definir un color. el boton cambia de color al seleccionar un color
# se implementa con un label, pues en mac no se pueden poner colores en los botones
################################

proc LabelButtonExecuteCommand { w} {
    if { $::LabelButtonOpciones($w,-state) != "disabled"} {
	if { $::LabelButtonOpciones($w,-command) != ""} {
	    # eval $::LabelButtonOpciones($w,-command)
	    uplevel $::LabelButtonOpciones($w,-command)
	}
    }
}

proc LabelButton_configure { w args} {
    if { $w == "."} {
	error ". can not be used as LabelButton."
	return $w
    }
    if { ![ winfo exists $w]} {
	error "LabelButton $w does not exist."
	return $w
    }
    array set opciones $args

    # opciones a interceptar:
    # -command - un label no tiene command, asi que...
    foreach opc [ list -state -command] {
	if { ![ info exists opciones($opc)]} {
	    if { [ info exists ::LabelButtonOpciones($w,$opc)]} {
		set opciones($opc) $::LabelButtonOpciones($w,$opc)
	    } else {
		set opciones($opc) ""
	    }
	}
	set ::LabelButtonOpciones($w,$opc) $opciones($opc)
    }
    unset opciones(-command)
    if { $::LabelButtonOpciones($w,-state) == "" } {
	set opciones(-state) normal
	set ::LabelButtonOpciones($w,-state) normal
    }
    set restoOpciones [ array get opciones]

    eval ${w}_original configure $restoOpciones
}

proc LabelButton_cget { w args} {
    if { $w == "."} {
	error ". can not be used as LabelButton."
	return $w
    }
    if { ![ winfo exists $w]} {
	error "LabelButton $w does not exist."
	return $w
    }

    # opciones a interceptar:
    # -state
    # -command - un label no tiene command, asi que...
    set cuantos [ llength $args]
    set ret {}
    if { $cuantos == 0} {
	# todos
	set ret [ ${w}_original cget]
	foreach opc [ list -state -command] {
	    if { [ info exists ::LabelButtonOpciones($w,$opc)]} {
		lappend ret [ list $opc $::LabelButtonOpciones($w,$opc)]
	    }
	}
    } else {
	# solo hacemos caso al primero
	set opc [ lindex $args 0]
	if { [ info exists ::LabelButtonOpciones($w,$opc)]} {
	    set ret [ list $opc $::LabelButtonOpciones($w,$opc)]
	} else {
	    set ret [ ${w}_original cget $opc]
	}
    }

    return $ret
}

proc LabelButton { w args} {
    if { $w == "."} {
	error ". can not be used as Colorbutton."
	return $w
    }
    array set opciones $args

    # opciones a interceptar:
    # -state - necesito la definicion, pues lo uso
    # -command - un label no tiene command, asi que...
    foreach opc [ list -state -command] {
	if { ![ info exists opciones($opc)]} {
	    set opciones($opc) ""
	}
	set ::LabelButtonOpciones($w,$opc) $opciones($opc)
    }
    unset opciones(-command)
    if { $::LabelButtonOpciones($w,-state) == "" } {
	set opciones(-state) normal
	set ::LabelButtonOpciones($w,-state) normal
    }
    set restoOpciones [ array get opciones]

    # set ::LabelButtonOpciones($w,ListaEtiquetas) $lst_lbl
    # set ::LabelButtonOpciones($w,ListaValores) $lst_val

    label $w

    bind $w <1> [ list LabelButtonExecuteCommand $w]

    eval $w configure $restoOpciones

    # set class LabelButton
    #
    # rename ${w} ${w}_original
    # proc ::$w { cmd args } \
    #         [subst {return \[eval \[linsert \$args 0 ${class}_\$cmd [list $w]\]\]}]
    #
    # bind $w <Destroy> [ list LabelButton_destroy $w]

    defineWidget LabelButton $w

    return $w
}

#returns the window name
proc CreateApplyCloseDecorationWindow { window top_frame but_frame apply_cmd close_cmd} {
    set def_back [ $window cget -background]
    set realzado [ CCColorActivo $def_back]
    
    frame $top_frame -relief ridge -bd 2

    # bottom part: botones ok, cancel ..
    set def_back [ $window cget -background]

    # marco de los botones
    frame $but_frame -bd 0 -background $realzado

    button $but_frame.apply -text [_ "Apply"] -command "$apply_cmd" -takefocus 0 -bd 1 -padx 8 -pady 3
    button $but_frame.close -text [_ "Close"] -command "$close_cmd" -takefocus 0 -bd 1 -padx 8 -pady 3

    SetWidgetsWidthFromText $but_frame.apply $but_frame.close

    grid $but_frame.apply -sticky ews -padx 4 -pady 10
    grid $but_frame.close -sticky ews -padx 4 -pady 10 -row 0 -column 1

    #enpaquetamos marcos
    grid $top_frame -sticky news -padx 0 -pady 0
    grid $but_frame -sticky wes
    if { $::tcl_version >= 8.5 } { grid anchor $but_frame center }

    grid columnconfigure $window 0 -weight 1
    grid rowconfigure $window 0 -weight 1

    focus $but_frame.apply
    bind $window <Return> "+$but_frame.apply configure -relief sunken; \
	    update; \
	    $but_frame.apply invoke; \
	    $but_frame.apply configure -relief raised"
    bind $window <Escape> "focus $but_frame.close; \
	    $but_frame.close configure -relief sunken; \
	    $but_frame.close invoke"
    return $window
}

proc _CDW_launch_binding { bt} {
    $bt configure -relief sunken
    update
    $bt invoke
    if { [ winfo exists $bt]} { 
	$bt configure -relief raised
    }
}

proc CreateDecorationWindow { window top_frame but_frame lst_button_labels lst_button_cmds lst_button_keys} {
    set def_back [ $window cget -background]
    set realzado [ CCColorActivo $def_back]
    
    frame $top_frame -relief ridge -bd 2

    # bottom part: botones ok, cancel ..
    set def_back [ $window cget -background]

    # marco de los botones
    frame $but_frame -bd 0 -background $realzado

    set num_but 0
    foreach lbl $lst_button_labels cmd $lst_button_cmds key $lst_button_keys {
	set bt $but_frame.but$num_but
	button $bt -text $lbl -command "$cmd" -takefocus 0 -bd 1 -padx 8 -pady 3
	SetWidgetsWidthFromText $bt
	grid $bt -sticky ews -padx 4 -pady 10 -row 0 -column $num_but
	if { "$key" != ""} {
	    bind $window $key "+_CDW_launch_binding $bt"
	}
	incr num_but
    }
    
    #enpaquetamos marcos
    grid $top_frame -sticky news -padx 0 -pady 0
    grid $but_frame -sticky wes
    if { $::tcl_version >= 8.5 } { grid anchor $but_frame center }
    
    grid columnconfigure $window 0 -weight 1
    grid rowconfigure $window 0 -weight 1
    
    focus $but_frame.but0
    return $window
}

proc WarnWinTk { msg { parent "."}} {
    tk_messageBox -title [_ "Warning"] -type ok \
	-icon warning -parent $parent \
	-message $msg 
}

