
proc ChangeFont { font label name1 name2 op } {
    global ChangeVarInfo
    catch {
	$label conf -font [list $ChangeVarInfo($font,family) \
		$ChangeVarInfo($font,size) $ChangeVarInfo($font,weight) \
		$ChangeVarInfo($font,slant)]
    }
}

proc pref_pgf_fonts_ui { frm lbl_frm ini_row} {
    global ChangeVarInfo

    set lst_fnts "PGF_DefaultFont PGF_AxisFont PGF_LegendFont PGF_LabelFont PGF_AsianFont PGF_TkDrawOGLFont"
    set lst_fnts_txt [ list [_ "Default Font"] [_ "Axis Font"] [_ "Legend Font"] [_ "Label Font"] [_ "Asian Font"] [_ "TkDrawOGL Font"]]

    set modo_empaquetamiento 2
    if { $modo_empaquetamiento == 1} {
	ttk::label $frm.l$ini_row -text $lbl_frm
	grid $frm.l$ini_row -sticky w
	set idx [ expr $ini_row + 1]
	foreach ifont $lst_fnts if_txt $lst_fnts_txt {
	    ttk::labelframe $frm.lf$ifont -text $if_txt
	    # label $frm.lf$ifont.l -textvariable ::ChangeVarInfo($ifont,texto)
	    # button $frm.lf$ifont.b -text [_ "Change"] -command "ChangePGFFont %ifont $frm.lf$ifont.l"
	    # ComboBox $frm.lf$ifont.cb -textvariable ::ChangeVarInfo($ifont,texto) -values {} -bd 1
	    TTKComboBox $frm.lf$ifont.cb -textvariable ::ChangeVarInfo($ifont,texto) -state readonly
	    set ::ChangeVarInfo($ifont,combobox) $frm.lf$ifont.cb
	    UpDownEntry $frm.lf$ifont.ud -variable ::ChangeVarInfo($ifont,tamanno) \
		-increment 1 -from 5 -to 80 \
		-entry-options "-relief sunken -width 3" \
		-button-options "-bd 1" \
		-up-color red -down-color blue
	
	    #grid $frm.lf$ifont.l $frm.lf$ifont.b $frm.lf$ifont.ud -sticky e
	
	    grid $frm.lf$ifont.cb $frm.lf$ifont.ud -sticky e -padx 2
	    grid configure $frm.lf$ifont.cb -sticky ew
	    grid columnconfigure $frm.lf$ifont 0 -weight 1
	    grid rowconfigure $frm.lf$ifont 0 -weight 1
	
	    grid $frm.lf$ifont -sticky ewns -padx 2
	
	    grid columnconfigure $frm 0 -weight 1
	    grid rowconfigure $frm $idx -weight 1
	    incr idx
	}

    } elseif { $modo_empaquetamiento == 2} {
	set f [ttk::labelframe $frm.lf$ini_row -text $lbl_frm]
	set idx $ini_row
	foreach ifont $lst_fnts if_txt $lst_fnts_txt {
	    label $f.l$ifont -text ${if_txt}:
	    # ComboBox $f.cb$ifont -textvariable ::ChangeVarInfo($ifont,texto) -values {} -bd 1
	    TTKComboBox $f.cb$ifont -textvariable ::ChangeVarInfo($ifont,texto) -state readonly
	    set ::ChangeVarInfo($ifont,combobox) $f.cb$ifont
	    UpDownEntry $f.ud$ifont -variable ::ChangeVarInfo($ifont,tamanno) \
		-increment 1 -from 5 -to 80 \
		-entry-options "-relief sunken -width 3" \
		-button-options "-bd 1" \
		-up-color red -down-color blue
	
	    grid $f.l$ifont $f.cb$ifont $f.ud$ifont -sticky e -padx 2
	    grid $f.cb$ifont -sticky ew
	    grid rowconfigure $f $idx -weight 1
	    incr idx
	}
	grid columnconfigure $f 1 -weight 1

	# el modo de render
	label $f.rm_l -text [_ "Render mode"]:
	#ComboBox $f.rm_cb -textvariable ::ChangeVarInfo(PGF_ModoRender,texto) -values {} -bd 1
	# ComboBoxGiD $f.rm_cb -keyvariable ::ChangeVarInfo(PGF_ModoRender,texto) -bd 1 \
	#     -values {} -keyvalues {}
	TTKMenubutton $f.rm_cb -textvariable ::ChangeVarInfo(PGF_ModoRender,texto)
	set ::ChangeVarInfo(PGF_ModoRender,combobox) $f.rm_cb
	grid $f.rm_l $f.rm_cb -sticky e -padx 2
	grid $f.rm_cb -sticky w
	grid rowconfigure $f $idx -weight 1

	grid $f -sticky news -padx 2
    }
}

proc pref_tcl_tk_fonts_ui { frm lbl_frm ini_row fontnames fontlabels fonthelp} {
    global ChangeVarInfo

    set frm1 [ttk::labelframe $frm.l$ini_row -text $lbl_frm]

    set irow [ expr $ini_row + 1]
    foreach i $fontnames lname $fontlabels help_txt $fonthelp {
	set fw [string tolower $i]
	set frm2 [ttk::frame $frm.f1$fw -borderwidth 2 -relief groove]

	label $frm2.l1$fw -text $lname
	
	set def_fnt [ font actual [ $frm2.l1$fw cget -font]]
	set def_back [ CCGetRGB $frm2.l1$fw [ $frm2.l1$fw cget -background]]
	
	#combobox $frm2.cb1$fw -textvariable ChangeVarInfo($i,family)
	# ComboBox $frm2.cb1$fw -editable 0 -textvariable ChangeVarInfo($i,family)
	TTKComboBox $frm2.cb1$fw -textvariable ::ChangeVarInfo($i,family) -state readonly
	set ChangeVarInfo($i,combo) $frm2.cb1$fw

	if { $i != "AsianFont"} {
	    #combobox $frm2.cb2$fw -textvariable ChangeVarInfo($i,size) -width 3
	    # ComboBox $frm2.cb2$fw -editable 0 -textvariable ChangeVarInfo($i,size) -width 3
	    # TTKMenubutton $frm2.cb2$fw -textvariable ::ChangeVarInfo($i,size) -width 3
	    TTKComboBox $frm2.cb2$fw -textvariable ::ChangeVarInfo($i,size) -width 3 -state readonly

	    set values {4 5 6 7 8 9 10 11 12 13 14 16 18 20 22 24 26 28 36 48 72}
	    $frm2.cb2$fw configure -values $values
	    # TTKMenubuttonConfigure $frm2.cb2$fw -values $values
	    #TTKComboBoxConfigure $frm2.cb2$fw -values $values
	
	    if { [ lsearch [ font names] Weight_$i] == -1} {
		font create Weight_$i
	    }
	    eval [ concat font conf Weight_$i $def_fnt]
	    SwitchButton $frm2.mb1$fw \
		"global ChangeVarInfo; set ChangeVarInfo($i,weight) bold;   font conf Weight_$i -weight bold" \
		"global ChangeVarInfo; set ChangeVarInfo($i,weight) normal; font conf Weight_$i -weight normal" \
		-text B -bd 1 -width 1 -padx 2 -font Weight_$i -activebackground [ CCColorActivo $def_back]
	
	    if { [ lsearch [ font names] Slant_$i] == -1} {
		font create Slant_$i
	    }
	    eval [ concat font conf Slant_$i $def_fnt]
	    SwitchButton $frm2.mb2$fw \
		"global ChangeVarInfo; set ChangeVarInfo($i,slant) italic; font conf Slant_$i -slant italic" \
		"global ChangeVarInfo; set ChangeVarInfo($i,slant) roman;  font conf Slant_$i -slant roman" \
		-text I -bd 1 -width 1 -padx 2 -font Slant_$i -activebackground [ CCColorActivo $def_back]
	
	    foreach j "family size weight slant" {
		trace add variable ChangeVarInfo($i,$j) write "ChangeFont $i $frm2.l1$fw"
	    }
	}

	grid $frm2.l1$fw -sticky nsew
	grid $frm2.cb1$fw -row 1 -column 0 -sticky we -padx 2

	if { $i != "AsianFont"} {
	    grid $frm2.cb2$fw -row 1 -column 1 -sticky w -padx 2
	    grid $frm2.mb1$fw -row 1 -column 2 -sticky w -padx 2
	    grid $frm2.mb2$fw -row 1 -column 3 -sticky w -padx 2
	}
	grid rowconfigure $frm2 0 -weight 1 -minsize 35
	grid rowconfigure $frm2 1 -weight 1
	grid columnconfigure $frm2 0 -weight 1
	
	grid $frm2 -in $frm1 -sticky ew -padx 2
	grid rowconfigure $frm $irow -weight 1 -minsize 2
	incr irow

	GidHelp "$frm2 [grid slaves $frm2]" $help_txt
    }
    grid $frm1 -sticky nsew
    grid columnconfigure $frm1 0 -weight 1
    grid columnconfigure $frm 0 -weight 1 -minsize 200
}

proc pref_fonts_ui {w args} {
    global ChangeVarInfo

    set modo [GiD_Info Project ViewMode]
    set esPost 0
    if { ( $modo eq "POSTUSE") || ( $modo eq "GRAFUSE")} {
	set esPost 1
    }

    ttk::frame $w.f

    #dos partes: User interface fonts y graphical fonts
    #User Interface fonts:
    set fontnames "NormalFont FixedFont BigFont"
    set fontlabels [list [_ "Normal Font"] [_ "Fixed Font"] [_ "Big Font"]]
    set fonthelp [ list \
		       [_ "This is the font normally used inside GiD."] \
		       [_ "This font must have the same spacing for every letter. It is used in places where this property is necessary."] \
		       [_ "This font is used in some dialog boxes."]]

    pref_tcl_tk_fonts_ui $w.f [_ "User interface fonts"]: 0 $fontnames $fontlabels $fonthelp

    if { $esPost} {
	pref_pgf_fonts_ui $w.f [_ "Graphical fonts"]: 3
    } else {
	# Graphical fonts
	set fontnames "CommentsFont LabelsFont AsianFont"
	set fontlabels [list [_ "Comments / Legend Font"] [_ "Labels / Dimensions Font"] [_ "Asian Font"]]
	set fonthelp [ list \
		           [_ "This font is used to draw Comments on the graphic window."] \
		           [_ "This font is used to draw Labels and Dimensions on the graphic window."] \
		           [_ "This font is used to draw asian characters in the graphical window."]]
	
	pref_tcl_tk_fonts_ui $w.f [_ "Graphical fonts"]: 3 $fontnames $fontlabels $fonthelp
    }

    grid $w.f -sticky news
    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1
    grid rowconfigure $w 1 -weight 1

    # additional interface code
    # end additional interface code

}
